2003-08-26  Dan Nicolaescu  <dann@ics.uci.edu>

	* parser.c (struct cp_token): Use enum bitfields.
	(CP_TOKEN_BLOCK_NUM_TOKENS): Make sure cp_token_block fits in a
	512B allocation unit.
	(cp_parser_token_tree_map_node): Use enum bitfields.

2003-08-26  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11871
	* decl.c (push_class_level_binding): Correct old_decl value from
	my 2003-07-29 reorganization.

	* call.c (build_call): Don't set TREE_SIDE_EFFECTS here.
	(build_new_method_call): Add goto finish.
	* semantics.c (simplify_aggr_init_exprs_r): Don't set
	TREE_SIDE_EFFECTS on a call.

2003-08-25  Richard Henderson  <rth@redhat.com>

	* cxx-pretty-print.c (pp_cxx_class_name): Remove unused function.

2003-08-25  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cxx-pretty-print.h (pp_cxx_flag_default_argument): New flag.
	(cxx_pretty_printer): Adjust base type.
	(pp_cxx_function_specifier): Declare.
	* cxx-pretty-print.c (pp_cxx_whitespace): New macro.
	(pp_cxx_left_paren): Likewise.
	(pp_cxx_right_paren): Likewise.
	(pp_cxx_dot): Likewise.
	(pp_cxx_arrow): Likewise.
	(pp_cxx_semicolon): Likewise.
	(pp_cxx_identifier): Likewise.
	(pp_cxx_cv_qualifier_seq): Likewise.
	(pp_cxx_storage_class_specifier): Likewise.
	(pp_cxx_expression_list): Likewise.
	(pp_cxx_space_for_pointer_operator): Likewise.
	(pp_cxx_init_declarator): Likewise.
	(pp_cxx_call_argument_list): Likewise.
	(pp_cxx_nonconsecutive_character): Tidy.
	(pp_cxx_conversion_function_id): New function.
	(pp_cxx_template_id): Likewise.
	(pp_cxx_template_keyword_if_needed): Likewise.
	(pp_cxx_nested_name_specifier): Likewise.
	(pp_cxx_unqualified_id): Tidy
	(pp_cxx_qualified_id): Handle more nodes.
	(pp_cxx_primary_expression): Tidy.
	(pp_cxx_postfix_expression): Likewise.
	(pp_cxx_new_expression): Tidy.
	(pp_cxx_delete_expression): Likewise.
	(pp_cxx_cast_expression): New function.
	(pp_cxx_pm_expression): Tidy.
	(pp_cxx_conditional_expression): Likewise.
	(pp_cxx_assignment_operator): New function.
	(pp_cxx_assignment_expression): Tidy.
	(pp_cxx_expression): New function.
	(pp_cxx_function_specifier): Likewise.
	(pp_cxx_decl_specifier_seq): Likewise.
	(pp_cxx_simple_type_specifier): Tidy.
	(pp_cxx_type_specifier_seq): Likewise.
	(pp_cxx_ptr_operator): New function.
	(pp_cxx_implicit_parameter_type): Likewise.
	(pp_cxx_parameter_declaration): Tidy.
	(pp_cxx_parameter_declaration_clause): New function.
	(pp_cxx_exception_specification): Likewise.
	(pp_cxx_direct_declarator): Tidy.
	(pp_cxx_declarator): Likewise.
	(pp_cxx_ctor_initializer): New function.
	(pp_cxx_function_definition): Likewise.
	(pp_cxx_abstract_declarator): Tidy.
	(pp_cxx_direct_abstract_declarator): Likewise.
	(pp_cxx_type_id): Likewise.
	(pp_cxx_exception_declaration): New function.
	(pp_cxx_statement): Likewise.
	(pp_cxx_simple_declaration): Likewise.
	(pp_cxx_template_parameter_list): Likewise.
	(pp_cxx_template_parameter): Likewise.
	(pp_cxx_template_declaration): Likewise.
	(pp_cxx_explicit_specialization): Likewise.
	(pp_cxx_explicit_instantiation): Likewise.
	(pp_cxx_declaration): Tidy.
	(pp_cxx_pretty_printer_init): Initialize more fields.

2003-08-25  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8795
	* cp-tree.h (build_cplus_method_type): Remove.
	* call.c (standard_conversion): Use build_method_type_directly
	instead of build_cplus_method_type.
	* class.c (build_clone): Likewise.
	(adjust_clone_args): Likewise.
	* decl.c (build_ptrmem_type): Likewise.
	(grokdeclarator): Likewise.
	(check_function_type): Likewise.
	* decl2.c (grok_method_quals): Likewise.
	(maybe_retrofit_in_chrg): Likewise.
	* pt.c (copy_default_args_to_explicit_spec): Likewise.
	(tsubst_function_type): Likewise.
	(tsubst): Likewise.
	* tree.c (build_cplus_method_type): Remove.
	* typeck.c (merge_types): Use build_method_type_directly.

2003-08-23  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/3765
	* search.c (dfs_access_in_type): Fix typo in comment.
	(dfs_accessible_queue_p): Likewise.
	(dfs_accessible_p): Only terminate when a friend is found.
	(accessible_p): Return immediately if access_in_type allows
	access.

2003-08-23  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/641, c++/11876
	* friend.c (add_friend): Add complain parameter.
	(make_friend_class): Likewise.
	(do_friend): Adjust add_friend call.
	* decl.c (grokdeclarator): Adjust make_friend_class call.
	* parser.c (cp_parser_member_declaration): Likewise.
	(cp_parser_template_declaration_after_exp): Likewise.
	* pt.c (instantiate_class_template): Adjust make_friend_class
	and add_friend call.
	* cp-tree.h (make_friend_class): Adjust declaration.
	(add_friend): Likewise.

2003-08-21  Jason Merrill  <jason@redhat.com>

	PR c++/11283
	* call.c (build_conditional_expr): Ignore cv-qual differences for
	non-class types.

2003-08-21  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11551
	* parser.c (cp_parser_id_expression): Add declarator_p parameter.
	(cp_parser_primary_expression): Adjust call to
	cp_parser_id_expression.
	(cp_parser_unqualified_id): Complain about the use of
	typedef-names in a destructor declarator.
	(cp_parser_postfix_expression): Adjust call to
	cp_parser_id_expression.
	(cp_parser_type_parameter): Likewise.
	(cp_parser_template_argument): Likewise.
	(cp_parser_declarator_id): Likewise.

	PR c++/11919
	* call.c (standard_conversion): Use same_type_p, not pointer
	equality, to compare types.

	PR c++/10762
	* parser.c (cp_parser_using_declaration): Check for invalid uses
	of template-ids here...
	* decl2.c (do_class_using_decl): ... rather than here.

2003-08-20  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11834
	* pt.c (more_specialized): Bump processing_template_decl.

2003-08-21  Jason Merrill  <jason@redhat.com>

	PR c++/11614
	* decl.c (grokdeclarator): Recognize a flexible array based on the
	type, not the form of the declarator.

2003-08-20  Jason Merrill  <jason@redhat.com>

	* semantics.c (simplify_aggr_init_expr): Split out from
	simplify_aggr_init_exprs_r.  Convert slot address to match
	the return type.
	* cp-tree.h: Declare it.
	* tree.c (cp_copy_res_decl_for_inlining): Don't clobber the
	DECL_NAME of a user variable.

2003-08-20  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11945
	* pt.c (build_non_dependent_expr): Look inside COND_EXPR and
	COMPOUND_EXPR.
	* semantics.c (finish_expr_stmt): Always convert to void.
	* typeck.c (build_x_compound_exp): Always convert to void.

2003-08-19  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11684
	* cp-tree.h (grok_op_properties): Change prototype.
	* decl.c (grok_op_properties): Add complain parameter.
	(grokfndecl): Pass it.
	* pt.c (tsubst_decl): Adjust accordingly.

	PR c++/10926
	* decl.c (start_method): Return immediately if push_template_decl
	does not like the declaration.
	* pt.c (push_template_decl_real): Disallow member template
	destructors.

	PR c++/11036
	* cp-tree.h (add_binding): Add prototype.
	* class.c (add_method): Set TYPE_HAS_DESTRUCTOR if appropriate.
	(maybe_warn_about_overly_private_class): Use
	CLASSTYPE_DESTRUCTORS.
	(pushclass): Adjust call to set_identifier_type_value.
	* decl.c (add_binding): Give it external linkage.
	(push_local_binding): Adjust call to add_binding.
	(push_class_binding): Likewise.
	(set_identifier_type_value_with_scope): Change prototype.  Use
	add_binding for global bindings.
	(set_identifier_type_value): Adjust accordingly.
	(pushtag): Likewise.
	(pushdecl): Use set_identifier_type_value, not
	set_identifier_type_value_with_scope.
	(pushdecl_namespace_level): Adjust calls to
	SET_IDENTIFIER_TYPE_VALUE to pass a DECL.
	(pushdecl_class_level): Likewise.
	(lookup_tag): Use select_decl.
	(select_decl): Improve comment.
	(record_builtin_type): Do not call pushdecl.
	(cxx_init_decl_processing): Do not call xref_tag for bad_alloc.
	(cp_finish_decl): Adjust call to set_identifier_type_value.
	(check_elaborated_type_specifier): Improve checks for invalid uses
	of typedefs.
	(xref_tag): Adjust call to check_elaborated_type_specifier.
	* decl2.c (grokclassfn): Do not set TYPE_HAS_DESTRUCTOR.
	* name-lookup.c (set_namespace_binding): Use add_binding.
	* parser.c (cp_parser_simple_type_specifier): Return a TYPE_DECL,
	rather than an IDENTIFIER_NODE, to represent built-in types, if
	requested by the caller.
	(cp_parser_postfix_expression): Adjust call.
	(cp_parser_type_specifier): Likewise.
	(cp_parser_elaborated_type_specifier): Adjust call to
	check_elaborated_type_specifier.
	* typeck2.c (build_functional_cast): Do not perform name lookups.

	PR c++/10717
	* decl.c (expand_static_init): Remove unncessary code.

2003-08-19  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c++/10538, PR c/5582
	* cp/cp-lang.c (LANG_HOOKS_DECL_UNINIT): Define.

2003-08-19  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/11174
	* init.c (build_offset_ref): Perform access checking for
	pointer to member correctly.

2003-08-19  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cp-lang.c (LANG_HOOKS_INITIALIZE_DIAGNOSTICS): Fix spelling.

2003-08-18  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11957
	* cp-tree.h (finish_stmt_expr): Add bool parameter.
	* init.c (finish_init_stmts): Pass true to finish_stmt_expr. Don't
	adjust the stmt_expr here.
	(build_vec_init): Use finish_stmt_expr_expr, convert result to
	array type.
	* parser.c (cp_parser_primar_expression): Adjust finish_stmt_expr
	call.
	* pt.c (tsubst_copy): Likewise.
	* semantics.c (finish_stmt_expr): Add parameter.

	* pt.c (instantiate_class_template): Push to class's scope before
	tsubsting base.

Sun Aug 17 10:05:38 CEST 2003  Jan Hubicka  <jh@suse.cz>

	PR C++/11702
	* semantics.c (finish_id_expression): Mark all functions as used.

2003-08-16  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11512
	* cvt.c (convert_to_void): Indicate which side of conditional has
	no effects, and rhs of comma operator. Test for no sideeffect
	expressions here and always build a convert expr.
	* init.c (expand_default_init): Convert the init to void.
	* typeck.c (build_x_compound_expr): Do not check for side effects
	here.
	(build_compound_expr): Do not convert lhs when building a
	template.

2003-08-15  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.def (NON_DEPENDENT_EXPR): Add operand.
	* decl2.c (build_offset_ref_call_from_tree): Use
	build_non_dependent_expr.
	* error.c (dump_expr) <NON_DEPENDENT_EXPR case>: Dump the operand.
	* pt.c (build_non_dependent_expr): Set operand.

2003-08-14  Jan Hubicka  <jh@suse.cz>

	* decl2.c (mark_member_pointers): Rename to...
	(mark_member_pointers_and_eh_tinfos): ... this one; deal with eh tinfos
	(lower_function): Update call.
	* except.c (eh_type_info): Break out from ...
	(build_eh_type): ... here; tinfo is already used.
	(finish_eh_spec_block): Mark tinfos as used.
	* semantics.c (finish_handler_params): Mark tinfo as used.
	* cp-tree.h (eh_type_info): Declare.

2003-08-15  Nathan Sidwell  <nathan@codesourcery.com>

	* pt.c (instantiate_class_template): Set location before
	substuting bases.

	* decl.c (make_typename_type): Use my_friendly_assert.
	* pt.c (tsubst_aggr_type): Rearrange context substitution.

Thu Aug 14 12:19:25 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* method.c (use_thunk): Expand body directly.

2003-08-12  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11703
	* call.c (type_passed_as): Use TYPE_SIZE, not TYPE_PRECISION to
	determine whether or not to promote types.
	(convert_for_arg_passing): Likewise.
	* decl2.c (cp_build_parm_decl): Do not set DECL_ARG_TYPE in
	templates.
	* pt.c (tsubst_decl): Do not expect it to be set.

	PR c++/9512
	PR c++/10923
	* cp-tree.h (check_elaborated_type_specifier): Declare.
	(handle_class_head): Remove.
	(note_got_semicolon): Likewise.
	(note_list_got_semicolon): Likewise.
	(finish_class_definition): Likewise.
	* decl.c (check_elaborated_type_specifier): Make it public.
	Robustify.
	(handle_class_head): Remove.
	* parser.c (cp_parser_elaborated_type_specifier): Use
	check_elaborated_type_specifier.
	(cp_parser_class_specifier): Do not call finish_class_definition.
	(cp_parser_class_head): Or handle_class_head.  Check for
	over-qualified names.
	* semantics.c (finish_class_definition): Remove.

	* parser.c (cp_parser_check_for_definition_in_return_type): New
	function.
	(cp_parser_simple_declaration): Adjust call to
	cp_parser_init_declarator.
	(cp_parser_decl_specifier_seq): Change type of
	declares_class_or_enum parameter.
	(cp_parser_explicit_instantiation): Adjust accordingly.
	(cp_parser_type_specifier): Change type of
	declares_class_or_enum parameter.
	(cp_parser_init_declarator): Add declares_class_or_enum
	parameter.
	(cp_parser_parameter_declaration): Adjust call to
	cp_parser_decl_specifier_seq.
	(cp_parser_function_definition): Likewise.
	(cp_parser_member_declaration): Likewise.
	(cp_parser_single_declaration): Likewise.

	* cp-tree.h (lang_type_class): Remove has_call_overloaded,
	has_array_ref_overloaded, has_arrow_overloaded, and got_semicolon.
	(TYPE_OVERLOADS_CALL_EXPR): Remove.
	(TYPE_OVERLOADS_ARRAY_REF): Likewise.
	(TYPE_OVERLOADS_ARROW): Likewise.
	(CLASSTYPE_GOT_SEMICOLON): Likewise.
	* class.c (check_bases): Do not set them.
	(finish_struct_1): Likewise.
	* decl.c (cp_finish_decl): Do not set CLASSTYPE_GOT_SEMICOLON.
	(build_ptrmemfunc_type): Likewise.
	(grok_op_properties): Do not set TYPE_OVERLOADS_*.
	(start_function): Do not check CLASSTYPE_GOT_SEMICOLON.
	* decl2.c (grokfield): Do not set CLASSTYPE_GOT_SEMICOLON.
	* lex.c (note_got_semicolon): Remove.
	(note_list_got_semicolon): Likewise.
	* parser.c (cp_parser_simple_declaration): Do not call
	note_list_got_semicolon.
	* pt.c (list_eq): Remove.
	(lookup_template_class): Do not set CLASSTYPE_GOT_SEMICOLON.
	(instantiate_class_template): Do not set TYPE_OVERLOADS*.
	(instantiate_class_template): Do not set CLASSTYPE_GOT_SEMICOLON.
	* ptree.c (cxx_print_type): Do not print them.
	* semantics.c (finish_member_class_template): Do not call
	note_list_got_semicolon.

2003-08-11  Aldy Hernandez  <aldyh@redhat.com>

	* call.c (standard_conversion): Opaque pointers interconvert.

	* testsuite/g++.dg/other/opaque-3.C: New.

2003-08-11  Mark Mitchell  <mark@codesourcery.com>

	* typeck.c (merge_types): Handle cv-qualified pointer-to-member
	types correctly.

2003-08-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11789
	* cp-tree.h (get_vbase): Remove.
	(get_vbase_types): Remove.
	* init.c (expand_member_init): Correct logic for looking up base
	classes.

2003-08-10  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* error.c (dump_expr): Tidy.
	* cxx-pretty-print.c (pp_cxx_nonconsecutive_character): New.
	(pp_cxx_begin_template_argument_list): Likewise.
	(pp_cxx_end_template_argument_list): Likewise.
	(is_destructor_name): Likewise.
	(pp_cxx_unqualified_id): Likewise.
	(pp_cxx_qualified_id): Likewise.
	(pp_cxx_id_expression): Likewise.
	(pp_cxx_new_expression): Likewise.
	(pp_cxx_delete_expression): Likewise.
	(pp_cxx_pm_expression): Likewise.
	(pp_cxx_type_specifier): Rework.
	(pp_cxx_type_id): Likewise.
	(pp_cxx_primary_expression): Likewise.
	(pp_cxx_postfix_expression): Likewise.
	(pp_cxx_unary_expression): Likewise.
	(pp_cxx_multiplicative_expression): Likewise.
	(pp_cxx_conditional_expression): Likewise.
	(pp_cxx_assignment_expression): Likewise.
	(pp_cxx_pretty_printer_init): Tidy.

2003-08-10  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (TMPL_ARGS_HAVE_MULTIPLE_LEVELS): non-NULL
	NODE is always a TREE_VEC of non-zero size.
	(NUM_TMPL_ARGS): NODE is always a TREE_VEC.
	* decl2.c (arg_assoc): Template args will be a vec.
	* error.c (dump_decl) <TEMPLATE_ID_EXPR case>: Call
	dump_template_argument_list.
	(dump_template_parms): Args will be a vec.
	* parser.c (cp_parser_template_argument_list): Produce a
	vector, not a list.
	* pt.c (coerce_template_parms): Args are always vectors.
	(mangle_class_name_for_template): Likewise.
	(lookup_template_function): Likewise.
	(lookup_template_class): Likewise.
	(tsubst_template_args): Likewise.
	(tsubst_baselink): Use tsubst_template_args.
	(tsubst_qualified_id): Likewise.
	(tsubst_copy) <TEMPLATE_ID_EXPR case>: Likewise.
	(tsubst_copy_and_build) <TEMPLATE_ID_EXPR case>: Likewise.
	(any_dependent_template_args_p):  Args are always vectors.
	* tree.c (cp_tree_equal): Add TEMPLATE_ID_EXPR case.

	PR c++/11670
	* call.c (convert_like_real): Add rvalue binding error message.
	* error.c (dump_expr) <NOP_EXPR case>: Detect when the no expr is
	really a cast.

	PR c++/10530
	* pt.c (dependent_type_p_r): A dependent template-id is a class
	type with dependent template arguments, or a bound template
	template parameter.
	(type_dependent_expression_p): A template function decl cannot
	have a dependent context.

2003-08-07  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/5767
	* parser.c (cp_parser_class_name): Return immediately when scope
	is error_mark_node.

2003-08-07  Aldy Hernandez  <aldyh@redhat.com>

	* cp/Make-lang.in (cp/call.o): Add dependency for target.h.

	* cp/call.c (standard_conversion): Support opaque types.
	Include target.h.
	(strip_top_quals): Use cp_build_qualified_type instead of
	TYPE_MAIN_VARIANT.

	* cp/typeck.c (convert_for_assignment): Support opaque types.

	* testsuite/g++.dg/other/opaque-1.C: New.

	* testsuite/g++.dg/other/opaque-2.C: New.

2003-08-06  Aldy Hernandez  <aldyh@redhat.com>

	* decl.c (grokparms): Use cp_build_qualified_type instead
	TYPE_MAIN_VARIANT.

2003-08-05  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cxx-pretty-print.h: New file.
	* cxx-pretty-print.c: Likewise.
	* error.c (scratch_pretty_printer): Change type.
	(init_error): Tidy.
	(dump_aggr_type): Likewise.
	(dump_global_iord): Likewise.
	(dump_expr): Likewise.
	(dump_char): Remove.
	* cp-lang.c (LANG_HOOKS_INITIALIZE_DIAGNOSTITCS): Define.
	(cxx_initialize_diagnostics): New function.
	* Make-lang.in (CXX_OBJS): Add cp/cxx-pretty-print.o
	(CXX_PRETTY_PRINT_H): New variable.
	(cp/cxx-pretty-print.o): New rule.
	(cp/cp-lang.o): Update dependence.
	(cp/error.o): Likewise.

2003-08-05  Steven Bosscher  <steven@gcc.gnu.org>

	* cp-tree.h (struct lang_decl): Don't include c_lang_decl.
	(DECL_DECLARED_INLINE_P): Remove.
	* decl2.c (import_export_decl): Only look at DECL_DECLARED_INLINE_P
	if decl is a FUNCTION_DECL.  This never made sense, but now it is
	required to avoid a tree check failure.
	* decl.c (grokfndecl): Don't touch DID_INLINE_FUNC.
	* optimize.c (maybe_clone_body): Likewise.

2003-08-04  Roger Sayle  <roger@eyesopen.com>

	* decl.c (cxx_insert_default_attributes): Delete.
	* cp-tree.h (cxx_insert_default_attributes): Don't prototype.
	* cp-lang.c (LANG_HOOKS_INSERT_DEFAULT_ATTRIBUTES): Don't define.

2003-08-03  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11704
	* pt.c (type_dependent_expression_p): Cope with COMPONENT_REF with
	unknown type.

	PR c++/11766
	* typeck.c (comp_ptr_ttypes_real): Don't loop on pointers to
	member functions.

2003-08-02  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9447
	* cp-tree.def (USING_DECL): Document its type.
	* class.c (pushclass): If we're entering a template, push any
	dependent using decls it has.
	* decl2.c (do_class_using_decl): Refactor. Type is NULL iff it is
	a dependent scope.
	* pt.c (tsubst_decl) <USING_DECL case>: Set type.
	(tsubst): Remove USING_DECL checks.
	(type_dependent_expression_p): Remove USING_DECL case.
	* semantics.c (finish_member_declaration): A USING_DECL's type
	indicates whether it is dependent.

2003-08-02  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (pushclass): Remove unneeded parameter.
	* class.c (pushclass): Remove unneeded MODIFY parm. Adjust.
	(push_nested_class): Adjust pushclass call.
	* pt.c (instantiate_class_template): Likewise.
	* semantics.c (begin_class_definition): Likewise.

2003-08-01  Nathanael Nerode  <neroden@gcc.gnu.org>

	* typeck2.c (add_exception_specifier): Use 'bool' where appropriate.

2003-08-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11697
	* decl.c (decls_match): Don't ignore the types of template
	classes.

	PR c++/11744
	* pt.c (tsubst_copy_and_build): Refine Koenig lookup logic.

2003-08-01  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8442, c++/8806
	* decl.c (qualify_lookup): Accept TEMPLATE_DECL if types are
	preferred.
	(check_elaborated_type_specifier): Add allow_template_p
	parameter.  Check tag mismatch and class template.
	(xref_tag): Add template_header_p parameter.  Add assertion
	that name is an IDENTIFIER_NODE.  Remove implicit typename
	warning.  Simplify lookup process if globalize is true.
	(cxx_init_decl_processing): Adjust call to xref_tag.
	(xref_tag_from_type): Likewise.
	* decl2.c (handle_class_head): Likewise.
	* parser.c (cp_parser_elaborated_type_specifier,
	cp_parser_class_head): Likewise.
	* rtti.c (init_rtti_processing, build_dynamic_cast1,
	tinfo_base_init, emit_support_tinfos): Likewise.
	* class.c (is_base_of_enclosing_class): Remove.
	* pt.c (convert_template_argument): Don't accept RECORD_TYPE as
	template template argument.
	* cp-tree.h (xref_tag): Adjust declaration.
	(is_base_of_enclosing_class): Remove.
	* NEWS: Document template template argument change.

2003-08-01  Nathan Sidwell  <nathan@codesourcery.com>

	* parser.c (cp_parser_init_declarator,
	cp_paser_member_declaration): Reformat.
	* pt.c (lookup_template_class, type_unification_real, unify,
	type_dependent_expression_p): Reformat.

	PR c++/11295
	* cp-tree.h (tubst_flags_t): Add tf_stmt_expr_cmpd,
	tf_stmt_expr_body.
	(finish_stmt_expr_expr): Declare.
	* parser.c (cp_parser_primary_expression): Tell
	cp_parser_compount_statement that it is a statement expression.
	(cp_parser_statement, cp_parser_labeled_statement,
	cp_parser_compound_statement, cp_parser_statement_seq_opt): Add
	in_statement_expr_p parameter.
	(cp_parser_expression_statement): Likewise. Call
	finish_stmt_expr_expr for final expression of a statement
	expression.
	(cp_parser_for_init_statement,
	cp_parser_implicitly_scoped_statement,
	cp_parser_already_scoped_statement, cp_parser_function_definition,
	cp_parser_try_block, cp_parser_handled): Adjust.
	* pt.c (tsubst_copy) <STMT_EXPR case>: Pass tf_stmt_expr.
	(tsubst_expr): Process tf_stmt_expr and tf_stmt_exprs flags.
	(tsubst_expr) <EXPR_STMT case>: Check tf_stmt_exprs flag.
	* semantics.c (finish_expr_stmt): Do not deal with statement
	expressions.
	(begin_stmt_expr): Clear last_expr_type.
	(finish_stmt_expr_expr): New.
	(finish_stmt_expr): Process the value expression.

	* typeck.c (build_compound_expr): If RHS is a TARGET_EXPR, put the
	compound expr inside the target's initializer.

	PR c++/11525
	* parser.c (cp_parser_primary_expression): Do not set
	non-constant-p merely because it is a dependent scope.

	PR c++/9447
	* decl2.c (do_class_using_decl): Set type to NULL_TREE.
	* semantics.c (finish_expr_stmt): Do not convert to void in a
	template.

2003-07-31  Nathan Sidwell  <nathan@codesourcery.com>

	* pt.c (coerce_template_parms): Refactor.
	(fn_type_unification): Increment processing_template_decl when
	tsubsting an incomplete set of explicit args.

	PR c++/11347
	* pt.c (instantiate_class_template): Increment
	processing_template_decl around the tsubst of a template member
	class.
	(tsubst_qualified_id): Assert we do not have a dependent scope.

	* pt.c (coerce_template_template_parms, lookup_template_class,
	can_complete_type_without_circularity, instantiate_class_template,
	tsubst_decl, unify): Reformat.

Thu Jul 31 01:07:41 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* decl2.c (maybe_make_one_only): Use mark_referenced.
	* method.c (use_thunk): Likewsie.

Wed Jul 30 19:12:48 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* class.c (build_vtable_entry_ref): Kill.
	(build_vtbl_ref_1): Do not call build_vtable_entry_ref.
	(build_vfn_ref): Do not call build_vtable_entry_ref.
	* cp-lang.c (LANG_HOOKS_PREPARE_ASSEMBLE_VARIABLE): Kill.
	* cp-tree.h (prepare_assemble_variable): Kill.
	* cp-decl.c (prepare_assemble_variable): Kill.

2003-07-29  Geoffrey Keating  <geoffk@apple.com>

	* parser.c (cp_lexer_new_main): Use c_common_no_more_pch instead
	of setting valid_pch by hand.

2003-07-29  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* decl.c (finish_enum): Initialize underlying_type.

2003-07-29  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9447
	* decl.c (add_binding): Add bval local variable.
	(push_class_level_binding): Likewise. Allow a USING_DECL to be
	pushed.
	* decl2.c (do_class_using_decl):  The type of a using decl is
	unknown.
	* parser.c (cp_parser_postfix_expression): Refactor unqualified-id
	function call lookup code.
	* pt.c (tsubst): A USING_DECL will have unknown type.
	(tsubst_copy_and_build): Allow a using decl.
	(type_dependent_expression_p): A USING_DECL will make it
	dependent.
	* semantics.c (finish_member_declaration): Push a dependent using
	declaration.

2003-07-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11530
	* parser.c (cp_parser_postfix_expression): Do not call mark_used.
	* semantics.c (finish_id_expression): Call mark_used for all
	declarations.

2003-07-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11667
	* call.c (standard_conversion): Allow all integral->enumeral
	conversions, after marking them as bad.
	* decl.c (finish_enum): Make sure that all enumerators are
	properly converted to the underlying type.
	(build_enumerator): Set DECL_CONTEXT for namespace-scope
	enumeration types.
	* pt.c (tsubst_copy): Adjust handling of CONST_DECLs accordingly.
	(tsubst_enum): Tidy.

	* Make-lang.in (typeck.o): Depend on convert.h.
	(class.o): Likewise.
	(rtti.o): Likewise.
	* call.c: Include convert.h.
	(convert_arg_to_ellipsis): Use convert_to_real.
	* class.c: Include convert.h.
	(build_base_path): Use convert_to_integer.
	* rtti.c: Include convert.h.
	(build_headof): Use convert_to_integer.
	* typeck.c: Include convert.h.
	(decay_conversion): Use convert_to_integer.
	(build_unary_op): Use build_nop.
	(get_delta_difference): Use convert_to_integer.
	(build_ptrmemfunc): Avoid unncessary conversions.

Mon Jul 28 23:55:10 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* decl2.c (mark_member_pointers): Verify that member pointer points to
	the function.

2003-07-28  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (begin_compound_stmt): No scope arg is a bool.
	(finish_compound_stmt): Remove no scope arg.
	* decl.c (register_dtor_fn): Adjust begin_compound_stmt and
	end_compound_stmt calls.
	(expand_static_init, begin_destructor_body, begin_function_body,
	finish_function_body): Likewise.
	* decl2.c (start_objects, finish_objects,
	start_static_storage_duration_function,
	finish_static_storage_duration_function): Likewise.
	* init.c (begin_init_stmts, finish_init_stmts,
	construct_virtual_base, build_vec_init): Likewise.
	* method.c (do_build_assign_ref, synthesize_method): Likewise.
	* parser.c (cp_parser_compound_statement,
	cp_parser_implicitly_scoped_statement,
	cp_parser_already_scoped_statement): Likewise.
	* pt.c (tsubst_expr): Likewise.
	* semantics.c (begin_compound_stmt): No scope arg is a bool.
	(finish_compound_stmt): Remove no scope arg.

	* error.c (dump_expr) <COMPOUND_EXPR case>: A compound expr is
	always dyadic.

2003-07-27  Mark Mitchell  <mark@codesourcery.com>

	* call.c (standard_conversion): Tweak handling of
	pointer-to-member types.
	* pt.c (tsubst): Correctly qualify pointers-to-data member types.
	* typeck.c (comp_ptr_ttypes_real): Check qualifiers on
	pointer-to-data member types.

2003-07-27  Nathan Sidwell  <nathan@codesourcery.com>

	* parser.c (cp_parser_type_parameter): Reformat.
	(cp_parser_parameter_declaration): Deprecate default args where
	not allowed.

2003-07-26  Nathan Sidwell  <nathan@codesourcery.com>

	* cfns.h: Rebuilt.

	* cp-tree.h (begin_init_stmts, finish_init_stmts): Remove.
	(begin_global_stmt_expr, finish_global_stmt_expr): Remove.
	* init.c (begin_init_stmts): Make static. Return is_global
	value. Always call begin_stmt_expr.
	(finish_init_stmts): Make static. Add is_global parm. Always
	building a stmt tree.
	(build_aggr_init): Adjust begin_init_stmts, finish_init_stmts calls.
	(build_vec_init): Likewise. Always building a stmt tree.
	(expand_default_init): Always building a stmt tree.
	(get_temp_regvar): Likewise.
	* semantics.c (begin_global_stmt_expr,
	finish_global_stmt_expr): Remove.

2003-07-25  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (build_compound_expr): Take LHS & RHS args.
	(build_x_compound_expr_from_list): Declare.
	* typeck.c (build_x_compound_expr_from_list): New.
	(build_x_compound_expr): Adjust.
	(build_compound_expr): Remove unreachable code. Take two
	parameters, adjust.
	* decl.c (grok_reference_init): Use
	build_x_compound_expr_from_list.
	(expand_static_init): Adjust build_compound_expr call.
	(cxx_maybe_build_cleanup): Likewise.
	* init.c (perform_member_init): Use
	build_x_compound_expr_from_list.
	(build_new_1): Likewise.
	(build_vec_delete): Adjust build_compound_expr calls.
	(build_vbase_delete): Likewise.
	* typeck2.c (store_init_value): Use
	build_x_compound_expr_from_list.
	(build_functional_cast): Likewise.

2003-07-25  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (enum tsubst_flags_t): Add tf_user.
	* decl.c (make_typename_type): Pass it.
	* pt.c (lookup_template_class): Use it.
	(resolve_typename_type): Pass it.
	* semantics.c (finish_template_type): Pass it.

2003-07-25  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11617
	* cp-tree.h (qualified_name_lookup_error): Declare.
	* pt.c (tsubst_qualified_id): Use qualified_name_lookup_error for
	errors.
	(tsubst_expr) <DECL_STMT case>: Likewise.
	(tsubst_copy_and_build) <COMPONENT_REF case>: Likewise.
	* semantics.c (qualified_name_lookup_error): New, broken out of ...
	(finish_id_expression): ... here. Use it.

2003-07-25  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	* cfns.gperf: Add '%%' delimiter to placate gperf 3.0.

2003-07-25  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11596
	* pt.c (maybe_fold_nontype_arg, maybe_fold_nontype_args): Remove.
	(tsubst_template_arg): New.
	(tsubst_template_arg_vector): Rename to ...
	(tsubst_template_args): ... this. Accept a TREE_LIST form. Use
	tsubst_template_arg.
	(coerce_template_parms): Use tsubst_template_arg for default
	value.
	(tsubst_template_parms): Likewise.
	(tsubst_aggr_type): Adjust.
	(tsubst_decl): Likewise.
	(tsubst): Use tsubst_template_arg for a DOMAIN. Adjust.
	(tsubst_copy) <TEMPLATE_ID_EXPR case>: Use tsubst_template_args.

2003-07-25 Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* Make-lang.in (cp/error.o): Depend on DIAGNOSTIC_H.
	* error.c: Use the new pretty-printer framework.

2003-07-24  Per Bothner  <pbothner@apple.com>

	* decl.c (pushdecl_class_level): Don't use push_srcloc/pop_srcloc
	which causes errors messages to incorrectly mention included files.

2003-07-24  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (convert_to_base_statically): Declare.
	* call.c (build_special_member_call): Convert INSTANCE to the base
	type.
	* class.c (convert_to_base_statically): New method.
	* init.c (construct_virtual_base): Use it.
	* method.c (do_build_assign_ref): Fix typo in comment.

2003-07-24  Jason Merrill  <jason@redhat.com>

	* decl.c: Just set truthvalue_* to boolean_*.

2003-07-24  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (reshape_init): Remove unreachable code.

2003-07-24  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/11513
	* cp-tree.h (PROCESSING_REAL_TEMPLATE_DECL_P): Use current_scope.

2003-07-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11645
	* cp-tree.h (accessible_base_p): Declare.
	* call.c (build_over_call): Use it.
	* search.c (accessible_base_p): New function, split out from ...
	(lookup_base): ... here.

	PR c++/11517
	* call.c (build_conditional_expr): Use perform_implicit_conversion
	and error_operand_p.  Robustify.
	* typeck.c (build_unary_op): Use perform_implicit_conversion.

2003-07-23  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10953
	* parser.c (cp_parser_nested_name_specifier): Reset scope on
	failure.
	(cp_parser_elaborated_type_specifier): Likewise.

2003-07-22  Mark Mitchell  <mark@codesourcery.com>

	Eliminate use of POINTER_TYPE for pointers-to-members.
	* call.c (standard_conversion): Rework pointer-to-member handling.
	Add comments.
	(add_builtin_candidate): Likewise.
	(resolve_scoped_fn_name): Remove.
	(build_conditional_expr): Rework pointer-to-member handling.
	(compare_ics): Likewise.
	* class.c (check_field_decls): Use TYPE_PTR_P.
	* cp-lang.c (cp_var_mod_type_p): Rework pointer-to-member
	handling.
	* cp-tree.h (SCALAR_TYPE_P): Use TYPE_PTR_TO_MEMBER_P.
	(TYPE_PTRMEM_P): Add comment.
	(TYPE_PTR_P): Simplify.
	(TYPE_PTROB_P): Correct definition.
	(TYPE_PTR_TO_MEMBER_P): New macro.
	(TYPE_PTRMEM_CLASS_TYPE): Adjust.
	(TYPE_PTRMEM_POINTED_TO_TYPE): Likewise.
	(resolved_scoped_fn_name): Remove declaration.
	(build_offset_ref): Change prototype.
	(resolve_offset_ref): Remove.
	(comp_target_types): Remove.
	* cvt.c (cp_convert_to_pointer): Rework pointer-to-member
	handling.
	(convert_to_reference): Use can_convert.
	(ocp_convert): Improve error handling.  Rework pointer-to-member
	handling.
	(perform_qualification_conversions): Rework pointer-to-member
	handling.
	* decl.c (build_ptrmem_type): Handle functions too.
	(create_array_type_for_decl): Remove OFFSET_TYPE error message.
	(grokdeclarator): Use OFFSET_TYPE for pointers to data members.
	(grokparms): Remove OFFSET_TYPE error message.
	* dump.c (cp_dump_tree): Rework pointer-to-member handling.
	* error.c (dump_type_prefix): Likewise.
	* expr.c (cplus_expand_constant): Use build_nop.
	* init.c (build_offset_ref): Add address_p parameter.  Fold in
	necessary bits from resolve_offset_ref.
	(resolve_offset_ref): Remove.
	* parser.c (cp_parser_postfix_expression): Remove special case
	code for OFFSET_TYPE.
	* pt.c (convert_nontype_argument): Rework pointer-to-member
	handling.
	(convert_template_argument): Likewise.
	(unify): Likewise.
	(invalid_nontype_parm_type_p): Likewise.
	(dependent_type_p_r): Likewise.
	* rtti.c (get_tinfo_decl): Remove OFFSET_TYPE special case.
	(target_incomplete_p_): Rework pointer-to-member
	handling.
	(get_pseudo_ti_init): Likewise.
	(get_pseudo_ti_desc): Likewise.
	* semantics.c (finish_qualified_id_expr): Adjust call to
	build_offset_ref.  Remove use of resolve_offset_ref.
	* tree.c (pod_type_p): Use TYPE_PTR_TO_MEMBER_P.
	* typeck.c (target_type): Use TYPE_PTRMEM_P.
	(type_unknown_p): Remove obsolete code about the time before
	non-dependent expressions were handled correctly.
	(qualify_type_recursive): Remove.
	(composite_pointer_type_r): New function.
	(composite_pointer_type): Use it.
	(merge_types): Remove dead comments.
	(comp_cv_target_types): Remove.
	(comp_target_types): Likewise.
	(comp_target_parms): Likewise.
	(cxx_sizeof_or_alignof_type): Remove OFFSET_TYPE error.
	(build_indirect_ref): Use TYPE_PTR_TO_MEMBER_P.
	(build_binary_op): Do not use of comp_target_types.
	(pointer_diff): Remove OFFSET_TYPE case.
	(build_unary_op): Adjust pointer-to-member handling.
	(unary_complex_lvalue): Likewise.
	(check_for_casting_away_constness): Add description parameter.
	(build_static_cast): Pass it.
	(build_reinterpret_cast): Use check_for_casting_away_constness.
	(build_const_cast): Adjust pointer-to-member handling.
	(build_c_cast): Likewise.
	(convert_for_assignment): Remove OFFSET_TYPE error message.
	(comp_ptr_ttypes_real): Adjust pointer-to-member handling.
	(comp_ptr_ttypes_reinterpret): Remove.
	(casts_away_constness_r): Adjust pointer-to-member handling.
	(casts_away_constness): Liekwise.
	(strip_all_pointer_quals): Remove.
	* typeck2.c (digest_init): Adjust pointer-to-member handling.
	(build_m_component_ref): Likewise.

2003-07-22  Wolfgang Bangerth  <bangerth@dealii.org>

	* lex.c (unqualified_fn_lookup_error): Mention that the error
	message needs to be kept in synch with the manual.

2003-07-22  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11614
	* decl.c (grokdeclarator): An array member is only a flexible
	array member if the field itself is the array.

2003-07-22  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10793
	* decl.c (xref_basetypes): Handle error_mark_node.

2003-07-22  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (enum cp_lvalue_kind): Add clk_packed.
	* tree.c (lvalue_p_1): Set it.
	* class.c (check_field): Don't allow non-packed non-POD fields to
	be packed.
	* call.c (reference_binding): Need a temporary for all bitfield
	and packed fields.
	(convert_like_real): Check it is ok to make a temporary here.

2003-07-21  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (hack_identifier): Remove.
	* method.c (hack_identifier): Remove.
	* semantics.c (finish_id_expression): Expand hack_identifier
	here. Simplify.

2003-07-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* call.c class.c decl.c decl2.c g++spec.c lex.c parser.c pt.c rtti.c
	semantics.c typeck.c: Remove unnecessary casts.

2003-07-18  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (hack_identifier): Remove.
	* method.c (hack_identifier): Remove.
	* semantics.c (finish_id_expression): Expand hack_identifier
	here. Simplify.

2003-07-18  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (finish_non_static_data_member): Add object param.
	* method.c (hack_identifier): Adjust.
	* pt.c (tsubst_copy_and_build) <COMPONENT_REF case>: Don't search
	again for a FIELD_DECL.
	* semantics.c (finish_non_static_data_member): Add object
	parameter. Always save the DECL in the COMPONENT_REF.
	* call.c (resolve_scoped_fn_name): Adjust.

2003-07-17  Zack Weinberg  <zack@codesourcery.com>

	* pt.c (get_bindings): Make definition consistent with
	forward declaration.

2003-07-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/7809
	* friend.c (add_friend): Check access for member functions
	and templates.

2003-07-17  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/10668
	* typeck.c (build_class_member_access_expr): Improve diagnostic.

2003-07-16  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11547
	* cp-tree.h (DECL_INITIALIZED_BY_CONSTANT_EXPRESSION_P): New
	macro.
	(DECL_PRETTY_FUNCTION_P): Use VAR_DECL_CHECK.
	* decl.c (duplicate_decls): Merge
	DECL_INITIALIZED_BY_CONSTANT_EXPRESSION_P.
	* parser.c (cp_parser_postfix_expression): Adjust call to
	cp_parser_initializer_list and
	cp_parser_parenthesized_expression_list.
	(cp_parser_parenthesized_expression_list): Add non_constant_p.
	(cp_parser_new_placement): Adjust call to
	cp_parser_parenthesized_expression_list.
	(cp_parser_direct_new_declarator): Likewise.
	(cp_parser_conditional_expression): Remove.
	(cp_parser_constant_expression): Parse an assignment-expression,
	not a conditional-expression.
	(cp_parser_simple_declaration): Resolve expression/declaration
	ambiguity more quickly.
	(cp_parser_mem_initializer): Adjust call to
	cp_parser_parenthesized_expression_list.
	(cp_parser_init_declarator): Keep track of whether or not the
	initializer is a constant-expression.
	(cp_parser_initializer): Add non_constant_p parameter.
	(cp_parser_initializer_clause): Likewise.
	(cp_parser_initializer_list): Likewise.
	(cp_parser_attribute_list): Adjust call to
	cp_parser_parenthesized_expression_list.
	(cp_parser_functional_cast): Likewise.
	* pt.c (tsubst_decl): Copy
	DECL_INITIALIZED_BY_CONSTANT_EXPRESSION_P.
	(tsubst_expr): Tweak use of DECL_PRETTY_FUNCTION_P.
	* semantics.c (finish_id_expression): Use
	DECL_INITIALIZED_BY_CONSTANT_EXPRESSION_P.

2003-07-16  Neil Booth  <neil@daikokuya.co.uk>

	* lang-options.h: Remove.

2003-07-16  Andrew Pinski  <pinskia@physics.uc.edu>

	PR c/10962
	* class.c (field_decl_cmp): Remove.
	(resort_field_decl_cmp): Remove.
	(resort_sorted_fields): Remove.
	(add_fields_to_vec): Rename to ...
	(add_fields_to_record_type): this.
	(finish_struct_1): Change to be using
	sorted_fields_type's fields.
	* cp-tree.h (lang_decl): In lang_decl_u3
	change sorted_fields to be a pointer to
	sorted_fields_type.
	(resort_sorted_fields): Remove prototype.
	* search.c (lookup_field_1): Change to be using
	sorted_fields_type's fields.

2003-07-16  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/5421
	* decl.c (grokdeclarator): Handle TEMPLATE_ID_EXPR if friend
	is a member of other class.
	* friend.c (do_friend): Don't build TEMPLATE_DECL if friend
	is a specialization of function template.

2003-07-16  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/10903
	* pt.c (convert_nontype_argument): Fix thinko in diagnostic.
	Improve.

2003-07-15  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.def (LOOKUP_EXPR): Remove.
	* cp-tree.h (cp_id_kind): Add CP_ID_KIND_UNQUALIFIED_DEPENDENT.
	(LOOKUP_EXPR_GLOBAL): Remove.
	(get_bindings): Remove.
	(is_aggr_type_2): Remove.
	* call.c (resolved_scoped_fn_name): Remove support for
	LOOKUP_EXPR.
	* decl.c (grokfndecl): Likewise.
	(grokdeclarator): Likewise.
	* error.c (dump_decl): Likewise.
	(dump_expr): Likewise.
	* friend.c (do_friend): Likewise.
	* init.c (build_offset_ref): Likewise.
	* lex.c (unqualified_fn_lookup_error): Use pedwarn.  Do not create
	LOOKUP_EXPRs
	* mangle.c (write_expression): Remove support for LOOKUP_EXPR.
	* parser.c (cp_parser_postfix_expression): Modify Koenig lookup
	test.
	* pt.c (get_bindings): Give it internal linkage.
	(check_explicit_specialization): Remove support for LOOKUP_EXPR.
	(lookup_template_function): Likewise.
	(for_each_tempalte_parm_r): Likewise.
	(tsubst_decl): Likewise.
	(tsubst_qualified_id): Handle template template parameters.
	(tsubst_copy): Remove support for LOOKUP_EXPR.
	(tsubst_copy_and_build): Likewise.
	(most_general_template): Likewise.
	(value_dependent_expression_p): Likewise.
	(type_dependent_expression_p): Note that IDENTIFIER_NODEs are
	always dependent.
	* semantics.c (perform_koenig_lookup): Do not create
	IDENTIFIER_NODEs.
	(finish_fname): Likewise.
	(finish_id_expression): Likewise.
	* tree.c (is_aggr_type_2): Remove.

2003-07-16  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/11531
	* typeck.c (check_return_expr): Fix thinko in diagnostic.

2003-07-15  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10108
	* pt.c (tsubst_decl) <TEMPLATE_DECL>: Add a check for
	error_mark_node.

2003-07-14  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11509
	* pt.c (dependent_scope_ref_p): New function.
	(value_dependent_expression_p): Use it.
	(type_dependent_expression_p): Likewise.

	* pt.c (tsubst_friend_function): Use reregister_specialization.

	PR c++/7019
	* cp-tree.h (lookup_qualified_name): Adjust prototype.
	* decl.c (lookup_qualified_name): Add complain parameter.  Adjust
	call to is_aggr_type.
	* parser.c (cp_parser_lookup_name): Adjust call to
	lookup_qualified_name.
	* pt.c (tsubst_qualified_id): Likewise.
	(tsubst_copy_and_build): Likewise.
	* semantics.c (finish_qualified_id_expr): Deal with erroneous
	expressions.

2003-07-14  Gabriel Dos Reis <gdr@integrable-solutions.net>

	PR c++/11510
	* call.c (op_error): Properly format  REALPART_EXPR and
	IMAGPART_EXPR.
	* error.c (dump_expr): Likewise.

2003-07-14  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* error.c (dump_expr): Handle EMPTY_CLASS_EXPR.

2003-07-14  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/5293
	* call.c (initialize_reference): Improve diagnostic.

2003-07-14  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/11154
	* pt.c (more_specialized_class): Add full_args parameter.
	(most_specialized_class): Adjust calls to more_specialized_class.
	* cp-tree.h (more_specialized_class): Adjust declaration.

2003-07-14  Dan Nicolaescu  <dann@ics.uci.edu>

	* lex.c (enum tree_node_kind): Delete.

2003-07-13  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11503
	* cp-tree.h (DECL_SELF_REFERENCE_P): New macro.
	(SET_DECL_SELF_REFERENCE_P): Likewise.
	* class.c (build_self_reference): Use SET_DECL_SELF_REFERENCE_P.
	* pt.c (tsubst_decl): Copy it.
	* search.c (lookup_base): Use DECL_SELF_REFERENCE_P.

	* pt.c (reregister_specialization): Fix thinko in previous change.

	* cp-tree.h (cp_id_kind): New type.
	(unqualified_name_lookup_error): Change prototype.
	(unqualified_fn_lookup_error): New function.
	(do_identifier): Remove.
	(do_scoped_id): Likewise.
	(tsubst_copy_and_build): Change prototype.
	(reregister_specialization): New function.
	(perform_koenig_lookup): Likewise.
	(finish_id_expression): Likewise.
	* call.c (build_method_call): Adjust call to
	unqualified_name_lookup_error.
	* decl.c (duplicate_decls): Use reregister_specialization.
	* lex.c (is_global): Remove.
	(unqualified_name_lookup_error): Return a value.
	(do_identifier): Remove.
	(do_scoped_id): Likewise.
	(identifier_typedecl_value): Remove.
	(unqualified_fn_lookup_error): New function.
	* parser.c (cp_parser_id_kind): Remove.
	(cp_parser_non_constant_id_expression): Remove.
	(cp_parser_primary_expression): Use finish_id_expression.
	(cp_parser_class_or_namespace_name): Use cp_id_kind, not
	cp_parser_id_kind.
	(cp_parser_postfix_expression): Use perform_koenig_lookup.
	(cp_parser_template_argument): Use cp_id_kind.
	(cp_parser_fold_non_dependent_expr): Adjust call to
	tsubst_copy_and_build.
	* pt.c (unregister_specialization): Rename to ...
	(reregister_specialization): This.
	(tsubst_friend_function): Use it.
	(maybe_fold_nontype_arg): Adjust call to tsubst_copy_and_build.
	(tsubst_qualified_id): Likewise.
	(tsubst_expr): Likewise.
	(tsubst_copy_and_build): Add function_p parameter.  Use
	finish_id_expression.  Introduce RECUR macro.
	(tsubst_non_call_postfix_expression): New function.
	(regenerate_decl_from_template): Use reregister_specialization.
	* semantics.c (perform_koenig_lookup): New function.
	(finish_id_expression): Likewise.

2003-07-13  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* pt.c (push_access_scope_real): Remove.
	(push_access_scope): Move code from push_access_scope_real.
	(pop_access_scope): Don't check for TEMPLATE_DECL.
	(instantiate_template): Defer access checking during template
	substitution.
	(regenerate_decl_from_template): Tidy.

2003-07-11  Nathanael Nerode  <neroden@gcc.gnu.org>

	PR c++/11437
	* operators.def: Add definitions for __imag__, __real__.

2003-07-11  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/11050
	* parser.c (cp_parser_expression_list): Rename to ...
	(cp_parser_parenthesized_expression_list): ... here. Add attribute
	parameter, parse the surounding parentheses.
	(cp_parser_skip_to_closing_parenthesis): Add recover and or_comma
	parameters. Return int.
	(cp_parser_skip_to_closing_parenthesis or comma): Remove.
	(cp_parser_postfix_expression): Adjust function call parsing.
	(cp_parser_new_placement): Adjust.
	(cp_parser_new_initializer): Likewise.
	(cp_parser_cast_expression): Likewise.
	(cp_parser_selection_statement): Likewise.
	(cp_parser_mem_initializer): Likewise.
	(cp_parser_asm_definition): Likewise.
	(cp_parser_init_declarator): Likewise.
	(cp_parser_declarator): Make
	cdtor_or_conv_p an int ptr.
	(cp_parser_direct_declarator): Likewise. Check for a parameter
	list on cdtors & conv functions.
	(cp_parser_initializer): Adjust.
	(cp_parser_member_declaration): Adjust.
	(cp_parser_attribute_list): Move code into
	cp_parser_parens_expression_list.
	(cp_parser_functional_cast): Adjust.
	* pt.c (type_dependent_expression_p): Erroneous expressions are
	non-dependent.

2003-07-11  Geoffrey Keating  <geoffk@apple.com>

	* decl.c (cp_finish_decl): Handle 'used' attribute.

	* cp-lang.c (c_reset_state): New dummy routine.
	* cp-tree.h (finish_file): Move prototype to c-common.h.
	* parser.c (c_parse_file): Rename from yyparse; don't call finish_file.

2003-07-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8327
	* pt.c (tsubst_qualified_id): Implement suggested resolution for
	Core Issue 2.
	(type_dependent_expression_p): Likewise.

2003-07-10  Mark Mitchell  <mark@codesourcery.com>

	* typeck.c (build_binary_op): Do not warn about signed
	vs. unsigned comparisons in the bodies of templates.

	PR c++/9411
	* parser.c (cp_parser_postfix_expression): Check dependency of
	functions.

2003-07-09  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10032
	* decl.c (cxx_init_decl_processing): With -pedantic, pedwarns are
	still errors.

	PR c++/10527
	* error.c (decl_to_string): Do not print default argument
	expressions.

	* cp-tree.h (break_out_calls): Remove declaration.
	* tree.c (break_out_calls): Remove.
	* typeck.c (build_modify_expr): Avoid invalid sharing of trees.

2003-07-09  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++ 9483
	* class.c (check_field_decls): Pass DECL_NAME to constructor_name_p.
	* decl2.c (constructor_name_p): Avoid repeated constructor_name
	calls.
	* decl.c (grokdeclarator): Refactor ctor/dtor detection.

2003-07-09  Mark Mitchell  <mark@codesourcery.com>

	* typeck.c (build_x_unary_op): Take note of the fact that
	PREINCREMENT_EXPR and POSTINCREMENT_EXPR are binary operations on
	trees.

	* parser.c (cp_parser_primary_expression): Preserve the form of
	qualified expressions in templates, even if they are not
	dependent.
	* pt.c (convert_nontype_argument): Handle non-dependent SCOPE_REFs.
	(tsubst_qualified_id): Likewise.
	* search.c (accessible_p): Treat everything in the body of a
	template as accessible.

2003-07-08  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.def (NON_DEPENDENT_EXPR): New node.
	* cp-tree.h (build_call_from_tree): Remove.
	(build_member_call): Likewise.
	(dependent_template_arg_p): Remove.
	(any_dependent_template_arguments_p): New function.
	(dependent_template_id_p): Likewise.
	(any_type_dependent_arguments_p): Likewise.
	(build_non_dependent_expr): Likewise.
	(build_non_dependent_args): Likewise.
	(build_x_compound_expr): Adjust prototype.
	* call.c (build_new_method_call): Handle non-dependent expressions
	correctly.
	* decl2.c (grok_array_decl): Likewise.
	(build_offset_ref_call_from_tree): Likewise.
	(build_call_from_tree): Remove.
	* error.c (dump_decl): Handle NON_DEPENDENT_EXPR.
	(dump_expr): Likewise.
	* init.c (build_member_call): Remove.
	* mangle.c (write_expression): Update handling for template-ids.
	* parser.c (cp_parser_primary_expression): Use
	any_dependent_template_arguments_p.  Update constant-expression
	handling.
	(cp_parser_postfix_expression): Use
	any_type_dependent_arguments_p.  Simplify call processing.
	(cp_parser_unary_expression): Simplify.
	(cp_parser_expression): Adjust for changes to
	build_x_compound_expr.
	(cp_parser_template_argument): Implement standard-conforming
	parsing of non-type template arguments.
	(cp_parser_direct_declarator): Use
	cp_parser_fold_non_dependent_expr.
	(cp_parser_fold_non_dependent_expr): New function.
	(cp_parser_next_token_ends_template_argument_p): Likewise.
	* pt.c (convert_template_argument): Do not call
	maybe_fold_nontype_arg.
	(tsubst_baselink): Likewise.
	(tsubst_copy_and_build): Share common code.  Make sizeof/alignof
	processing work correctly for non-dependent expressions.  Adjust
	handling of COMPOUND_EXPR.  Simplify call processing.
	(value_dependent_expression_p): Deal with functional casts and
	sizeof/alignof correctly.
	(type_dependent_expression_p): Handle overloaded functions.
	(any_type_dependent_arguments_p): New function.
	(any_dependent_template_arguments_p): Likewise.
	(dependent_template_p): Treat SCOPE_REFs as dependent.
	(dependent_template_id_p): Simplify.
	(build_non_dependent_expr): New function.
	(build_non_dependent_args): Likewise.
	* semantics.c (finish_stmt_expr): Don't make dependent
	statement-expresions have void type.
	(finish_call_expr): Handle non-dependent expressions
	correctly.
	* tree.c (lvalue_p_1): Treat NON_DEPENDENT_EXPRs as lvalues.
	* typeck.c (cxx_sizeof_or_alignof_type): Give the expression
	type size_t, even in templates.
	(expr_sizeof): Likewise.
	(finish_class_member_access_expr): Handle non-dependent expressions
	correctly.
	(build_x_indirect_ref): Likewise.
	(build_x_binary_op): Likewise.
	(build_x_unary_op): Likewise.
	(build_x_conditional_expr): Likewise.
	(build_x_compound_expr): Likewise.
	* typeck2.c (build_x_arrow): Likewise.

Wed Jul  9 02:28:39 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cp-lang.c (LANG_HOOKS_TREE_INLINING_ESTIMATE_NUM_INSNS): New.
	* decl.c (duplicate_decls): Use DECL_ESTIMATED_INSNS.
	(start_function): Use DECL_ESTIMATED_INSNS.
	* optimize.c (maybe_clone_body): Use DECL_ESTIMATED_INSNS.

	* decl2.c (maybe_emit_vtables): Fix marking vtables as needed in
	unit-at-a-time

2003-07-08  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/11030
	* pt.c (instantiate_class_template): Don't call xref_tag to
	inject name when the friend class is a specialization.

2003-07-07  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (build_scoped_method_call): Remove.
	(lookup_qualified_name): Remove parameter.
	(tsubst_copy_and_build): Declare.
	(finish_qualified_object_call_expr): Remove.
	(check_accessibility_of_qualified_id): New function.
	(finish_qualified_id_expr): Likewise.
	(non_reference): Likewise.
	(build_expr_from-tree): Remove.
	* call.c (non_reference): Remove.
	(build_scoped_method_call): Likewise.
	(build_method_call): Use error_operand_p.  Assert that we are not
	processing a template.
	(standard_conversion): Use non_reference.
	* class.c (build_vtbl_entry_ref): Likewise.
	(build_vtbl_ref_1): Likewise.
	* cvt.c (build_expr_type_conversion): Use non_reference.
	* decl.c (lookup_qualified_name): Remove flags parameter.
	(grok_op_properties): Use non_reference.
	* decl2.c (grok_array_decl): Likewise.
	(build_expr_from_tree): Remove.
	(build_offset_ref_call_from_tree): Update comment.
	* error.c (parm_to_string): Call reinit_global_formatting_buffer.
	* except.c (prepare_eh_types): Use non_reference.
	(can_convert_eh): Likewise.
	* init.c (build_dtor_call): Avoid using build_method_call.
	* mangle.c (write_template_param): Remove misleading comment.
	* method.c (locate_copy): Use non_reference.
	* parser.c (cp_parser_scope_through_which_access_occurs): Remove.
	(cp_parser_primary_expression): Do not create SCOPE_REFs is
	non-dependent contexts.
	(cp_parser_postfix_expression): Use finish_qualified_id_expr.
	(cp_parser_direct_declarator): Use tsubst_copy_and_build, not
	build_expr_from_tree.
	(cp_parser_lookup_name): Adjust call to lookup_qualified_name.
	Use check_accessibility_of_qualified_id.
	* pt.c (maybe_fold_nontype_arg): Use tsubst_copy_and_build, not
	build_expr_from_tree.
	(tsubst_baselink): New function.
	(tsubst_qualified_id): Likewise.
	(tsubst_copy): Use them.  Remove support for METHOD_CALL_EXPR.
	(tsubst_expr): Adjust call to lookup_qualified_name.
	(tsubst_copy_and_build): Handle SCOPE_REFs specially.  Adjust
	handling of CALL_EXPRs.
	(value_dependent_expression_p): Use INTEGRAL_OR_ENUMERATION_TYPE_P.
	* rtti.c (get_tinfo_decl_dynamic): Use non_reference.
	* search.c (check_final_overrider): Likewise.
	* semantics.c (check_accessibility_of_qualified_id): New function.
	(finish_qualified_object_call_expr): Remove.
	* typeck.c (target_type): Use non_reference.
	(cxx_sizeof_or_alignof_type): Likewise.
	(dubious_conversion_warnings): Likewise.
	(convert_for_initialization): Likewise.
	(non_reference): New function.

2003-07-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (print_binding_level, print_other_binding_stack,
	print_binding_stack): Merge uses of HOST_PTR_PRINTF with adjacent
	stdio calls.
	* ptree.c (cxx_print_decl, cxx_print_binding): Likewise.

2003-07-07  Andreas Jaeger  <aj@suse.de>

	* friend.c: Convert to ISO C90 prototypes.

	* Make-lang.in ($(srcdir)/cp/cfns.h): Use ANSI-C as output
	language.
	* cfns.h: Regenerate.

	* typeck.c: Convert remaining prototypes to ISO C90.
	* search.c: Likewise.

	* decl2.c (build_expr_from_tree): Convert prototype to ISO C90.
	* semantics.c (expand_or_defer_fn): Likewise
	* mangle.c (discriminator_for_string_literal): Likewise.
	* g++spec.c (lang_specific_driver): Likewise.

	* search.c (lookup_base_r): Remove unused variable.

2003-07-07  Nathan Sidwell  <nathan@codesourcery.com>

	* semantics.c: (genrtl_try_block) Adjust emit_line_note
	calls.

2003-07-07  Andreas Jaeger  <aj@suse.de>

	* search.c (lookup_base_r): Remove unused variable.

2003-07-06  Michael Chastain  <mec@shout.net>

	PR debug/10055
	* lex.c (cxx_init): Call push_srcloc and pop_srcloc rather than
	assigning to input_filename directly.

2003-07-06  Kazu Hirata  <kazu@cs.umass.edu>

	* call.c: Fix comment formatting.
	* class.c: Likewise.
	* cp-tree.h: Likewise.
	* decl.c: Likewise.
	* decl2.c: Likewise.
	* error.c: Likewise.
	* method.c: Likewise.
	* name-lookup.c: Likewise.
	* parser.c: Likewise.
	* pt.c: Likewise.
	* rtti.c: Likewise.
	* search.c: Likewise.
	* typeck.c: Likewise.

2003-07-06  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11345
	* search.c (lookup_base_r): Remove is_non_public and
	within_current_scope parameters.  Remove other dead code.
	(lookup_base): Adjust call to lookup_base_r.
	(adjust_result_of_qualified_name_lookup): Improve comment.
	* semantics.c (finish_call_expr): Use maybe_dummy_object.

2003-07-06  Neil Booth  <neil@daikokuya.co.uk>

	* cp-lang.c (LANG_HOOKS_HANDLE_FILENAME,
	LANG_HOOKS_MISSING_ARGUMENT): Override.

2003-07-05  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11431
	* typeck.c (build_static_cast): Check for reference conversions
	earlier.

2003-07-04  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (perform_integral_promotions): Declare.
	* call.c (build_addr_func): Use decay_conversion.
	(convert_arg_to_ellipsis): Likewise.  Remove misleading comment.
	(convert_for_arg_passing): Use perform_integral_promotions.
	* cvt.c (build_expr_type_conversion): Use decay_conversion.
	(type_promotes_to): Do not return a cv-qualified type.
	* decl.c (grok_reference_init): Fix formatting.
	(get_atexit_node): Use decay_conversion.
	(build_enumerator): Use perform_integral_promotions.
	* init.c (build_vec_init): Use decay_conversion.
	* semantics.c (finish_expr_stmt): Likewise.
	(finish_switch_cond): Use perform_integral_promotions.
	* typeck.c (default_conversion): Likewise.
	(perform_integral_promotions): New function.
	(build_indirect_ref): Use decay_conversion.
	(build_array_ref): Use perform_integral_promotions.
	(convert_arguments): Use decay_conversion.
	(build_unary_op): Use perform_integral_promotions.
	(build_c_cast): Use decay_conversion.
	(build_modify_expr): Likewise.
	(convert_for_initialization): Likewise.
	* typeck2.c (build_x_arrow): Likewise.

2003-07-04  Kazu Hirata  <kazu@cs.umass.edu>

	* call.c: Fix comment typos.
	* class.c: Likewise.
	* cp-tree.h: Likewise.
	* cvt.c: Likewise.
	* decl2.c: Likewise.
	* decl.c: Likewise.
	* init.c: Likewise.
	* mangle.c: Likewise.
	* parser.c: Likewise.
	* pt.c: Likewise.
	* search.c: Likewise.
	* semantics.c: Likewise.
	* tree.c: Likewise.
	* typeck.c: Likewise.

2003-07-04  Zack Weinberg  <zack@codesourcery.com>

	* parser.c (cp_lexer_read_token): No need to handle string
	constant concatenation.

2003-07-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cp-tree.h (GCC_DIAG_STYLE, ATTRIBUTE_GCC_CXXDIAG): Define.
	(cp_error_at, cp_warning_at, cp_pedwarn_at): Mark with
	ATTRIBUTE_GCC_CXXDIAG.

2003-07-03  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_addr_func): Handle bound pointers-to-members.
	(build_method_call): Do not call resolve_offset_ref.
	(implicit_conversion): Likewise.
	(resolve_scoped_fn_name): Use finish_non_static_data_member, not
	resolve_offset_ref.
	(resolve_args): Do not call resolve_offset_ref.
	(build_conditional_expr): Likewise.
	(build_new_method_call): Likewise.
	* cp-tree.def (OFFSET_REF): Update documentation.
	* cvt.c (cp_convert_to_pointer): Update handling of conversions from
	pointers to members to pointers.
	(ocp_convert): Do not call resolve_offset_ref.
	(convert_to_void): Likewise.
	(build_expr_type_conversion): Likewise.
	* decl2.c (delete_sanity): Likewise.
	* init.c (resolve_offset_ref): Simplify greatly.
	(build_vec_delete): Do not call resolve_offset_ref.
	* parser.c (cp_parser_postfix_expression): Call resolve_offset_ref
	if appropriate.
	(cp_parser_unary_expression): Use
	cp_parser_simple_cast_expression.
	(cp_parser_delete_expression): Likewise.
	(cp_parser_cast_expression): Likewise.
	(cp_parser_pm_expression): Use cp_parser_binary_op.
	(cp_parser_simple_cast_expression): New function.
	* rtti.c (build_dynamic_cast_1): Do not call resolve_offset_ref.
	* semantics.c (finish_increment_expr): Likewise.
	(finish_typeof): Likewise.
	* tree.c (lvalue_p_1): Do not handle OFFSET_REF.
	* typeck.c (require_complete_type): Do not handle OFFSET_REFs.
	(decay_conversion): Do not call resolve_offset_ref.
	(finish_class_member_access_expr): Likewise.
	(convert_arguments): Likewise.
	(build_x_binary_op): Handle DOTSTAR_EXPR.
	(condition_conversion): Do not call resolve_offset_ref.
	(unary_complex_lvalue): Likewise.
	(build_static_cast): Likewise.
	(build_reinterpret_cast): Likewise.
	(build_const_cast): Likewise.
	(build_c_cast): Likewise.
	(build_modify_expr): Likewise.
	(convert_for_assignment): Likewise.
	(convert_for_initialization): Likewise.
	* typeck2.c (build_x_arrow): Likewise.
	(build_m_component_ref): Simplify.

	* call.c (build_scoped_method_call): Use convert_to_void.
	(build_method_call): Likewise.
	* class.c (check_field_decls): Remove dead code.
	* cvt.c (convert_from_reference): Remove OFFSET_TYPE handling.
	* decl2.c (grok_array_decl): Remove dead code.
	(arg_assoc_type): Avoid relying on POINTER_TYPE over OFFSET_TYPE
	as pointer-to-member representation.
	* init.c (build_offset_ref): Tidy.
	(build_vec_delete_1): Use convert_to_void.
	* mangle.c (write_type): Avoid relying on POINTER_TYPE over OFFSET_TYPE
	as pointer-to-member representation.

2003-07-03  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9162
	* decl.c (grokdeclarator): Return friend decls, not
	void_type_node.
	* decl2.c (grokfield): Alter friend decl check.
	* parser.c (struct cp_parser): Document default_arg chain on
	unparsed_functions_queue.
	(cp_parser_save_default_args): New.
	(cp_parser_init_declarator, cp_parser_function_definition,
	cp_parser_member_declaration): Call it.
	(cp_parser_class_specifier): Remove unused variable. Alter
	processing of unparsed_functions_queue.

2003-07-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (add_method, check_field_decl): Fix format specifier.
	* decl.c (duplicate_decls, pushdecl, check_goto,
	fixup_anonymous_aggr, maybe_commonize_var, grokdeclarator,
	start_enum): Likewise.
	* decl2.c (ambiguous_decl): Likewise.
	* pt.c (redeclare_class_template): Likewise.

2003-07-02  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10219
	* pt.c (type_unification_real): Don't unify exprs of error type.
	* tree.c (error_type): Don't die on error_type.

	PR c++/9779
	* decl2.c (arg_assoc_class): Don't die on NULL type.
	* typeck.c (type_unknown_p): Don't die on untyped expressions.

2003-07-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/6949
	* decl2.c (grokfield): Create TEMPLATE_DECLs for methods in local
	classes.

2003-07-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* error.c (locate_error): %P takes an `int', not a `tree'.

Wed Jul  2 00:36:48 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* decl2.c (defer_fn): Set DECL_DEFER_OUTPUT.
	(finish-file): Do not process function with DECL_DEFER_OUTPUT clear;
	clear DECL_DEFER_OUTPUT once function is processed; avoid flags
	massaging.

	* cp-tree.h (DECL_NEEDED_P): Support unit-at-a-time
	(expand_or_defer_fn): Declare.
	(lower_function): Declare.
	* decl.c (start_cleanup_fn): Use expand_or_defer_fn.
	* decl2.c: Include cgraph.h and varpool.h
	(maybe_emit_vtables):  Make explicit instantations as needed.
	(mark_member_pointers, lower_function): New functions.
	(finish_file): Do unit-at-a-time.
	* method.c (synthesize_method): Use expand_or_defer_fn.
	* optimize.c (maybe_clone_body): Use expand_or_defer_fn.
	* parser.c (cp_parser_function_definition_after_decl): Use
	expand_or_defer_fn.
	* pt.c (instantiate_decl): Likewise.
	* semantics.c: Include cgraph.h
	(expand_or_defer_fn): Break out from ...
	(expand_body): ... here; deal with unit-at-a-time.
	* cp-lang.c (LANG_HOOKS_CALLGRAPH_EXPAND_FUNCTION,
	LANG_HOOKS_CALLGRAPH_LOWER_FUNCTION): Define.

2003-07-01  Mark Mitchell  <mark@codesourcery.com>

	* call.c (resolve_scoped_fn_name): Return error_mark_node for
	erroneous cases.

2003-07-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11149
	* call.c (resolve_scoped_fn_name): Check that the qualifying scope
	is a class type.

2003-07-01  Giovanni Bajo  <giovannibajo@libero.it>

	PR c++/8046
	* error.c (dump_decl): Handle BIT_NOT_EXPR as
	pseudo destructor calls.

2003-07-01  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (define_label): Replace filename and lineno
	arguments with a location_t.
	* decl.c (pop_label): Adjust define_label call.
	(define_label): Replace filename and lineno arguments with a
	location_t.
	* semantics.c (finish_label): Adjust define_label call.

2003-07-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9559
	* decl2.c (grokfield): Do not build NOP_EXPRs around the
	error_mark_node.

2003-06-30  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Update.
	* cp-lang.c (c_language): Define.
	(LANG_HOOKS_INIT_OPTIONS): Use common hook.
	* cp-tree.h (cxx_init_options): Remove.
	* lex.c: Don't include diagnostic.h.
	(cxx_init_options): Remove.

2003-06-30  Giovanni Bajo  <giovannibajo@libero.it>

	PR c++/4933
	* error.c (dump_expr): Support correctly the COMPOUND_EXPR
	tree generated within a template. Use dump_expr to dump an
	expression sizeof.

2003-06-30  Giovanni Bajo  <giovannibajo@libero.it>

	* mangle.c (write_expression): Exit gracefully when trying to
	mangle a CALL_EXPR.

2003-06-30  Giovanni Bajo  <giovannibajo@libero.it>

	PR c++/10750
	* parser.c (cp_parser_primary_expression): A VAR_DECL with a
	(value- or type-) dependent expression as DECL_INITIAL is a
	valid constant-expression (at parser time).

2003-06-30  Giovanni Bajo <giovannibajo@libero.it>

	PR c++/11106
	* error.c (dump_decl): Call dump_decl to dump the DECL_NAME for a
	USING_DECL, instead of print_tree_identifier.

2003-06-29  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cp-tree.h (language_to_string): Adjust declaration.
	* dump.c (cp_dump_tree): Adjust usage.
	* error.c (dump_char): Use output_formatted_scalar. Tidy.
	(parm_to_string): Lose unused parameter.  Tidy.
	(expr_to_string): Likewise.
	(code_to_string): Likewise.
	(language_to_string): Likewise.
	(op_to_string): Likewise.
	(assop_to_string): Likewise.
	(digit_buffer): Remove.
	(dump_type): Format builtin vector type as __vector__.

2003-06-29  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* error.c (print_integer): Remove.
	(dump_type_suffix): Adjust.
	(dump_expr): Likewise.

2003-06-28  Nathan Sidwell  <nathan@codesourcery.com>

	* error.c (print_instantiation_partial_context): Take a
	location_t.
	(print_instantiation_full_context): Adjust.
	(print_instantiation_context): Adjust.

	* cp-tree.h (cp_line_of, cp_file_of): Remove.
	* error.c (cp_line_of, cp_file_of): Merge into ...
	(location_of): ... here. Make static, return a location_t.
	(cp_error_at, cp_warning_at, cp_pedwarn_at): Adjust.

2003-06-28  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10784
	* call.c (joust): Move warn_conversion check outwards.

2003-06-27  Zack Weinberg  <zack@codesourcery.com>

	* decl.c (build_typename_type)
	* mangle.c (write_template_template_arg)
	* parser.c (cp_parser_scope_through_which_access_occurs)
	* pt.c (push_access_scope_real, push_access_scope, pop_access_scope)
	* repo.c (get_base_filename)
	* semantics.c (maybe_convert_cond):
	Mark the definition static, matching the forward declaration.

2003-06-27  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10468
	* pt.c (tsubst): Handle qualified TYPEOF_TYPEs correctly.

2003-06-27  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10796
	* decl.c (finish_enum): Implement DR377.

	* decl.c (cp_finish_decl): Don't make variables with reference
	type readonly while they are being initialized.

2003-06-26  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11332
	* typeck.c (build_static_cast): Avoid returning expressions with
	reference type.

2003-06-26  Nathan Sidwell  <nathan@codesourcery.com>

	* call.c (build_op_delete_call): Use strip_array_call. Correct
	error message to say 'delete' or 'delete[]'.

2003-06-26  Giovanni Bajo  <giovannibajo@libero.it>

	PR c++/8266
	* pt.c (check_explicit_specialization): When looking up a
	template function from an identifier outside class-scope, bind
	it to CP_DECL_CONTEXT.

2003-06-25  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10990
	* search.c (lookup_base_r): Rely on accessible_p, rather than
	trying to emulate that logic here.

	PR c++/10931
	* call.c (convert_like): Pass issue_conversion_warnings.
	(convert_like_with_context): Likewise.
	(convert_like_real): Add issue_conversion_warnings parameter.
	(perform_direct_initialization_if_possible): New function.
	* cp-tree.h (perform_direct_initialization_if_possible): Declare it.
	* typeck.c (check_for_casting_away_constness): New function.
	(build_static_cast): Rewrite.

2003-06-24  Nathan Sidwell  <nathan@codesourcery.com>

	* call.c (enforce_access): Assert we get a binfo.
	(build_op_delete_call): Pass a binfo to
	perform_or_defer_access_check.
	* class.c (alter_access): Likewise.
	* decl.c (make_typename_type): Likewise.
	(make_unbound_class_template): Likewise.
	* lex.c (do_identifier): Likewise.
	* method.c (hack_identifier): Likewise.
	* parser.c (cp_parser_lookup_name): Likewise.
	* search.c (lookup_member): Likewise. Move IDENTIFIER_CLASS_VALUE
	test.
	* semantics.c (finish_non_static_data_member): Likewise.
	(perform_or_defer_access_check): Expect a binfo.
	* typeck.c (comptypes): Expect types.

	* mangle.c (find_substitution): Don't pass a non-type to same_type_p
	* friend.c (make_friend_class): Likewise.
	* pt.c (check_default_tmpl_args): Likewise.
	(lookup_template_class): Likewise.

Tue Jun 24 15:30:05 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* method.c (thunk_labelno): Move outside ifdef block to make garbage
	collector happy.

Tue Jun 24 13:52:34 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* class.c (build_vtable): Make vtables.
	* cp-tree.h (DECL_VTABLE_OR_VTT_P): New macro.
	* decl2.c (output_vtable_inherit): Rename to ...
	(prepare_assemble_variable): ... this one; change interface.
	(maybe_emit_vtables): Do not call output_vtable_inherit.
	* cp-lang.c (LANG_HOOKS_PREPARE_ASSEMBLE_VARIABLE): Define.
	* cp-tree.h (prepare_assemble_variable): New.

2003-06-23  Andrew Pinski <pinskia@physics.uc.edu>

	* method.c: add prototype for make_alias_for_thunk.
	(thunk_labelno, make_alias_for_thunk): only define
	if ASM_OUTPUT_DEF is defined.

2003-06-23  Jakub Jelinek  <jakub@redhat.com>

	* method.c (thunk_labelno): New variable.
	(make_alias_for_thunk): New function.
	(use_thunk): Use it if defined ASM_OUTPUT_DEF.  Put the thunk
	into the same section as the function it is calling.
	Include gt-cp-method.h.
	* Make-lang.in (gt-cp-method.h): Depend on s-gtype.
	(cp/method.o): Depend on gt-cp-method.h.
	* config-lang.in (gtfiles): Add $(srcdir)/cp/method.c.

Mon Jun 23 19:41:27 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* decl.c (register_dtor_fn): Mark cleanup as used.
	* decl2.c (mark_vtable_entries): Skip nops.
	* rtti.c (get_tinfo_ptr): Mark tinfo as used.
	(build_dynamic_cast_1): Likewise.
	(tinfo_base_init): Likewise.
	(emit_tinfo_decl): Likewise.

2003-06-23  Jakub Jelinek  <jakub@redhat.com>

	* mangle.c (hash_type): Val is the TREE_LIST itself, not a pointer
	to it.

2003-06-21  Gabriel Dos Reis <gdr@integrable-solutions.net>

	PR c++/10784
	* call.c (joust): Warn about choosing conversion sequence only if
	-Wconversion.

2003-06-21  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR c++/10864
	* call.c (op_error): Tidy.
	* error.c (dump_expr): Properly format 'T()' when T is an
	aggregate type.

2003-06-21  Gabriel Dos Reis <gdr@integrable-solutions.net>

	PR c++/10915
	* decl.c (grok_op_properties): Warn possible confusing conversion
	only if -Wconversion.

2003-06-20  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10749
	* parser.c (cp_parser_class_head): See through dependent names
	when parsing a class-head.

	PR c++/10845
	* pt.c (try_class_unification): Correct handling of member class
	templates.

2003-06-20  Nathan Sidwell  <nathan@codesourcery.com>

	* semantics.c (genrtl_finish_function): Adjust
	expand_function_end call.

2003-06-19  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10939
	* pt.c (tsubst_decl): Do not try to substitute into non-dependent
	functions.
	(value_dependent_expression_p): Correct logic for FUNCTION_DECLs.

	PR c++/9649
	* cp-tree.h (pushdecl_class_level): Change prototype.
	(push_class_level_binding): Likewise.
	* decl.c (add_binding): Reject duplicate static data members.
	(pushdecl_class_level): Return a value indicating whether or not
	the binding was valid.
	(push_class_level_binding): Likewise.
	* semantics.c (finish_member_declaration): Don't keep invalid
	declarations.

	PR c++/11041
	* call.c (initialize_reference): Do not use cp_finish_decl to emit
	temporary variables.
	* cp-tree.h (static_aggregates): Declare.
	(pushdecl_top_level_and_finish): Likewise.
	* decl.c (pushdecl_top_level_1): New function.
	(pushdecl_top_level): Use it.
	(pushdecl_top_level_and_finish): New function.
	(initialize_local_var): Remove redundant code.
	(cp_finish_decl): Remove support for RESULT_DECLs.  Don't check
	building_stmt_tree.
	* decl.h (static_aggregates): Remove.
	* decl2.c (get_guard): Use pushdecl_top_level_and_finish.
	* rtti.c (get_tinfo_decl): Use pushdecl_top_level_and_finish.
	(tinfo_base_init): Likewise.

2003-06-19  Matt Austern  <austern@apple.com>

	PR c++/11228
	* init.c (build_zero_init): Assert that number of array elements
	is an integer constant.
	(build_default_init) Don't use build_zero_init for arrays with
	variable number of elements.

2003-06-19  Andreas Jaeger  <aj@suse.de>

	* cp-tree.h: Remove duplicated declarations.

2003-06-18  Nathanael Nerode  <neroden@gcc.gnu.org>

	* pt.c: Convert to ISO C.
	* semantics.c: Convert to ISO C.

2003-06-18  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (comp_except_specs, compparms, cp_has_mutable_p,
	at_least_as_qualified_p, more_qualified_p): Return bool.
	* typeck.c: ANSIFY function definitions.
	(comp_array_types): Take redeclaration bool parameter.
	(comptypes): Rearrange STRICT handling.
	(at_least_as_qualified_p, more_qualified_p,
	comp_cv_qualification): Cache cv quals.
	(compparms): Rearrange loop.

2003-06-18  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (COMPARE_RELAXED): Rename to ...
	(COMPARE_DERIVED): ... here. Adjust comment.
	(resolve_typename_type_in_current_instantiation): Remove.
	(cp_tree_equal, comptypes): Return a bool.
	* cvt.c (convert_to_reference): Adjust comptypes call.
	* pt.c (template_args_equal, unify,): Adjust cp_tree_equal call.
	(resolve_typename_type_in_current_instantiation): Remove.
	* tree.c (cp_tree_equal): Return bool. Cope with TEMPLATE_DECLs and
	IDENTIFIER_NODEs. Abort if undeciderable. Adjust recursive
	calls. Refactor code.
	* typeck.c (comp_array_types): Return bool. Lose callback.
	parameter. Adjust cp_tree_equal calls.
	(comptypes): Return bool. Adjust strict handling. Remove relaxed
	enumeration and java type handling. Deal with typename types here.
	Adjust recursive and cp_tree_equals calls. Adjust base and derived
	checking.
	(comp_target_types): Remove unreachable code. Adjust
	same_or_base_type_p calls.
	(ptr_reasonably_similar): Adjust base and derived check.

	* typeck.c (maybe_warn_about_returning_address_of_local): Remove
	unused calculation.
	(check_return_expr): Adjust error messages.
	* cp-tree.def (SCOPE_REF): Correct comment.

2003-06-17  Mark Mitchell  <mark@codesourcery.com>

	* mangle.c (mangle_conv_op_name_for_type): Correct sprintf format
	string again.

2003-06-17  Robert Abeles  <rabeles@archaelogic.com>

	* optimize.c (dump_function): Form complete flag name by
	prefixing 'fdump-' to string returned by dump_flag_name().

2003-06-17  Mark Mitchell  <mark@codesourcery.com>

	* mangle.c (mangle_conv_op_name_for_type): Correct sprintf format
	string.

2003-06-17  Jason Merrill  <jason@redhat.com>

	PR c++/10929
	* decl.c (grokfndecl): Don't mark a function inline for
	-finline-functions if it isn't defined.

2003-06-17  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10712
	* class.c (handle_using_decl): Robustify.

	PR c++/11105
	* cp-tree.h (DECL_CONV_FN_TYPE): New method.
	* mangle.c (struct globals): Remove internal_mangling_p.
	(write_unqualified_name): Use DECL_CONV_FN_TYPE.
	(write_template_parm): Don't write out the level number.
	(conv_type_names): New variable.
	(hash_type): New function.
	(compare_type): Likewise.
	(mangle_conv_op_name_for_type): Don't try to mangle conversion
	operator names.
	* search.c (lookup_conversion_operator): New function.
	(lookup_fnfields_1): Use it.

2003-06-17  Andreas Jaeger  <aj@suse.de>

	* except.c: Remove duplicate declaration of push_eh_cleanup.

	* call.c: Remove extra declaration of inhibit_warnings.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	2003-06-16  Jens-Michael Hoffmann  <jensmh@gmx.de>
	* mangle.c: Convert to ISO C.

2003-06-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cp/decl.c, cp/pt.c, cp/search.c, cp/tree.c: Don't use the PTR
	macro.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* tree.c: Convert to ISO C.

2003-06-16  Kazu Hirata  <kazu@cs.umass.edu>

	* cp-tree.h: Follow spelling conventions.
	* mangle.c: Likewise.
	* method.c: Likewise.
	* parser.c: Likewise.

2003-06-14  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (start_function): Adjust init_function_start call.
	* method.c (use_thunk): Likewise.
	* semantics.c (genrtl_start_function): Likewise.

2003-06-14  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Remove c-options.o.

2003-06-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* lex.c: Convert to ISO C.

	2003-05-19  Jens-Michael Hoffmann  <jensmh@gmx.de>
	* init.c: removes use of PARAMS macro.  Use ISO style function
	declarations.  (Not copyright-significant change.)

	* rtti.c: Remove PARAMS.

	* typeck2.c: Convert to ISO C.

2003-06-12  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10635
	* typeck.c (build_c_cast): Check that the destination type is
	complete.

2003-06-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10432
	* cp-tree.h (finish_declarator): Remove.
	* decl.c (cp_finish_decl): Make sure to pop_nested_class even for
	erroneous declarations.
	* semantics.c (finish_declarator): Remove.

2003-06-11  Roger Sayle  <roger@eyesopen.com>

	* decl2.c (generate_ctor_or_dtor_function): Avoid expanding a
	global static constructor/destructor if it will be empty, i.e.
	either doesn't call any ctors/dtors or only calls pure or const
	ctors/dtors.

2003-06-11  Mark Mitchell  <mark@codesourcery.com>

	* mangle.c (tm_p.h): Include it.
	* Make-lang.in (cp/mangle.o): Depend on $(TM_P_H).

	PR c++/11131
	* tree.c (cp_cannot_inline_fn): Check for "inline" before
	instantiation.

2003-06-10  Jason Merrill  <jason@redhat.com>

	PR c++/10968
	* pt.c (mark_decl_instantiated): Clear DECL_COMDAT.

2003-06-10  Andrew Pinski  <pinskia@physics.uc.edu>

	* decl.c (start_cleanup_fn): Move static 'counter' out, mark with GTY.
	(start_cleanup_cnt): New.

2003-06-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11131
	* cp-tree.h (template_for_substitution): Declare.
	* decl2.c (mark_used): Use it when figuring out whether or not a
	function is inline.
	* pt.c (template_for_substitution): Give it external linkage.
	* tree.c (cp_cannot_inline_tree_fn): Instantiate as early as
	possible.

2003-06-09  Zack Weinberg  <zack@codesourcery.com>

	PR 8861
	* mangle.c (write_real_cst): New function.  Implement
	ABI-compliant mangling of floating-point literals when
	-fabi-version>=2; provide backward compatibility with 3.3 when
	-fabi-version=1 (with warning).  Clarify commentary.
	(write_template_arg_literal): Use write_real_cst.

2003-06-07  Andreas Jaeger  <aj@suse.de>

	* cp/decl.c (xref_tag): Remove undefined macro NONNESTED_CLASSES.

2003-06-07  Neil Booth  <neil@daikokuya.co.uk>

	* cp-lang.c (LANG_HOOKS_DECODE_OPTON): Drop.
	(LANG_HOOKS_HANDLE_OPTION): Override.
	* cp-tree.h (cxx_init_options): Update.
	* lex.c (cxx_init_options): Update.

Thu Jun  5 18:33:40 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* Make-lang.in:  Add support for stageprofile and stagefeedback

2003-06-04  J"orn Rennecke <joern.rennecke@superh.com>

	* decl.c (grokdeclarator): Error_mark_node in, error_mark_node out.

2003-06-04  Andreas Jaeger  <aj@suse.de>

	* g++spec.c (lang_specific_driver): Remove ALT_LIBM usage.

2003-06-03  Jason Merrill  <jason@redhat.com>

	* cp/cp-tree.h (CP_AGGREGATE_TYPE_P): Accept vectors.

	* cp/decl.c (reshape_init): Handle vectors.

	* testsuite/g++.dg/init/array10.C: New.

2003-06-03  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10940
	* pt.c (check_explicit_specialization): Check for 'static'
	earlier.

2003-05-31  Diego Novillo  <dnovillo@redhat.com>

	* class.c (dump_array): Call CONSTRUCTOR_ELTS to access
	the operand of a CONSTRUCTOR node.

2003-05-31  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* decl.c (cp_binding_level::this_entity): Rename from this_class.
	(cxx_scope_descriptor): New function.
	(cxx_scope_debug): Likewise.
	(push_binding_level): Use it.
	(pop_binding_level): Likewise.
	(suspend_binding_level): Likewise.
	(resume_binding_level): Likewise.
	(pushlevel_class): Adjust use of this_class.
	(pushtag): Likewise.
	(lookup_name_real): Likewise.
	(global_scope_name): New variable.
	(initialize_predefined_identifiers): Initialize it.
	(push_namespace): Use it.
	(make_cxx_scope): New function.
	(pushlevel): Use it.
	(pushlevel_class): Likewise.
	(push_binding_level): Simplify.  Loose the last two arguments.
	(make_binding_level): Remove.
	(initial_push__namespace_scope): New function.
	(push_namespace): Use it.  Simplify.
	(cxx_init_decl_processing): Likewise.
	(declare_namespace_level): Remove.

2003-05-31  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10956
	* pt.c (instantiate_decl): Don't use full template arguments if
	we are dealing with specializations.

2003-05-29  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* decl.c (ENABLE_SCOPE_CHECKING): Rename from DEBUG_BINDING_LEVELS.
	(binding_depth): Unconditionally define.
	(is_class_level): Likewise.
	(indent): Likewise.  Take an indenting parameter.
	(push_binding_level): Remove conditional definittion.
	(pop_binding_level): Likewise.
	(suspend_binding_level): Likewise.
	(resume_binding_level): Likewise.
	(pushlevel): Likewise.
	(pushlevel_class): Likewise.
	(poplevel_class): Likewise.
	(pop_everything): Likewise.

2003-05-27  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* name-lookup.h (global_scope_p): New macro.
	* decl.c (pop_binding_level): Use it.  Don't refer directly to
	global_binding_level.
	(suspend_binding_level): Likewise.
	(global_bindings_p): Likewise.
	(print_other_binding_stack): Likewise.
	(print_binding_stack): Likewise.
	(maybe_push_to_top_level): Likewise.
	(pushdecl_namespace_level): Likewise.
	(cxx_init_decl_processing): Likewise.
	(start_decl): Likewise.
	(cp_finish_decl): Likewise.
	(start_function): Likewise.
	(global_binding_level): Remove.

2003-05-25  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* parser.c (cp_parser_explicit_instantiation): Restore old
	access before template instantiation.

2003-05-23  Geoffrey Keating  <geoffk@apple.com>

	* lang-specs.h: Use -o to specify preprocessor's output file.
	Make -no-integrated-cpp work when building PCH files.

2003-05-23  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10682
	* pt.c (instantiate_class_template): Use DECL_ARTIFICIAL to
	check for implicitly created typedef to an enum.

2003-05-21  Jason Merrill  <jason@redhat.com>

	* init.c (build_vec_delete): Copy the address into a temporary
	variable before calling build_vec_delete_1.
	* decl2.c (delete_sanity): Don't call stabilize_reference.

2003-05-21  Nathan Sidwell  <nathan@codesourcery.com>

	* pt.c (register_specialization): Update the decl's location,
	if necessary.
	(check_explicit_specialization): Likewise.

2003-05-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* error.c (dump_expr): Use HOST_WIDE_INT_PRINT_DOUBLE_HEX.

2003-05-21  Danny Smith  <dannysmith@users.sourceforge.net>

	PR c++/9738
	* decl.c (duplicate_decls): Re-invoke make_decl_rtl
	if the old decl had instantiated DECL_RTL.
	(Base on Richard Henderson 2003-05-13 patch to c-decl.c).

2003-05-19  Matt Austern  <austern@apple.com>

	* lang-options.h: Document -Wno-invalid-offsetof
	* typeck.c (build_class_member_access_expr): Don't complain about
	(Foo *)p->x for non-POD Foo if warn_invalid_offset is zero.

2003-05-18 Andrew Pinski <pinskia@physics.uc.edu>

	* name-lookup.c (free_binding_entry): fix where the GTY markers are.
	(binding_entry_make): Make entry->chain NULL after getting an entry.
	fix the spelling of chain in a comment.
	(binding_table_free): speed up by having temporary variable.
	(binding_table_new): set table->chain to be NULL after allocating
	a table.
	(cxx_binding_make): use gcc_alloc instead of ggc_alloc_cleared and set
	binding->previous to NULL after getting an binding for speed.

2003-05-18  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cp-tree.h (struct lang_type_class): Replace data member tags
	with hash-table nested_udts.
	(CLASSTYPE_NESTED_UTDS): Rename from CLASSTYPE_TAGS.
	* class.c (unreverse_member_declarations): Don't touch
	CLASSTYPE_TAGS.
	(pushclass): Use cxx_remember_type_decls.
	* decl.c (struct cp_binding_level): Replace data member tags with
	hash-table type_decls.
	(pop_binding_level): Handle level->type_decls.
	(kept_level_p): Adjust.
	(poplevel): Remove unused local variable.
	(bt_print_entry): New function.
	(print_binding_level): Use it.
	(push_namespace): Build current_binding_level->type_decls.
	(maybe_process_template_type_declaration): Adjust.
	(pushtag): Likewise.
	(clear_anon_tags): Use binding_table_remove_anonymous_types.
	(gettags): Remove.
	(cxx_remember_type_decls):  Rename from storetags.  Adjust.
	(lookup_tag): Use binding_table_find_anon_type.  Tidy.
	(lookup_tag_reverse): Use binding_table_reverse_maybe_remap.
	(cxx_init_decl_processing): Build global_binding_level->type_decls.
	(store_parm_decls): Remove pointless code.
	* name-lookup.c (free_binding_entry): New variable.
	(ENTRY_INDEX): New macro.
	(struct binding_table_s): New datatype.
	(binding_entry_make): New function.
	(binding_entry_free): Likewise.
	(binding_table_construct): Likewise.
	(binding_table_free): Likewise.
	(binding_table_new): Likewise.
	(binding_table_expand): Likewise.
	(binding_table_insert): Likewise.
	(binding_table_find): Likewise.
	(binding_table_find_anon_type): Likewise.
	(binding_table_reverse_maybe_remap): Likewise.
	(binding_table_remove_anonymous_types): Likewise.
	(binding_table_foreach): Likewise.
	* name-lookup.h (binding_table): New type.
	(binding_entry): Likewise.
	(bt_foreach_proc): Likewise.
	(struct binding_entry_s): New datatype.
	(SCOPE_DEFAULT_HT_SIZE): New macro.
	(CLASS_SCOPE_HT_SIZE): Likewise.
	(NAMESPACE_ORDINARY_HT_SIZE): Likewise.
	(NAMESPACE_STD_HT_SIZE): Likewise.
	(GLOBAL_SCOPE_HT_SIZE): Likewise.
	(binding_table_new): Declare.
	(binding_table_free): Likewise.
	(binding_table_insert): Likewise.
	(binding_table_find_anon_type): Likewise.
	(binding_table_reverse_maybe_remap): Likewise.
	(binding_table_remove_anonymous_types): Likewise.
	(binding_table_foreach): Likewise.
	(binding_table_find): Likewise.
	(cxx_remember_type_decls): Likewise.
	* pt.c (bt_instantiate_type_proc): New function.
	(do_type_instantiation): Use it.
	* search.c (lookup_field_r): Use binding_table_find.

2003-05-18  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* semantics.c (perform_deferred_access_checks): Don't discard
	checked access.

2003-05-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* error.c (cp_error_at, cp_warning_at, cp_pedwarn_at): Eliminate
	libiberty VA_ macros, always use stdarg.
	* rtti.c (create_pseudo_type_info): Likewise.
	* tree.c (build_min_nt, build_min): Likewise.

2003-05-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* ptree.c (cxx_print_type, cxx_print_xnode): Use string
	concatentation on HOST_WIDE_INT_PRINT_* format specifier to
	collapse multiple function calls into one.
	* tree.c (debug_binfo): Likewise.

2003-05-15  Jason Merrill  <jason@redhat.com>

	PR c++/5388
	* call.c (conditional_conversion): Don't consider implicit
	conversions if T2 is a base of T1.
	* cp-tree.h (DERIVED_FROM_P, UNIQUELY_DERIVED_FROM_P): Make boolean.
	(ACCESSIBLY_UNIQUELY_DERIVED_P, PUBLICLY_UNIQUELY_DERIVED_P): Likewise.

	* parser.c (cp_parser_primary_expression): Convert a static data
	member from reference.

2003-05-15  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_op_delete_call): Avoid creating unnecessary types.
	* class.c (instantiate_type): Remove tests for tf_no_attributes.
	* cp-tree.h (tsubst_flags_t): Remove tf_no_attributes.
	(COMPARE_NO_ATTRIBUTES): Remove.
	* typeck.c (comptypes): Do not check COMPARE_NO_ATTRIBUTES.

	PR c++/8385
	* semantics.c (finish_typeof): Refine type-dependency check.

2003-05-13  Jason Merrill  <jason@redhat.com>

	* typeck.c (build_modify_expr): Don't always stabilize the lhs and
	rhs.  Do stabilize the lhs of a MODIFY_EXPR used on the lhs.

2003-05-11  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* method.c (synthesize_method): Call push/pop_deferring_access_checks.

2003-05-11  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10230, c++/10481
	* semantics.c (finish_non_static_data_member): Handle when the
	non-static member is not from a base of the current class type.

2003-05-11  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10552
	* pt.c (tsubst_copy): Handle TEMPLATE_DECL that is a member class
	template and has dependent context.

2003-05-10  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* pt.c (instantiate_decl): Call push/pop_deferring_access_checks.

2003-05-10  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9252
	* cp-tree.h (saved_scope): Remove check_access field.
	(tsubst_flags_t): Remove tf_parsing.
	* decl.c (maybe_push_to_top_level): Don't initialize
	scope_chain->check_access.
	(make_typename_type, make_unbound_class_template): Don't use
	tf_parsing.
	(register_dtor_fn): Use push/pop_deferring_access_checks
	instead of scope_chain->check_access.
	* method.c (use_thunk): Likewise.
	* parser.c (cp_parser_explicit_instantiation
	(cp_parser_constructor_declarator_p): Don't call
	push/pop_deferring_access_checks here.
	(cp_parser_template_argument, cp_parser_class_name): Don't use
	tf_parsing.
	(yyparse): Check flag_access_control.
	* pt.c (instantiate_class_template): Call
	push/pop_deferring_access_checks.
	* semantics.c (push_deferring_access_checks): Propagate
	dk_no_check.
	(perform_or_defer_access_check): Make sure basetype_path is
	a type before comparison.
	* call.c (build_op_delete_call, build_over_call): Use
	perform_or_defer_access_check.
	* class.c (alter_access): Likewise.
	* init.c (build_offset_ref): Likewise.
	* lex.c (do_identifier): Likewise.
	* method.c (hack_identifier): Likewise.
	* search.c (lookup_member): Likewise.
	* semantics.c (finish_non_static_data_member): Likewise.
	(simplify_aggr_init_exprs_r): Use push/pop_deferring_access_checks
	instead of flag_access_control.

2003-05-10  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9554
	* parser.c (cp_parser_class_name): Remove check_access parameter.
	All caller adjusted.  Update declaration.
	(cp_parser_lookup_name): Likewise.
	* semantics.c (push_deferring_access_checks): Change parameter type
	to enum deferring_kind.  All caller adjusted.
	(resume_deferring_access_checks): Adjust to use new enum.
	(stop_deferring_access_checks): Likewise.
	(perform_or_defer_access_check): Likewise.
	* cp-tree.h (deferring_kind): New enum.
	(deferred_access): Adjust field type.
	(push_deferring_access_checks): Update declaration.

2003-05-09  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10555, c++/10576
	* pt.c (lookup_template_class): Handle class template with
	multiple levels of parameters when one of the levels contain
	errors.

2003-05-08  Jason Merrill  <jason@redhat.com>

	* init.c (build_new_1): Don't reuse a TARGET_EXPR in an
	expression.  Undo some of the recent reorg.

2003-05-07  Richard Henderson  <rth@redhat.com>

	PR c++/10570
	* cfns.gperf: Comment out POSIX thread cancellation points,
	plus abort and raise.
	* cfns.h: Regenerate.

2003-05-07  Jason Merrill  <jason@redhat.com>

	* call.c (build_conditional_expr): Don't assume that the folded
	expression has result_type.

2003-05-06  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* typeck.c (build_unary_op): Deal with const qualifier in
	invalid pointer-to-member earlier.

2003-05-05  Jason Merrill  <jason@redhat.com>

	PR c++/9537
	* call.c (conditional_conversion): Build an RVALUE_CONV if
	we're just changing the cv-quals.
	(build_conditional_expr): Don't call convert to change
	cv-quals.

2003-05-05  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10496
	* typeck.c (build_unary_op): Don't output const qualifier when
	output invalid pointer-to-member diagnostics.

2003-05-05  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* decl.c: Fix typos.

2003-05-05  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/4494
	* decl.c (start_function): Use same_type_p to check return type
	of main.

2003-05-03  Zack Weinberg  <zack@codesourcery.com>

	PR c/10604
	* cp/typeck.c (build_x_compound_expr): No need to check
	extra_warnings as well as warn_unused_value.

2003-05-03  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9364, c++/10553, c++/10586
	* decl.c (make_typename_type): Don't crash on illegal code.

2003-05-03  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (finish_struct): Use location_t and input_location
	directly.
	* decl.c (make_label_decl): Likewise.
	(use_label): Likewise.
	* decl2.c (warn_if_unknown_interface): Likewise.
	(start_static_initialization_or_destruction): Likewise.
	(generate_ctor_or_dtor_function): Likewise.
	(finish_file): Likewise.
	* error.c (print_instantiation_full_context): Likewise.
	* init.c (create_temporary_var): Likewise.
	* method.c (synthesize_method): Likewise.
	* parser.c (cp_token): Likewise.
	(cp_lexer_set_source_position_from_token): Likewise.
	(cp_lexer_get_preprocessor_token): Likewise.
	(cp_parser_statement): Likewise.
	* pt.c (tsubst_friend_function): Likewise.
	(instantiate_class_template): Likewise.
	(tsubst_decl): Likewise.
	(tsubst): Likewise.
	(instantiate_decl): Likewise.
	* semantics.c (begin_class_definition): Likewise.
	(expand_body): Likewise.

2003-05-01  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (finish_struct): Rename lineno to input_line.
	* decl.c (push_binding_level, pop_binding_level,
	suspend_binding_level, resume_binding_level, make_label_decl,
	use_label, start_function): Likewise.
	* decl2.c (warn_if_unknown_interface,
	start_static_initialization_or_destruction,
	generate_ctor_or_dtor_function, finish_file): Likewise.
	* error.c (cp_line_of, print_instantiation_full_context,
	print_instantiation_context): Likewise.
	* except.c (check_handlers_1, check_handlers): Likewise.
	* init.c (create_temporary_var): Likewise.
	* method.c (use_thunk, synthesize_method): Likewise.
	* parser.c (cp_lexer_set_source_position_from_token,
	cp_lexer_get_preprocessor_token): Likewise.
	* pt.c (push_tinst_level, pop_tinst_level,
	tsubst_friend_function, instantiate_class_template, tsubst_decl,
	tsubst, tsubst_expr, instantiate_decl): Likewise.
	* semantics.c (genrtl_try_block, finish_label_stmt,
	begin_class_definition, expand_body,
	genrtl_finish_function): Likewise.
	* tree.c (build_min_nt, build_min): Likewise.

2003-05-01  Mark Mitchell  <mark@codesourcery.com>

	* decl2.c (comdat_linkage): Don't externalize explicit
	instantiations.

2003-05-01  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10554
	* decl2.c (do_class_using_decl): Check if operand 0 of SCOPE_REF
	is not NULL.

2003-05-01  Steven Bosscher  <steven@gcc.gnu.org>

	* cp-tree.h (struct lang_id2): Remove.  Move fields from here...
	(struct lang_identifier): ... to here.
	(LANG_ID_FIELD): Remove.
	(SET_LANG_ID): Remove.
	(IDENTIFIER_LABEL_VALUE): Adjust for new lang_identifier.
	(SET_IDENTIFIER_LABEL_VALUE): Likewise.
	(IDENTIFIER_IMPLICIT_DECL): Likewise.
	(SET_IDENTIFIERL_IMPLICIT_DECL): Likewise.
	(IDENTIFIER_ERROR_LOCUS): Likewise.
	(SET_IDENTIFIER_ERROR_LOCUS): Likewise.

2003-05-01  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8772
	* pt.c (convert_template_argument): Correct diagnostic.

2003-04-30  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9432, c++/9528
	* decl2.c (validate_nonmember_using_decl): Handle SCOPE_REF.

2003-04-30  Garbiel Dos Reis  <gcc@integrable-solutions.net>

	* decl.c (check_previous_goto_1): Adjust prototype.
	(check_previous_goto): Adjust use.
	(check_switch_goto): Likewise.
	(use_label): Adjust.
	(check_previous_goto_1): Don't use pedwarn_with_file_and_line.
	(struct named_label_use_list): Use location_t datatype.

2003-04-29  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10551
	* pt.c (mark_decl_instantiated): Defer all explicit instantiations
	that have not yet been written out.

2003-04-29  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10549
	* class.c (layout_class_type): Mark overlong bitfields as having
	the maximum size permitted by their type, after layout.

	PR c++/10527
	* error.c (dump_expr): Correctly handling of NEW_EXPR.4

2003-04-29  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* call.c (build_operator_new_call): Fix typo.
	* lang-options.h: Likewise.

2003-04-29  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10515
	* cp-tree.h (lookup_field_1): Declare it.
	* search.c (lookup_field_1): Make it public.
	* decl.c (reshape_init): Handle designated initializers.

	* decl.c (maybe_commonize_var): Further tweak support for systems
	without weak symbols.

2003-04-27  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (maybe_commonize_var): Fix thinko in last patch.

2003-04-27  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10506
	* method.c (use_thunk): Decrement immediate_size_expand.

	PR c++/10503
	* cp-tree.h (DECL_VAR_MARKED_P): New macro.
	(DECL_MAYBE_TEMPLATE): Remove.
	* class.c (fixed_type_or_null): Avoid infinite recursion.

	* decl.c (maybe_commonize_var): Make the code match the comments.
	* pt.c (instantiate_decl): Move call to import_export_decl.

2003-04-26  Mark Mitchell  <mark@codesourcery.com>

	* decl2.c (finish_file): Fix merge botch.

2003-04-25  Mark Mitchell  <mark@codesourcery.com>

	* decl2.c (finish_file): Don't call import_export_decl for
	functions that are not defined.
	(handle_class_head): Robustify.
	* pt.c (instantiate_decl): Do not call cp_finish_decl for
	variables that are not defined.

2003-04-24  Sylvain Pion  <Sylvain.Pion@mpi-sb.mpg.de>

	* call.c (print_z_candidates): Fix off by one error.

2003-04-24  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10337
	* call.c (joust): Don't warn about conversion ops that are exact
	or cv-conversions. Rearrange to avoid multiple type comparisons.

2003-04-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10471
	* call.c (build_cxx_call): Robustify.

2003-04-23  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in (lex.o): Remove mbchar.h.
	* lex.c (MULTIBYTE_CHARS): Lose.
	* parser.c (cp_lexer_get_preprocessor_token): CPP_OTHER handled
	in c-lex.c.

2003-04-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9847
	* cp-tree.h (duplicate_tag_error): Remove.
	* class.c (duplicate_tag_error): Remove.
	* semantics.c (begin_class_definition): Return immediately for a
	duplicate class definition.

	PR c++/10451
	* decl.c (grokdeclarator): Correct logic for "mutable" errors.

2003-04-22  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10446
	* search.c (lookup_fnfields_1): Handle empty slots in the method
	vector.

	PR c++/10428
	* decl.c (check_elaborated_type_specifier): New function, split
	out from ...
	(xref_tag): ... here.  Use the new function in more places.

	* rtti.c (throw_bad_typeid): Use build_cxx_call.

2003-04-21  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_over_call): Use build_cxx_call.
	(build_cxx_call): New method, split out of build_over_call.
	* cp-tree.h (language_function): Add can_throw.
	(build_cxx_call): Declare it.
	* decl.c (finish_function): If a function does not contain any
	calls to functions that can throw an exception, indicate that
	fact.
	* decl2.c (mark_used): Do not defer the instantiation of
	functions, if the current function does not throw.
	* optimize.c (maybe_clone_body): Copy TREE_NOTHROW to the clones.
	* pt.c (instantiate_decl): Make sure import_export_decl is called
	before emitting things.
	* rtti.c (throw_bad_cast): Use build_cxx_call.
	(build_dynamic_cast_1): Likewise.
	* typeck.c (build_function_call): Likewise.

2003-04-21  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9881
	* typeck.c (build_unary_op): Fold all COMPONENT_REF addr
	expressions. Reverts my 2002-08-08 patch.

	* typeck.c (comp_ptr_ttypes_real): Swap final && operands for
	cheaper early exit.

2003-04-20  Nathan Sidwell  <nathan@codesourcery.com>

	* cp/decl2.c (start_static_storage_duration_function): Take count
	arg, don't check if it wraps round.
	(generate_ctor_or_dtor_function): Add locus arg, use it.
	(generate_ctor_and_dtor_functions_for_priority): Data arg is a
	locus.
	(finish_file): Set line numbers to past EOF for synthesized
	functions.

2003-04-20  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10405
	* search.c (lookup_field_1): Final scan goes backwards for
	types, forwards for non-types.

2003-04-17  Roger Sayle  <roger@eyesopen.com>

	PR c/10375
	* decl.c (duplicate_decls): Preserve "const", "noreturn" and
	"nothrow" function attributes.

2003-04-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/10347
	* pt.c (type_dependent_expression_p): Handle array new.

2003-04-15  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10381
	* parser.c (cp_parser_primary_expression): Reorganize logic for
	dealing with name lookup failures.

2003-04-15  Jason Merrill  <jason@redhat.com>

	* decl2.c (mark_used): Don't instantiate anything if
	skip_evaluation.

2003-04-14  Ziemowit Laski  <zlaski@apple.com>

	* tree.c (build_cplus_array_type_1): Do not call
	uses_template_parms() on a NULL index_type.

2003-04-13  Roger Sayle  <roger@eyesopen.com>

	* decl.c (duplicate_decls): Preserve pure and malloc attributes.

2003-04-12  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10300
	* init.c (build_new_1): Reorganize.

2003-04-12  Zack Weinberg  <zack@codesourcery.com>

	* class.c (initialize_array)
	* decl.c (reshape_init)
	* decl2.c (build_expr_from_tree)
	* init.c (build_zero_init)
	* pt.c (tsubst_copy, tsubst_copy_and_build)
	* rtti.c (tinfo_base_init, generic_initializer, ptr_initializer)
	(ptm_initializer, class_initializer, get_pseudo_ti_init)
	* semantics.c (finish_compound_literal)
	* typeck.c (build_ptrmemfunc1)
	* typeck2.c (store_init_value, process_init_constructor)
	(build_functional_cast): Use build_constructor.

2003-04-12  Zack Weinberg  <zack@codesourcery.com>

	* call.c (print_z_candidates): Use gcc_gettext_width, not
	strlen, to determine how much padding to use.

2003-04-10  Zack Weinberg  <zack@codesourcery.com>

	* decl.c: Update all calls to shadow_warning.

2003-04-10  Mark Mitchell  <mark@codesourcery.com>

	* class.c (layout_class_type): Correct handling for overlong
	bit-fields whose width is the same as an integer type.

2003-04-06  Zack Weinberg   <zack@codesourcery.com>

	* cp-tree.def: Make fourth element for all 'c' and 'x' nodes zero.
	* cp-lang.c (cp_tree_size): New function.
	(LANG_HOOKS_TREE_SIZE): Override.

	* cp-tree.h (SOURCE_LOCUS, SRCLOC_FILE, SRCLOC_LINE, struct
	tree_srcloc, TS_CP_COMMON, TS_CP_SRCLOC): Kill.
	(union lang_tree_node): Remove common and srcloc members.
	(build_srcloc_here): Don't prototype.
	* decl.c (cp_tree_node_structure): Kill SRCLOC case.
	* pt.c (pending_templates): Correct comment.
	* tree.c (build_srcloc, build_srcloc_here): Kill.

2003-04-06  Zack Weinberg   <zack@codesourcery.com>

	* call.c: Include intl.h.
	(print_z_candidate): Always use inform; get rid of errfn
	argument. Reorganize so that all the strings get picked up
	by xgettext.  Note obligation of caller to pass first argument
	through gettext.
	(print_z_candidates): Update to match.  Indent second and
	successive candidates by strlen() of translated message.
	(joust): Restructure ambiguous-conversion pedwarn so that
	translators see a complete sentence.  Update calls to
	print_z_candidate.

	* Make-lang.in (cp/call.o): Update dependencies.

2003-04-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (set_current_binding_level): Delete, revert last change.
	(current_binding_level): Modify to allow it as as lvalue.

2003-04-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* name-lookup.c (find_binding): Pass appropriate pointer type to
	POP_TIMEVAR_AND_RETURN.

2003-04-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (cp-warn): Add $(STRICT_WARN).
	* cp-tree.h: Don't insist on having GNUC.

2003-04-03  Jason Merrill  <jason@redhat.com>

	* cvt.c (ocp_convert): Only abort if we try to convert an object
	of TREE_ADDRESSABLE type.

	* class.c (build_vtable): Set DECL_ALIGN here.
	(get_vtable_decl): Not here.
	(layout_vtable_decl): Or here.
	(create_vtable_ptr): Or here.
	(layout_class_type): Or here.
	(check_bitfield_decl): Don't mess with field alignment.

2003-04-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* operators.def (DEF_SIMPLE_OPERATOR, DEF_ASSN_OPERATOR,
	DEF_ASSN_OPERATOR): Delete spurious semi-colon.
	* rtti.c (dfs_class_hint_mark): Likewise.

	* decl.c (push_local_name, push_class_level_binding,
	maybe_inject_for_scope_var): Don't use POP_TIMEVAR_AND_RETURN in
	functions returning void.
	* decl2.c (add_using_namespace): Likewise.

	* decl.c (print_binding_level, print_other_binding_stack,
	print_binding_stack): Cast argument of %p specifier to void*.
	* ptree.c (cxx_print_decl): Likewise.

	* cp-tree.h (VAR_OR_FUNCTION_DECL_CHECK,
	VAR_FUNCTION_OR_PARM_DECL_CHECK,
	VAR_TEMPL_TYPE_OR_FUNCTION_DECL_CHECK, RECORD_OR_UNION_TYPE_CHECK,
	BOUND_TEMPLATE_TEMPLATE_PARM_TYPE_CHECK, LANG_TYPE_CLASS_CHECK,
	LANG_TYPE_PTRMEM_CHECK, LANG_DECL_U2_CHECK): Add __extension__.

	* decl.c (set_current_binding_level): New macro.  Use throughout
	when setting the current binding level.

	* cp-tree.h (cp_lvalue_kind, base_access): Delete trailing comma
	in enum.
	* method.c (mangling_flags): Likewise.

	* cp-tree.h (lang_type_header): Add __extension__ and use
	CHAR_BITFIELD for members.

2003-04-02  Geoffrey Keating  <geoffk@apple.com>

	PR other/9274
	* mangle.c: Include gt-cp-mangle.h.
	(subst_identifiers): Mark with GTY.
	* config-lang.in (gtfiles): Add cp/mangle.c.
	* Make-lang.in: (gt-cp-mangle.h): New rule.
	(cp/mangle.o): Depends on gt-cp-mangle.h.

2003-04-01  Andrew Pinski  <pinskia@physics.uc.edu>

	* config-lang.in (gtfiles): Add \$(srcdir)/cp/name-lookup.c
	after \$(srcdir)/cp/name-lookup.h.
	* name-lookup.c: (cxx_binding_make): Use ggc_alloc_clearedinstead
	of ggc_alloc.  Include gt-cp-name-lookup.h at the end of the file.
	* Make-lang.in: (gt-cp-name-lookup.h): Is generated by gengtype.
	(cp/name-lookup.o): Depends on gt-cp-name-lookup.h.

2003-03-31  Jason Merrill  <jason@redhat.com>

	PR java/10145
	* class.c (check_field_decl): Don't set DECL_ALIGN.

2003-03-30  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7647
	* decl.c (grokdeclarator): Tidy, slightly.
	* search.c (lookup_field_1): Add want_type parameter.
	(lookup_field_r): Adjust call to lookup_field_1.

2003-03-30  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* Make-lang.in (cp/name-lookup.o): Add more dependencies.

2003-03-30  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* cp-tree.h (binding_for_name: Move to name-lookup.h  Adjust
	prototype.
	(cxx_scope_find_binding_for_name): Likewise.
	* decl.c (find_binding: Move to name-lookup.c.
	(binding_for_name): Likewise.
	(cxx_scope_find_binding_for_name): Likewise.
	(BINDING_LEVEL):  Remove.
	(push_binding): Tidy.
	(push_class_binding): Likewise.
	(pop_binding): Likewise.
	(poplevel): Likewise.
	(poplevel_class): Likewise.
	(set_identifier_type_value_with_scope): Likewise.
	(push_overloaded_decl): Likewise.
	(lookup_tag): Likewise.
	(unqualified_namespace_lookup): Likewise.
	(lookup_name_current_level): Likewise.
	(maybe_inject_for_scope_var): Likewise.
	(namespace_binding): Move to name-lookup.c.
	(set_namespace_binding): Likewise.
	* decl2.c (lookup_using_namespace): Tidy.
	(qualified_lookup_using_namespace): Likewise.
	(do_toplevel_using_decl): Likewise.
	* name-lookup.c: Include "timevar.h"
	* name-lookup.h (cxx_scope):  Declare.
	(struct cxx_binding): Lose member "has_level".  Adjust "scope"
	member declaration.
	(BINDING_SCOPE): Adjust definition.
	(BINDING_HAS_LEVEL_P): Remove.

2003-03-30  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* name-lookup.c: New file.
	* name-lookup.h: Likewise..
	* decl.c (push_binding): Adjust use cxx_binding_make.
	(free_bindings): Move to name-lookup.c
	(pop_binding): Use cxx_binding_free.
	(binding_for_name): Tidy.
	* cp-tree.h: Include "name-lookup.h"
	(cxx_binding_make): Move to name-lookup.h
	(cxx_binding_clear): Likewise.
	(struct cxx_binding): Likewise.
	(LOCAL_BINDING_P): Likewise.
	(INHERITED_VALUE_BINDING_P): Likewise.
	(BINDING_SCOPE): Likewise.
	(BINDING_HAS_LEVEL_P): Likewise.
	(BINDING_VALUE): Likewise.
	(BINDING_TYPE): Likewise.
	* config-lang.in (gtfiles): Add cp/name-lookup.h
	* Make-lang.in (cp/name-lookup.o): New rule.
	(CXX_OBJS): Add cp/name-lookup.o
	(CXX_TREE_H): Add cp/name-lookup.h

2003-03-28  Jason Merrill  <jason@redhat.com>

	PR c++/10245
	* cvt.c (force_rvalue): New fn.
	* call.c (build_conditional_expr): Use it.
	* cp-tree.h: Declare it.

2003-03-28  Mike Stump  <mrs@apple.com>

	* error.c (dump_expr): Add 0x to printed hex numbers to make
	output match source code better.

2003-03-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10218
	* decl.c (grokfndecl): Return NULL_TREE for bogus out-of-class
	definitions.

	* decl2.c (generate_ctor_or_dtor_function): Tolerate a
	non-existant ssdf_decls array.
	(finish_file): Call generator_ctor_or_dtor_function when there are
	static constructors or destructors and no other static
	initializations.

2003-03-28  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10047
	* decl2.c (finish_file): Don't warn about explicitly instantiated
	inline decls.

2003-03-27  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10224
	* pt.c (lookup_template_class): Only check instantiated args if
	they do not contain template parameters.

2003-03-27  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10158
	* parser.c (cp_parser_function_definition): Set
	DECL_INITIALIZED_IN_CLASS for members.
	* pt.c (instantiate_decl): Only reduce the template args for
	friends that are not defined in class.

2003-03-25  Jason Merrill  <jason@redhat.com>

	* call.c (print_z_candidate): Change name of first arg to msgid.
	(joust): Add comment for translators.

2003-03-24  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9898, PR c++/383, DR 322
	* pt.c (maybe_adjust_types_for_deduction) <DEDUCE_CONV>: Look
	through reference types on both PARM and ARG.

2003-03-24  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10119
	* error.c (dump_expr) <BASELINK>: Use dump_expr.
	* pt.c (maybe_fold_nontype_args): New function.
	(tsubst_copy) <SCOPE_REF>: Subst any template_id args.
	<TEMPLATE_ID_EXPR>: Break out folding code, call it.
	(tsubst_copy_and_build) <TEMPLATE_ID_EXPR>: Call
	maybe_fold_nontype_args.

2003-03-24  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/10026
	* decl2.c (arg_assoc_type) <ERROR_MARK>: Don't die.

2003-03-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7086
	* typeck.c (cxx_mark_addressable):  Adjust call to
	gen_mem_addressof or put_var_into_stack.

2003-03-22  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9978, c++/9708
	* cp-tree.h (instantiate_template): Add tsubst_flags parameter.
	* call.c (add_template_candidate_real): Adjust
	instantiate_template call.
	* class.c (resolve_address_of_overloaded_function): Likewise.
	* decl.c (build_enumerator): Set TREE_CONSTANT.
	* pt.c (check_instantiated_args): New.
	(push_inline_template_parms_recursive): Set TREE_CONSTANT,
	TREE_READONLY.
	(build_template_parm_index): Copy TREE_CONSTANT, TREE_READONLY.
	(reduce_template_parm_level): Likewise.
	(process_template_parm): Likewise.
	(check_explicit_specialization): Adjust instantiate_template call.
	(convert_template_argument): Don't check non-type argument here.
	(lookup_template_class): Check them here.
	(tsubst_friend_function): Adjust instantiate_template call.
	(instantiate_template): Add tsubst_flags parameter, use it. Check
	instantiated args.

2003-03-21  Zack Weinberg  <zack@codesourcery.com>

	* decl.c: Update calls to shadow_warning.

2003-03-21  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9898
	* error.c (dump_decl) [CONST_DECL]: Print '<enumerator>'.
	(dump_expr) [CONSTRUCTOR]: Print default ctor as a function call.

2003-03-20  Mark Mitchell  <mark@codesourcery.com>

	* cp/decl2.c (arg_assoc_class): Correct check for namespace-scope
	friends.
	* cp/pt.c (instantiate_class_template): Fix formatting.

2003-03-14  Matt Austern  <austern@apple.com>

	* cp-tree.h (unemitted_tinfo_decls): Declaration of a new varray.
	(unemitted_tinfo_decl_p): Remove.
	(emit_tinfo_decl): Change declaration to remove unused parameter.
	* decl2.c (finish_file): Change tinfo emission to loop through
	unemitted_tinfo_decls array instead of looping through all decls.
	* rtti.c (unemitted_tinfo_decl_p): Declare as static, remove
	unused second parameter.
	(init_rtti_processing): initialize unemitted_tinfo_decls varray.
	(get_tinfo_decls): push new tinfo decl on unemitted_tinfo_decls.
	(emit_tinfo_decl): remove unused second parameter, add assertion
	that decl hasn't already been emitted.

2003-03-19  Nathanael Nerode  <neroden@gcc.gnu.org>

	* dump.c (cp_dump_tree), cp-tree.h (cp_dump_tree): Change return
	type from 'int' to 'bool'. Replace 0 and 1 with true and false in
	return statements.

2003-03-19  Jason Merrill  <jason@redhat.com>

	PR c++/8316, c++/9315, c++/10136
	* call.c (print_z_candidate): Split out from...
	(print_z_candidiates): ...here.
	(joust): Use it.

2003-03-17  Roger Sayle  <roger@eyesopen.com>

	PR c++/10031
	* decl.c (duplicate_decls): Use the new type when prototyping
	anticipated decls, even when the types match.  This defines the
	exception list for the built-in function.

2003-03-17  Jason Merrill  <jason@redhat.com>

	PR c++/10091
	* typeck.c (build_class_member_access_expr): Compare
	TYPE_MAIN_VARIANTs.

2003-03-17  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9639
	* parser.c (cp_parser_declarator_id): Clear parser->scope.

2003-03-16  Jason Merrill  <jason@redhat.com>

	PR c++/9993
	* decl.c (finish_function): Only allow the NRVO to use variables
	declared at function scope.

2003-03-17  Andreas Jaeger  <aj@suse.de>

	* Make-lang.in (cp/TAGS): Remove.

2003-03-16  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9629
	* cp-tree.h (struct language_function): Add in_base_initializer.
	(in_base_initializer): define it.
	(expand_member_init): Remove INIT param.
	* init.c (expand_member_init): Remove INIT param, return the member.
	(emit_mem_initializers): Set in_base_initializer.
	* class.c (build_base_path): Check in_base_initializer.
	* parser.c (cp_parser_mem_initializer): Set in_base_initializer.
	* pt.c (tsubst_initializer_list): Likewise.

2003-03-16   Gabriel Dos Reis <gdr@integrable-solutions.net>

	* decl.c (binding_for_name): Fix initialization thinko.

2003-03-15  Gabriel Dos Reis <gdr@integrable-solutions.net>

	Compile-time improvement: 2/n.
	* cp-tree.h (struct cxx_binding): New datatype;
	(struct lang_identifier): Use it.
	(LOCAL_BINDING_P): Adjust definition.
	(INHERITED_VALUE_BINDING_P): Likewise.
	(BINDING_SCOPE): Likewise.
	(BINDING_HAS_LEVEL_P): Likewise.
	(BINDING_VALUE): Likewise.
	(BINDING_TYPE): Likewise.
	(IDENTIFIER_VALUE): Likewise.
	(struct tree_binding): Remove.
	(TS_CP_BINDING): Likewise.
	((union lang_tree_node): Remove field "binding".
	(cxx_binding_clear): New macro.
	(binding_for_name): Adjust return type.
	(qualified_lookup_using_namespace): Adjust prototype.
	(lookup_using_namespace): Adjust prototype.
	(cxx_scope_find_binding_for_name): Declare.
	* cp-tree.def: Remove CPLUS_BINDING definition.
	* decl.c (push_binding): Adjust local variable type.
	(add_binding): Likewise.
	(push_class_binding): Likewise.
	(pop_binding): Likewise.
	(poplevel): Likewise.
	(poplevel_class): Likewise.
	(free_bindings):  Adjust type.
	(find_binding): Adjust return type, add a third parameter. Remove
	non-useful assertion now that we use static typing.
	(cxx_scope_find_binding_for_name): New function.
	(binding_for_name): Use it.  Adjust local variable type. Simplify.
	(namespace_binding):  Simplify.
	(set_namespace_binding): Likewise.
	(set_identifier_type_value_with_scope): Adjust local variable type.
	(lookup_tag): Don't type-abuse of local variable 'old'.
	(lookup_namespace_name): Likewise.  Allocate binding on stack.
	(select_decl): Adjust prototype.
	(unqualified_namespace_lookup):  Allocate binding on stack.
	Don't type-abuse of local variable 'val'.
	(lookup_name_real): Likewise.
	(maybe_inject_for_scope_var): Adjust local variable type.
	(cp_tree_node_structure): Remove CPLUS_BINDING case label.
	(namespace_binding): Adjust logic, simplify.
	(BINDING_LEVEL): Adjust definition.
	(push_class_level_binding): Adjust local variable type.
	(struct cxx_saved_binding): Adjust field 'binding' type.
	* decl2.c (ambiguous_decl): Adjust prototype.
	(lookup_using_namespace): Adjust local variable type.
	(qualified_lookup_using_namespace): Catch type error and correct
	ensueing logic error.
	(do_nonmember_using_decl): Adjust local variable type.  Allocate
	temporary cxx_binding on stack.
	(do_toplevel_using_decl): Adjust local variable type.
	* ptree.c (cxx_print_cxx_binding): New function.
	(cxx_print_identifier): Use it.
	(cxx_print_xnode): Delete CPLUS_BINDING case label.

2003-03-15  Roger Sayle  <roger@eyesopen.com>

	* tree.c (count_functions): Fix whitespace.

2003-03-15  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Update.

2003-03-15  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/6440
	* pt.c (maybe_process_partial_specialization): Handle
	member class template when enclosing class template is
	explicit specialized.
	(most_general_template): Stop looking when DECL is already
	specialized.

2003-03-13  Jason Merrill  <jason@redhat.com>

	PR c++/9420
	* search.c (lookup_conversions): Call complete_type here.
	* call.c (implicit_conversion): Not here.

2003-03-13  Mark Mitchell  <mark@codesourcery.com>

	* decl2.c (do_nonmember_using_decl): Correct handling of
	simultaneous type/non-type bindings.

	* call.c (initialize_reference): Remove bogus assertion.
	* decl.c (build_ptrmemfunc_type): Revert change of 2003-03-09.

2003-03-12  Andrew Lewycky  <andrew@mxc.ca>

	PR c++/7050
	* expr.c (cxx_expand_expr): Return const0_rtx for throw
	expressions.

2003-03-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9474
	* decl2.c (do_nonmember_using_decl): Do not call duplicate decls
	to merge old and new declarations.

2003-03-12  Alexandre Oliva  <aoliva@redhat.com>

	* g++.1: Remove.
	* Make-lang.in (c++.generated-manpages): Build cp/g++.1.
	(cp/g++.1): Build it from scratch in the build tree.
	(c++.install-man): Depend on it.  Install it from the build tree.
	(c++.mostlyclean): Clean it.

2003-03-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9474
	* decl2.c (do_nonmember_using_decl): Do not call duplicate decls
	to merge old and new declarations.

	PR c++/9924
	* decl2.c (do_nonmember_using_decl): Ignore anticipated builtins.

2003-03-11  Jason Merrill  <jason@redhat.com>

	PR c++/9820
	* search.c (lookup_member): Fix handling of functions in a class
	being defined.

2003-03-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8700
	* call.c (convert_class_to_reference): Adjust usage of
	splice_viable.
	(any_viable): Remove.
	(splice_viable): Combine with any_viable.
	(print_z_candidates): Avoid printing duplicates.
	(build_user_type_conversion_1): Adjust usage of splice_viable.
	(build_new_function_call): Likewise.
	(build_operator_new_call): Likewise.
	(build_object_call): Likewise.
	(build_conditional_expr): Likewise.
	(build_new_op): Likewise.
	(build_new_method_call): Likewise.
	(joust): Remove spurious comment.
	* cp-tree.h (DECL_FRIENDLIST): Correct documentation.
	* decl2.c (arg_assoc_class): Simplify.
	* friend.c (add_friend): Likewise.

2003-03-11  Jason Merrill  <jason@redhat.com>

	PR c++/8660
	* decl2.c (check_classfn): A member template only matches a
	member template.

2003-03-11  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in (CXX_C_OBJS): Update.
	* lang-specs.h: Don't define __GNUG__ here.

2003-03-10  Mark Mitchell  <mark@codesourcery.com>

	* call.c (perform_overload_resolution): New function.
	(build_new_function_call): Use it.
	(build_operator_new_call): Likewise.
	(add_candidates): Add explicit_targs and template_only parameters.
	(build_new_op): Adjust accordingly.
	* cp-tree.h (build_operator_new_call): New function.
	(build_function_call_real): Remove.
	(build_function_call_maybe): Likewise.
	* init.c (build_new_1): Use build_operator_new_call.
	* typeck.c (build_function_call_real): Rename to ...
	(build_function_call): ... this.

2003-03-10  Devang Patel  <dpatel@apple.com>

	PR c++/9394
	* g++spec.c (lang_specific_driver): Use DEFAULT_WORD_SWTCH_TAKES_ARG.

2003-03-10  Jason Merrill  <jason@redhat.com>

	PR c++/9798
	* decl.c (push_using_directive): Push before recursing.

	PR c++/9868, c++/9524
	* call.c (resolve_scoped_fn_name): Handle the case of a function
	pointer member.

	* decl2.c (build_offset_ref_call_from_tree): Only mess with 'this'
	argument in the pointer-to-member case.

2003-03-09  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9373
	* cp-lang.c (cxx_get_alias_set): Use alias set zero for
	pointers to member functions.

	PR c++/8534
	* decl.c (build_ptrmemfunc_type): Do not allow default arugments
	in pointer-to-member-function types.

2003-03-10  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* expr.c (cplus_expand_constant): Use C90 prototype style.
	(cxx_expand_expr): Likewise.

2003-03-09  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9970
	* decl.c (duplicate_decls): Only copy DECL_THUNKS for virtual
	functions.

2003-03-08  Geoffrey Keating  <geoffk@apple.com>

	* lang-specs.h (c++-header): Change .pch to .gch.

2003-03-08  Neil Booth  <neil@daikokuya.co.uk>

	* cp-tree.h (cxx_init): Update prototype.
	* lex.c (cxx_init): Similarly.

2003-03-08  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9823
	* cp-tree.h (begin_mem_initializers): Remove.
	* parser.c (cp_parser_mem_initializer_list): Inline it here.
	Do not call finish_mem_initializers if not in a constructor.
	(cp_parser_class_head): Fix typo in error message.
	* semantics.c (begin_mem_initializers): Remove.
	* testsuite/g++.dg/parser/constructor1.C: New test.

	PR c++/9809
	* call.c (add_function_candidate): Skip builtin fuctions that have
	not yet been declared.

	PR c++/9982
	* init.c (build_new_1): Correct logic for determining whether or
	not to use an array cookie.

	PR c++/9524
	* parser.c (cp_parser_postfix_expression): Call
	finish_non_static_data_member, even when processing_template_decl.

	PR c++/9912
	* cp-tree.h (is_ancestor): New function.
	(handle_class_head): Change prototype.
	* decl2.c (is_namespace_ancestor): Rename to ...
	(namespace_anecestor): ... this.
	(set_decl_namespace): Adjust accordingly.
	(handle_class_head): Remove unncessary parameters.
	* parser.c (cp_parser_class_head): Check that
	nested-name-specifiers are used appropriately.

2003-03-07  Mark Mitchell  <mark@codesourcery.com>

	* call.c (reference_binding): Remove REF_IS_VAR parameter.
	(implicit_conversion): Adjust call to reference_binding.
	(make_temporary_var_for_ref_to_type): Add TYPE parameter.
	(initialize_reference): Adjust handling for references bound to
	rvalues.
	* cp-tree.h (make_temporary_var_for_ref_to_temp): Change
	prototype.
	(real_non_cast_lvalue_p): New method.
	* cvt.c (build_up_reference): Adjust use of
	make_temporary_var_for_ref_to_temp.
	* tree.c (real_non_cast_lvalue_p): New method.

2003-03-07  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* except.c (init_exception_processing): Use C90 prototype style.
	(cp_protect_cleanup_actions): Likewise.
	(prepare_eh_type): Likewise.
	(build_eh_type_type): Likewise.
	(build_exc_ptr): Likewise.
	(do_begin_catch): Likewise.
	(dtor_nothrow): Likewise.
	(do_end_catch): Likewise.
	(push_eh_cleanup): Likewise.
	(decl_is_java_type): Likewise.
	(choose_personality_routine): Likewise.
	(initialize_handler_parm): Likewise.
	(expand_start_catch_block): Likewise.
	(expand_end_catch_block): Likewise.
	(begin_eh_spec_block): Likewise.
	(finish_eh_spec_block): Likewise.
	(do_allocate_exception): Likewise.
	(do_free_exception): Likewise.
	(wrap_cleanups_r): Likewise.
	(stabilize_throw_expr): Likewise.
	(build_throw): Likewise.
	(complete_ptr_ref_or_void_ptr_p): Likewise.
	(is_admissible_throw_operand): Likewise.
	(nothrow_libfn_p): Likewise.
	(can_convert_eh): Likewise.
	(check_handlers_1): Likewise.
	(check_handlers): Likewise.

2003-03-06  Mark Mitchell  <mark@codesourcery.com>

	* call.c (merge_conversion_sequences): New function.
	(build_conv): Set ICS_USER_FLAG for USER_CONVs.
	(convert_class_to_reference): Correct handling of second
	standard conversion sequence in a user-defined conversion
	sequence.
	(build_user_type_conversion_1): Use merge_conversion_sequences.
	* cp-tree.def: Add comments for CONV nodes.
	* rtti.c (get_tinfo_decl): Use build_address/build_nop.

2003-03-07  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* error.c (init_error): Use C90 prototype style.
	(dump_scope): Likewise.
	(dump_qualifiers): Likewise.
	(dump_template_argument): Likewise.
	(dump_template_argument_list): Likewise.
	(dump_template_parameter): Likewise.
	(dump_template_bindings): Likewise.
	(dump_type): Likewise.
	(dump_typename): Likewise.
	(class_key_or_enum): Likewise.
	(dump_aggr_type): Likewise.
	(dump_type_prefix): Likewise.
	(dump_type_suffix): Likewise.
	(dump_global_iord): Likewise.
	(dump_simple_decl): Likewise.
	(dump_decl): Likewise.
	(dump_template_decl): Likewise.
	(dump_function_decl): Likewise.
	(dump_parameters): Likewise.
	(dump_exception_spec): Likewise.
	(dump_function_name): Likewise.
	(dump_template_parms): Likewise.
	(dump_char): Likewise.
	(dump_expr_list): Likewise.
	(dump_expr): Likewise.
	(dump_binary_op): Likewise.
	(dump_unary_op): Likewise.
	(type_as_string): Likewise.
	(expr_as_string): Likewise.
	(decl_as_string): Likewise.
	(context_as_string): Likewise.
	(lang_decl_name): Likewise.
	(cp_file_of): Likewise.
	(cp_line_of): Likewise.
	(decl_to_string): Likewise.
	(expr_to_string): Likewise.
	(fndecl_to_string): Likewise.
	(code_to_string): Likewise.
	(language_to_string): Likewise.
	(parm_to_string): Likewise.
	(op_to_string): Likewise.
	(type_to_string): Likewise.
	(assop_to_string): Likewise.
	(args_to_string): Likewise.
	(cv_to_string): Likewise.
	(cxx_print_error_function): Likewise.
	(cp_diagnostic_starter): Likewise.
	(cp_diagnostic_finalizer): Likewise.
	(cp_print_error_function): Likewise.
	(function_category): Likewise.
	(print_instantiation_full_context): Likewise.
	(print_instantiation_partial_context): Likewise.
	(maybe_print_instantiation_context): Likewise.
	(print_instantiation_context): Likewise.
	(cp_printer): Likewise.
	(print_integer): Likewise.
	(print_non_consecutive_character): Likewise.
	(locate_error): Likewise.

2003-03-06  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9965
	* call.c (reference_binding): Add ref_is_var parameter.
	(implicit_conversion): Adjust call to reference_binding.
	(initialize_reference): Likewise.

	PR c++/9400
	* decl.c (pushdecl): Don't check for shadowing of DECL_ARTIFICIAL
	PARM_DECLs.

	PR c++/9791
	* class.c (get_basefndecls): Use lookup_fnfields_1.

2003-03-06  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9188
	* parser.c (cp_parser_type_parameter): Remove redundant `expect'
	in error message.
	(cp_parser_single_declaration): Likewise.

2003-03-05  Jason Merrill  <jason@redhat.com>

	PR c++/9440
	* call.c (build_conditional_expr): Use convert rather than an
	explicit NOP_EXPR.

2003-03-02  Matt Austern  <austern@apple.com>

	* decl.c (cp_binding_level): Add static_decls varray member.
	(add_decl_to_level): Add static/inline namespace scope
	declarations to static_decls array.
	(wrapup_global_for_namespace): Pass static_decls only, instead of
	all decls, to wrapup_global_declarations/check_global_declarations.
	(push_namespace): Initialize static_decls for ordinary namespaces.
	(cxx_init_decl_processing): Initialize static_decls for global
	namespace.

2003-03-05  Mark Mitchell  <mark@codesourcery.com>

	* class.c (end_of_class): Correct thinko.

2003-03-04  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config-lang.in: Replace ${libstdcxx_version} by its value.

2003-03-04  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* cp-tree.h (cxx_saved_binding): Declare.
	(struct saved_scope): Adjust type of field 'old_binding'.
	* decl.c (cxx_saved_binding_make): New macro.
	(struct cxx_saved_binding): Define.
	(store_bindings): Adjust prototype.  Use cxx_saved_binding to save
	C++ bindings.
	(maybe_push_to_top_level): Adjust local variable type.
	(pop_from_top_level): Likewise.

2003-03-04  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (c++.tags): New target.

2003-03-04  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Update.

2003-03-03  Jason Merrill  <jason@redhat.com>

	* decl.c (finish_enum): Do set the type in a template. Simplify.
	* pt.c (tsubst_enum, tsubst_copy): Revert last patch.

2003-03-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9878
	* call.c (convert_class_to_reference): Correct conversion
	sequences.
	(reference_binding): Add ref_bound_directly_to_rvalue_p parameter.
	(implicit_conversion): Adjust call to reference_binding.
	(add_candidate): Change type of candidates parameter.
	(add_function_candidate): Likewise.
	(add_conv_candidate): Likewise.
	(build_builtin_candidate): Likewise.
	(add_builtin_candidate): Likewise.
	(add_builtin_candidates): Likewise.
	(add_template_candidate_real): Likewise.
	(add_template_candidate): Likewise.
	(add_template_conv_candidate): Likewise.
	(build_user_type_conversion_1): Adjust accordingly.
	(build_object_call): Likewise.
	(build_conditional_expr): Likewise.
	(add_candidates): Likewise.
	(build_new_op): Likewise.
	(convert_like_real): Use USER_CONV_CAND.  Use build_nop.
	(build_new_method_call): Adjust calls to add_function_candidate.
	(make_temporary_var_for_ref_to_temp): New function.
	(initialize_reference): Add decl parameter.
	* class.c (build_rtti_vtbl_entries): Use build_address and
	build_nop.
	* cp-tree.h (initialize_reference): Change prototype.
	(make_temporary_var_for_ref_to_temp): New function.
	(build_type_conversion): Change prototype.
	(build_address): New function.
	(build_nop): Likewise.
	* cvt.c (cp_convert_to_pointer): Adjust call to
	build_type_conversion.  Avoid indicating redundant NOP_EXPRs.
	Use build_nop.
	(convert_to_pointer_force): Use build_nop.
	(build_up_reference): Use make_temporary_var_for_ref_to_temp.
	(convert_to_reference): Adjust call to build_type_conversion.
	(ocp_convert): Likewise.
	(build_type_conversion): Remove for_sure parameter.
	* decl.c (grok_reference_init): Use initialize_reference.
	* typeck.c (build_address): New function.
	(build_nop): Likewise.
	(build_unary_op): Use them.
	(build_ptrmemfunc): Tidy slightly.
	(convert_for_initialization): Adjust call to
	initialize_reference.
	* typeck2.c (store_init_value): Remove #if 0'd code.

2003-03-03  Jason Merrill  <jason@redhat.com>

	* decl.c (start_function): Clear DECL_NUM_STMTS.

	* class.c (get_vtable_decl): Use vtbl_type_node.
	(build_primary_vtable): Check for it.

2003-03-02  Aldy Hernandez  <aldyh@redhat.com>

	* decl.c (check_initializer): Check for vector_opaque_p.

2003-03-02  Ashif Harji  <asharji@uwaterloo.ca>

	* lang-specs.h (default_compilers): Add -no-integrated-cpp flag to
	  invoke an external cpp during compilation.

2003-03-01  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* decl.c (duplicate_decls): Convert use of warning_with_decl() to
	that of warning().
	(start_decl): Likewise.
	(start_function): Likewise.

2003-03-01  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in (CXX_C_OBJS): Update.

2003-02-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9892
	* pt.c (instantiate_decl): Clear DECL_RTL for a VAR_DECL when
	instantiating it.

2003-02-28  Aldy Hernandez  <aldyh@redhat.com>

	* parser.c (cp_parser_init_declarator): Revert opaque
	vector_opaque_p change.
	Do not include target.h.

2003-02-28  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9879
	* cp-tree.h (build_zero_init): Add parameter.
	* decl.c (cp_finish_decl): Adjust call.
	* init.c (build_zero_init): Add nelts parameter.  Adjust recursive
	calls.
	(build_default_init): Add nelts parameter.  Adjust calls to
	build_zero_init.
	(build_new_1): Adjust call to build_default_init.
	* typeck2.c (process_init_constructor): Adjust call to build_zero_init.

2003-02-26  Devang Patel  <dpatel@apple.com>

	* decl.c (finish_enum): Merge two 'for' loops. Copy value node if
	required.  Postpone enum setting for template decls.
	(build_enumerator): Delay copying value node until finish_enum
	(). Remove #if 0'ed code.
	* pt.c (tsubst_enum): Set TREE_TYPE and copy value node.
	(tsubst_copy): Add check for enum type.

2003-02-25  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9683
	* decl2.c (prune_vars_needing_no_initialization): Do not throw
	away initializations for DECL_EXTERNAL VAR_DECLs.
	(finish_file): Adjust accordingly.
	* pt.c (instantiate_decl): Do not defer VAR_DECLs.

2003-02-24 Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* decl.c (add_binding): Time TV_NAME_LOOKUP.
	(push_class_binding): Likewise.
	(set_namespace_binding): Likewise.

2003-02-24  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9836
	* cp-tree.h (CLASSTYPE_PRIMARY_TEMPLATE): Do not skip from
	specializations back to the main template.
	* parser.c (cp_parser_diagnose_invalid_type_name):Adjust use.
	* pt.c (resolve_typename_type): Likewise.

2003-02-24  Jeffrey D. Oldham  <oldham@codesourcery.com>

	PR c++/9778
	* pt.c (tsubst_copy_and_build): For a templated function inside a
	scope, process template arguments.

2003-02-24  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9602
	* typeck2.c (abstract_virtuals_error): Don't check when
	TYPE is still template parameter dependent.

2003-02-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/5333
	* cp-tree.h (CLASSTYPE_PRIMARY_TEMPLATE): New macro.
	* parser.c (cp_parser_diagnose_invalid_type_name): Use it.
	* pt.c (instantiate_class_template): Don't try to instantiate
	dependent types.
	(resolve_typename_type): Use CLASSTYPE_PRIMARY_TEMPLATE.

2003-02-21  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9749
	* decl.c (grokdeclarator): Do not allow parameters with variably
	modified types.

2003-02-21  Nathan Sidwell  <nathan@codesourcery.com>

	* search.c (grow_bfs_bases): Remove. Fold into ...
	(bfs_walk): ... here, fix fencepost error. Fix merge lossage
	in previous patch.

2003-02-20  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9729
	* mangle.c (mangle_conv_op_name_for_type): Issue an error message
	when the G++ 3.2 ABI prevents correct compilation.

2003-02-20  Nathan Sidwell  <nathan@codesourcery.com>

	Change base class access representation. Share virtual base
	binfos.
	* cp/call.c (build_special_member_call): Remove binfo_for_vbase
	call.
	* cp/class.c (build_base_path): Likewise.
	(build_primary_vtable): Adjust BINFO_NEW_VTABLE_MARKED use.
	(build_secondary_vtable): Remove FOR_TYPE arg. Adjust.
	(make_new_vtable): Adjust.
	(force_canonical_binfo_r): Delete.
	(force_canonical_binfo): Delete.
	(mark_primary_virtual_base): Delete.
	(dfs_unshared_virtual_bases): Delete.
	(mark_primary_bases): Adjust.
	(maybe_warn_about_overly_private_class): Adjust.
	(dfs_base_derived_from): Delete.
	(base_derived_from): Follow the inheritance chain.
	(struct find_final_overrider_data): Add vpath member.
	(dfs_find_final_overrider): Adjust.
	(dfs_find_final_overrider_q, dfs_find_final_overrider_post): New.
	(find_final_overrider): Adjust.
	(update_vtable_entry_for_fn): Adjust.
	(modify_all_vtables): Adjust.
	(walk_subobject_offsets): Adjust.
	(layout_nonempty_base_or_field): Adjust.
	(layout_empty_base): Remove last parameter. Adjust.
	(build_base_field): Adjust.
	(build_base_fields): Adjust.
	(propagate_binfo_offsets): Remove last parameter. Adjust.
	(dfs_set_offset_for_unshared_vbases): Delete.
	(layout_virtual_bases): Adjust.
	(finish_struct_1): Adjust.
	(init_class_processing): Don't init access nodes.
	(dfs_get_primary_binfo): Delete.
	(get_primary_binfo): Adjust.
	(dump_class_hierarchy_r): Remove most derived arg, add IGO
	parameter. Adjust.
	(dump_class_hierarchy): Adjust.
	(finish_vtbls): Adjust.
	(get_original_base): Delete.
	(build_vtt_inits): Adjust.
	(dfs_build_secondary_vptr_vtt_inits): Adjust.
	(dfs_ctor_vtable_bases_queue_p): Adjust.
	(build_ctor_vtbl_group): Adjust.
	(dfs_accumulate_vtbl_inits): Adjust.
	(build_vtbl_initializer): Adjust.
	(build_vbase_offset_vtbl_entries): Adjust.
	(add_vcall_offset_vtbl_entries_1): Adjust.
	* cp/cp-tree.h (CPTI_ACCESS_*): Remove.
	(access_*_node): Remove.
	(CANONICAL_BINFO): Delete.
	(BINFO_UNSHARED_MARKED): Remove.
	(BINFO_MARKED): Set LANG_FLAG_0 directly.
	(SET_BINFO_MARKED, CLEAR_BINFO_MARKED): Delete.
	(BINFO_VTABLE_PATH_MARKED): Set LANG_FLAG_3 directly.
	(SET_BINFO_VTABLE_PATH_MARKED, CLEAR_BINFO_VTABLE_PATH_MARKED):
	Delete.
	(BINFO_NEW_VTABLE_MARKED): Set LANG_FLAG_4 directly.
	(SET_BINFO_NEW_VTABLE_MARKED): Adjust.
	(SET_BINFO_PUSHDECLS_MARKED, CLEAR_BINFO_PUSHDECLS_MARKED):
	Delete.
	(BINFO_DEPENDENT_BASE_P): New.
	(dfs_walk, dfs_walk_real): Queue function takes derived binfo and
	index.
	(markedp, unmarkedp): Adjust.
	(dfs_unmarked_real_bases_queue_p, dfs_marked_real_bases_queue_p,
	dfs_skip_vbases, marked_vtable_pathp, unmarked_vtable_pathp,
	find_vbase_instance, binfo_for_vbase): Delete.
	(copied_binfo, original_binfo): Declare.
	(finish_base_specifier): Add virtual_p arg.
	(unshare_base_binfos): Delete.
	(copy_base_binfos): Declare.
	(reverse_path): Delete.
	* cp/decl.c (xref_basetypes): Access and virtuality passed
	differently. Don't copy direct base binfos here. Call
	copy_base_binfos.
	* cp/init.c (dfs_initialize_vtbl_ptrs): Adjust.
	(initialize_vtbl_ptrs): Adjust.
	(expand_member_init): Adjust.
	* cp/parser.c (cp_parser_base_specifier): Adjust.
	* cp/pt.c (instantiate_class_template): Adjust.
	(get_template_base_recursive): Adjust.
	* cp/rtti.c (get_pseudo_ti_init): Adjust.
	(get_pseudo_ti_desc): Adjust.
	* cp/tree.c (unshare_base_binfos): Rename to ...
	(copy_base_binfos): ... here, reimplement.
	(make_binfo): Set BINFO_DEPENDENT_BASE_P.
	(reverse_path): Remove.
	* cp/typeck.c (get_delta_difference): Adjust error messages.
	* cp/semantics.c (finish_base_specifier): Add virtual arg, adjust.
	* cp/search.c (lookup_base_r): Adjust.
	(dynamic_cast_base_recurse): Adjust.
	(canonical_binfo): Remove.
	(dfs_canonical_queue): Remove.
	(dfs_assert_unmarked_p): Remove.
	(assert_canonical_unmarked): Remove.
	(shared_marked_p, shared_unmarked_p): Remove.
	(BINFO_ACCESS, SET_BINFO_ACCESS): Use TREE_PUBLIC & TREE_PRIVATE.
	(dfs_access_in_type): Adjust.
	(access_in_type): Adjust.
	(dfs_accessible_queue_p): Adjust.
	(dfs_accessible_p): Adjust.
	(is_subobject_of_p_1, is_subobject_of_p): Remove.
	(struct lookup_field_info): Remove from_dep_base_p field.
	(lookup_field_queue_p): Adjust, test BINFO_DEPENDENT_BASE_P.
	(lookup_field_r): Remove dependent base code.
	(lookup_member): Likewise.
	(dfs_walk, dfs_walk_real): Add access arg to queue fn.
	(dfs_unmarked_real_bases_queue_p): Remove.
	(dfs_marked_real_bases_queue_p): Remove.
	(dfs_skip_vbases): Remove.
	(dfs_get_pure_virtuals): Adjust.
	(markedp, unmarkedp): Adjust.
	(marked_vtable_pathp, unmarked_vtable_pathp): Remove.
	(marked_pushdecls_p, unmarked_pushdecls_p): Adjust.
	(dfs_unmark): Adjust.
	(dfs_get_vbase_types):Remove.
	(dfs_build_inheritance_graph_order): Remove.
	(get_vbase_types): Remove
	(dfs_find_vbase_instance): Remove.
	(find_vbase_instance): Remove.
	(dfs_debug_unmarkedp): Adjust.
	(dependent_base_p): Remove.
	(dfs_push_type_decls): Adjust.
	(dfs_push_decls): Adjust.
	(dfs_no_overlap_yet): Adjust.
	(copied_binfo): New function.
	(original_binfo): New function.
	(binfo_for_vbase): Remove.

2003-02-18  Zack Weinberg  <zack@codesourcery.com>

	* cp/search.c (grow_bfs_bases): New subroutine of bfs_walk.
	(bfs_walk): Rewritten using circular queue of BINFO_BASETYPES
	vectors, for speed.

2003-02-18  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9704
	* class.c (layout_class_type): In the 3.2 ABI, take into account
	trailing bit fields when computing CLASSTYPE_SIZE_UNIT.

2003-02-18  Matt Austern <austern@apple.com>

	* cp/cp-lang.c: Change lang hooks so that final_write_globals does
	nothing for C++.
	* cp/decl.c (wrapup_globals_for_namespace): Remove special
	handling of global namespace.

2003-02-18  Geoffrey Keating  <geoffk@apple.com>

	* cp-tree.h (rid_to_yy): Delete.
	(C_RID_YYCODE): Delete.
	(finish_file): Delete redundant declaration.

2003-02-18  Jason Merrill  <jason@redhat.com>

	PR c++/9623
	* decl.c (reshape_init): Don't mess with initializer labels.

	PR c++/9485
	* parser.c (cp_parser_postfix_expression): Set idk properly for
	object->scope::member.

2003-02-18  Ben Elliston  <bje@redhat.com>

	PR other/7350
	* decl.c (duplicate_decls): Fix typo in comment.

2003-02-17  Michael Elizabeth Chastain <mec@shout.net>

	PR debug/9717
	* class.c (build_base_field): Mark fields for base classes with
	DECL_IGNORED_P.

2003-02-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9457
	* pt.c (tsubst_copy_and_build) [CONSTRUCTOR]: Substitute
	CONSTRUCTOR_ELTS only once.

2003-02-16  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9459
	* error.c (dump_type_prefix): Handle TYPEOF_TYPE.
	(dump_type_suffix): Likewise.

2003-02-14  Nathan Sidwell  <nathan@codesourcery.com>

	* search.c: ANSIfy function declarations and definitions.
	* cp-tree.h (lookup_field, lookup_member): Last parameter is a bool.
	* call.c (build_method_call, resolve_scoped_fn_name,
	build_java_interface_fn_ref): Adjust lookup_field, lookup_member
	calls.
	* class.c (handle_using_decl): Likewise.
	* decl.c (make_typename_type, make_unmound_class_template,
	start_decl, compute_array_index_type): Likewise.
	* decl2.c (build_expr_from_tree, build_call_from_tree): Likewise.
	* init.c (expand_member_init, build_member_call): Likewise.
	* pt.c (tsubst_copy, tsubst_copy_and_build, do_decl_instantiation,
	resolve_typename_type): Likewise.
	* typeck.c (lookup_destructor, finish_class_member_access_exprm
	build_prememfunc_access_expr): Likewise.

2003-02-13  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* decl2.c: Include "timevar.h".
	(namespace_ancestor): Time name lookup.
	(add_using_namespace): Likewise.
	(lookup_using_namespace): Likewise.
	(qualified_lookup_using_namespace): Likewise.
	(decl_namespace): Likewise.
	(lookup_arg_dependent): Likewise.
	* lex.c (do_identifier): Likewise.
	(do_scoped_id): Likewise.
	* pt.c (lookup_template_class): Likewise.

2003-02-14   Andrew Pinski <pinskia@physics.uc.edu>

	* decl.c: (define_label): Fix warning for return 0 instead of NULL.

2003-02-13  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* decl.c: Include "timevar.h".
	(poplevel): Time name lookup.
	(find_binding): Likewise.
	(push_namespace): Likewise.
	(pop_nested_namespace): Likewise.
	(store_bindings): Likewise.
	(maybe_push_to_top_level): Likewise.
	(pop_from_top_level): Likewise.
	(push_local_name): Likewise.
	(pushtag): Likewise.
	(pushdecl): Likewise.
	(pushdecl_with_scope): Likewise.
	(pushdecl_namespace_level): Likewise.
	(pushdecl_top_level): Likewise.
	(pushdecl_class_level): Likewise.
	(push_class_level_binding): Likewise.
	(push_using_decl): Likewise.
	(push_using_directive): Likewise.
	(push_overloaded_decl): Likewise.
	(lookup_label): Likewise.
	(define_label): Likewise.
	(lookup_tag): Likewise.
	(lookup_tag_reverse): Likewise.
	(lookup_namespace_name): Likewise.
	(select_decl): Likewise.
	(unqualified_namespace_lookup): Likewise.
	(lookup_name_real): Likewise.
	(lookup_name_current_level): Likewise.
	(lookup_type_current_level): Likewise.
	(maybe_inject_for_scope_var): Likewise.
	(xref_tag): Likewise.

	* Make-lang.in (cp/decl.o): Add dependency on timevar.h

2003-02-12  Phil Edwards  <pme@gcc.gnu.org>

	* decl.c (build_enumerator):  Remove unneeded test.

2003-02-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* cp-tree.h (struct lang_type_header): Make all fields unsigned
	char.

2003-02-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7129
	* call.c (z_candidate): Add args.
	(convert_class_to_reference): Set it.
	(implicit_conversion): Tidy.
	(add_candidate): Add args parameter.
	(add_function_candidate): Adjust call to add_candidate.
	(add_conv_candidate): Likewise.
	(build_builtin_candidate): Likewise.
	(build_user_type_conversion_1): Eliminate wasteful tree_cons
	usage.
	(build_new_function_call): Likewise.
	(build_object_call): Likewise.
	(add_candidates): New function.
	(build_new_op): Use it.
	(covert_like_real): Adjust call to build_over_call.
	(build_over_call): Remove args parameter.
	* operators.def: Add <?= and >?=.

2003-02-01  Richard Sandiford  <rsandifo@redhat.com>

	* typeck.c (build_indirect_ref): Don't check flag_volatile.

2003-01-31  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8849
	* pt.c (resolve_overloaded_unification): Handle FUNCTION_DECL.

2003-01-31  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (BINFO_SUBVTT_INDEX, BINFO_VPTR_INDEX,
	BINFO_PRIMARY_BASE_OF): Use BINFO_ELTS.
	(BINFO_LANG_ELTS): New #define.
	* tree.c (make_binfo): Use BINFO_LANG_ELTS.

2003-01-30  Geoffrey Keating  <geoffk@apple.com>

	* cp/Make-lang.in: Remove -Wno-error from cp/decl.o.

2003-01-30  Mark Mitchell  <mark@codesourcery.com>

	* class.c (check_field_decls): Only check C_TYPE_FIELDS_READONLY
	for class types.
	* cp-tree.h (C_TYPE_FIELDS_READONLY): Use a lang-specific bit
	rather than TYPE_LANG_FLAG_0.
	(TYPE_BUILT_IN): Remove.
	(TYPE_DEPENDENT_P): New macro.
	(TYPE_DEPENDENT_P_VALID): Likewise.
	(lang_type_class): Add fields_readonly.
	* decl.c (record_builtin_type): Don't set TYPE_BUILT_IN.
	* pt.c (dependent_type_p_r): New function, split out from ...
	(dependent_type_p): ... here.  Memoize results.
	* search.c (dependent_base_p): Use dependent_type_p, not
	uses_template_parms.
	* typeck.c (build_modify_expr): Only check C_TYPE_FIELDS_READONLY
	for class types.

2003-01-29  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_field_call): Use build_new_op, not build_opfncall.
	(prep_operand): New function.
	(build_new_op): Use it.  Remove dead code.
	* class.c (pushclass): Change "modify" parameter type from int to
	bool.
	(currently_open_class): Use same_type_p, not pointer equality.
	(push_nested_class): Adjust calls to pushclass, remove modify
	parameter.
	* cp-tree.h (INTEGRAL_OR_ENUMERATION_TYPE_P): New macro.
	(pushclass): Change prototype.
	(push_nested_class): Likewise.
	(grokoptypename): Remove.
	(build_opfncall): Remove.
	(value_dependent_expression_p): Declare.
	(resolve_typename_type): Likewise.
	(resolve_typename_type_in_current_instantiation): Likewise.
	(enter_scope_of): Remove.
	(tsubst): Remove.
	(tsubst_expr): Likewise.
	(tsubst_copy): Likewise.
	(tsubst_copy_and_build): Likewise.
	* decl.c (warn_about_implicit_typename_lookup): Remove.
	(finish_case_label): Return error_mark_node for erroneous labels.
	(start_decl): Adjust calls to push_nested_class.
	(grokfndecl): Call push_scope/pop_scope around call to
	duplicate_decls.
	(grokdeclarator): Do not call tsubst.
	(start_function): Adjust calls to push_nested_class.
	* decl2.c (grok_array_decl): Use build_new_op, not build_opfncall.
	(check_classfn): Use push_scope/pop_scope around type comparisions.
	(grokoptypename): Remove.
	(push_sscope): Adjust call to push_nested_class.
	* error.c (dump_type): Show cv-qualification of typename types.
	* init.c (build_member_call): Use build_new_op, not
	build_opfncall.
	* method.c (build_opfncall): Remove.
	* parser.c (cp_parser): Add allow_non_constant_expression_p and
	non_constant_expression_p.
	(cp_parser_constant_expression): Adjust prototype.
	(cp_parser_resolve_typename_type): Remove.
	(cp_parser_non_constant_expression): New function.
	(cp_parser_non_constant_id_expression): Likewise.
	(cp_parser_new): Set allow_non_constant_expression_p and
	non_constant_expression_p.
	(cp_parser_primary_expression): Reject `this' and `va_arg' in
	constant-expressions.  Note that dependent names aren't really
	constant.
	(cp_parser_postfix_expression): Reject conversions to non-integral
	types in constant-expressions.  Neither are increments or
	decrements.
	(cp_parser_unary_expression): Reject increments and decrements in
	constant-expressions.
	(cp_parser_direct_new_declarator): Adjust call to
	cp_parser_constant_expression.
	(cp_parser_cast_expression): Reject conversions to non-integral
	types in constant-expressions.
	(cp_parser_assignment_expression): Rejects assignments in
	constant-expressions.
	(cp_parser_expression): Reject commas in constant-expressions.
	(cp_parser_labeled_statement): Adjust call to
	cp_parser_constant_expression.
	(cp_parser_direct_declarator): Simplify array bounds, even in
	templates, when they are non-dependent.  Use
	resolve_typename_type, not cp_parser_resolve_typename_type.
	(cp_parser_class_head): Use resolve_typename_type, not
	cp_parser_resolve_typename_type.
	(cp_parser_member_declaration): Adjust call to
	cp_parser_constant_expression.
	(cp_parser_constant_initializer): Likewise.
	(cp_parser_constructor_declarator): Use resolve_typename_type, not
	cp_parser_resolve_typename_type.
	(cp_parser_late_parsing_default_args): Adjust call to
	push_nested_class.
	* pt.c (tsubst): Give it internal linkage.
	(tsubst_expr): Likewise.
	(tsubst_copy): Likewise.
	(tsubst_copy_and_build): Likewise.
	(push_access_scope_real): Likewise.
	(tsubst_friend_class): Likewise.
	(instantiate_class_template): Adjust call to pushclass.
	(value_dependent_expression_p): Give it external linkage.
	Robustify.
	(resolve_typename_type): New function.
	* semantics.c (finish_call_expr): Use build_new_op, not
	build_opfncall.
	(begin_constructor_declarator): Remove.
	(begin_class_definition): Adjust call to pushclass.
	(enter_scope_of): Remove.
	* typeck.c (comptypes): Resolve typename types as appropriate.
	(build_x_indirect_ref): Use build_new_op, not build_opfncall.
	(build_x_compound_expr): Likewise.
	(build_modify_expr): Likewise.
	(build_x_modify_expr): Likewise.
	* typeck2.c (build_x_arrow): Likewise.

2003-01-29  Fariborz Jahanian  <fjahanian@apple.com>

	* pt.c (last_pending_template) Declare GTY().

2003-01-29  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8591
	* parser.c (cp_parser_elaborated_type_specifier): Convert
	TEMPLATE_DECL to TYPE_DECL only when processing template friends.
	(cp_parser_maybe_treat_template_as_class): Remove redundant tests.

2003-01-28  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9437
	* pt.c (unify): Don't unify '*T' with 'U C::*'.

	PR c++/3902
	* parser.c (cp_parser_decl_specifier_seq): Cannot have constructor
	inside a declarator.

2003-01-27  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (update_vtable_entry_for_fn): Add index parameter.
	Generate vcall thunk for covariant overriding from a virtual
	primary base.
	(dfs_modify_vtables): Adjust.

2003-01-25  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9403
	* parser.c (cp_parser_class_or_namespace_name): Reject duplicate
	template keyword.
	(cp_parser_base_specifier): Look for and consume a
	TEMPLATE keyword. Replace switch with array index.

	PR c++/795
	* semantics.c (finish_non_static_data_member): Remember the
	field's type even in a template.

	PR c++/9415
	* pt.c (tsubst_copy_and_build, CALL_EXPR): BASELINK exprs are
	already scoped.

	PR c++/8545
	* parser.c (cp_parser_cast_expression): Be more tentative.

2003-01-25  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* cp-tree.h (flagged_type_tree_s): Remove.
	(check_for_new_type): Likewise.
	* typeck2.c (check_for_new_type): Likewise.

2003-01-23  Nathanael Nerode  <neroden@gcc.gnu.org>

	* dump.c: ANSIfy function declarations and definitions.

	* cp-tree.h, decl.h: Get rid of PARAMS.  Again.

2003-01-22  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9354
	* init.c (build_new): Set the type of the new-expression, even
	when processing_templte_decl.

	PR c++/9216
	* parser.c (cp_parser_primary_expression): Improve error message
	for templates used in an expression context.

	PR c++/8696
	* parser.c (cp_parser_decl_specifier_seq): Commit to tentative
	parse when encountering "typedef".

2003-01-22  Nathanael Nerode  <neroden@gcc.gnu.org>

	* class.c, parser.c: ANSIfy function definitions and declarations.

2003-01-22  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9328
	* error.c (dump_decl): For an OVERLOAD, just print the name of the
	function; it doesn't make sense to try to print its type.
	* semantics.c (finish_typeof): Issue errors about invalid uses.

	PR c++/9298
	* parser.c (cp_parser_consume_semicolon_at_end_of_statement): New
	function.
	(cp_parser_expression_statement): Use it.
	(cp_parser_explicit_instantiation): Likewise.
	* pt.c (do_decl_instantiation): Improve error handling logic.

2003-01-22  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9384
	* parser.c (cp_parser_using_declaration): Issue error messages
	about name resolution failures here.

	PR c++/9388
	* class.c (currently_open_derived_class): Use dependent_type_p.
	* cp-tree.h (dependent_type_p): New function.
	(dependent_template_arg_p): Likewise.
	(dependent_template_p): Likewise.
	(type_dependent_expression_p): Likewise.
	* parser.c (cp_parser_dependent_type_p): Remove.
	(cp_parser_value_dependent_type_p): Likewise.
	(cp_parser_type_dependent_expression_p): Likewise.
	(cp_parser_dependent_template_arg_p): Likewise.
	(cp_parser_dependent_template_id_p): Likewise.
	(cp_parser_dependent_template_p): Likewise.
	(cp_parser_diagnose_invalid_type_name): Replace
	cp_parser_dependent_type_p with dependent_type_p, etc.
	(cp_parser_primary_expresion): Likewise.
	(cp_parser_nested_name_specifier_opt): Likewise.
	(cp_parser_postfix_expression): Likewise.
	(cp_parser_unary_expression): Likewise.
	(cp_parser_template_name): Likewise.
	(cp_parser_class_name): Likewise.
	(cp_parser_lookup_name): Likewise.
	* pt.c (dependent_type_p): New function.
	(value_dependent_expression_p): Likewise.
	(type_dependent_expression_p): Likewise.
	(dependent_template_arg_p): Likewise.
	(dependent_template_id_p): Likewise.
	(dependent_template_p): Likewise.

	PR c++/9285
	PR c++/9294
	* parser.c (cp_parser_simple_declaration): Return quickly when
	encountering errors.

2003-01-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	Make-lang.in (cp/decl.o-warn): Add -Wno-error.

2003-01-17  Jason Merrill  <jason@redhat.com>

	PR c++/9167, c++/9358
	* decl.c (require_complete_types_for_parms): Also update DECL_ARG_TYPE.

2003-01-17  Jason Merrill  <jason@redhat.com>

	PR c++/9342
	* call.c (build_conditional_expr): Always do lvalue-rvalue
	conversion.

2003-01-17  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9294
	* cp-tree.def (BASELINK): Make it class 'x', not class 'e'.
	* cp-tree.h (BASELINK_BINFO): Adjust.
	(BASELINK_FUNCTIONS): Likewise.
	(BASELINK_ACCESS_BINFO): Likewise.
	(tree_baselink): New structure.
	(cp_tree_node_structure_enum): Add TS_CP_BASELINK.
	(lang_tree_node): Add baselink.
	* decl.c (cp_tree_node_structure): Add BASELINK case.
	* search.c (build_baselink): Adjust.
	* tree.c (cp_walk_subtrees): Add BASELINK case.  Remove BASELINK_P
	test from TREE_LIST case.

	PR c++/9272
	* parser.c (cp_parser_constructor_declarator_p): Do not assume
	that a constructor cannot be declared outside of its own class.

	* parser.c (cp_parser_resolve_typename_type): If the scope cannot
	be resolved, neither can the qualified name.

	* rtti.c (get_pseudo_ti_desc): Fix thinko.

2003-01-16  Jason Merrill  <jason@redhat.com>

	PR c++/8564
	* init.c (build_vec_init): Re-add maxindex parm.
	(perform_member_init, build_aggr_init): Pass it.
	(build_new_1): Pass it. Use an incomplete array type for full_type.
	* typeck.c (build_modify_expr): Pass it.
	* cp-tree.h: Adjust.

2003-01-16  Jeffrey D. Oldham  <oldham@codesourcery.com>

	* cp-tree.h (tsubst_copy_and_build): New declaration.
	* pt.c (tsubst_copy): Remove 'build_expr_from_tree' from comment.
	(tsubst_expr): Use 'tsubst_copy_and_build'.  Update initial comment.
	(tsubst_copy_and_build): New function.

2003-01-16  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (lang_type_class): Remove is_partial_instantiation.
	(PARTIAL_INSTANTIATION_P): Remove.
	(IMPLICIT_TYPENAME_P): Likewise.
	(IMPLICIT_TYPENAME_TYPE_DECL_P): Likewise.
	(build_typename_type): Remove declaration.
	(parmlist_is_exprlist): Likewise.
	* decl.c (build_typename_type): Make it static, remove third
	parameter.
	(push_class_binding): Don't do implicit typename stuff.
	(make_typename_type): Likewise.
	(lookup_name_real): Likewise.
	(grokdeclarator): Don't try to convert declarations into
	initializations.  Don't do implicit typename stuff.
	(parmlist_is_exprlist): Remove.
	(xref_basetypes): Simplify.
	* decl2.c (grokfield): Don't try to convert declarations into
	initializations.
	(build_anon_union_vars): Do this while processing templates, too.
	(finish_anon_union): Likewise.
	* error.c (dump_type): Remove implicit typename handling.
	* parser.c (cp_parser_diagnose_invalid_type_name): New method.
	(cp_parser_primary_expression): Correct handling of names not
	found by unqualified name lookup in templates.
	(cp_parser_nested_name_specifier_opt): Avoid checking dependency
	of types when possible.
	(cp_parser_simple_declaration): Complain intelligently about some
	invalid declarations.
	(cp_parser_member_declaration): Likewise.
	(cp_parser_constructor_declarator_p): Don't check when we're in a
	function scope.
	* pt.c (instantiate_class_template): Remove
	PARTIAL_INSTANTIATION_P gunk.
	* search.c (lookup_field_r): Don't build implicit typenames.
	(marked_pushdecls_p): Don't enter dependent base types.
	(unmarked_pushdecls_p): Likewise.
	* semantics.c (begin_class_definition): Remove implicit typename
	stuff.

2003-01-16  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9212
	* parser.c (cp_parser_direct_declarator): If accepting either
	abstract or named, the name must be an unqualified-id.

2003-01-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (layout_virtual_bases): Avoid signed/unsigned warning.

2003-01-14  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl2.c (check_classfn): Fix uninitialized warning.
	(build_anon_union_vars): Likewise.
	* pt.c (tsubst_copy): Likewise.

2003-01-14  Jeffrey D. Oldham  <oldham@codesourcery.com>

	Further conform g++'s __vmi_class_type_info to the C++ ABI
	specification.
	* rtti.c (dfs_class_hint_mark): Do not set hints not specified by
	the specification.
	(class_hint_flags): Likewise.

2003-01-14  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* config-lang.in: Add semantics.c to gtfiles.
	* cp-tree.h (flagged_type_tree_s): Remove lookups field.
	(saved_scope): Likewise.
	(type_lookups): Remove.
	(deferred_access): New structure.
	(type_access_control): Remove.
	(save_type_access_control): Likewise.
	(reset_type_access_control): Likewise.
	(decl_type_access_control): Likewise.
	(push_deferring_access_checks): Declare.
	(resume_deferring_access_checks): Likewise.
	(stop_deferring_access_checks): Likewise.
	(pop_deferring_access_checks): Likewise.
	(get_deferred_access_checks): Likewise.
	(pop_to_parent_deferring_access_checks): Likewise.
	(perform_deferred_access_checks): Likewise.
	(perform_or_defer_access_check): Likewise.
	* decl.c (make_typename_type): Use perform_or_defer_access_check.
	(make_unbound_class_template): Likewise.
	(grokdeclarator): Don't call decl_type_access_control.
	* parser.c (cp_parser_context): Remove deferred_access_checks
	and deferring_access_checks_p fields.
	(cp_parser_context_new): Adjust.
	(cp_parser): Remove access_checks_lists.
	(cp_parser_defer_access_check): Remove.
	(cp_parser_start_deferring_access_checks): Remove.
	(cp_parser_stop_deferring_access_checks): Remove.
	(cp_parser_perform_deferred_access_checks): Remove.
	(cp_parser_nested_name_specifier_opt): Use new deferred access
	functions.
	(cp_parser_simple_declaration): Likewise.
	(cp_parser_template_id): Likewise.
	(cp_parser_function_definition): Likewise.
	(cp_parser_class_specifier): Likewise.
	(cp_parser_lookup_name): Likewise.
	(cp_parser_single_declaration): Likewise.
	(cp_parser_pre_parsed_nested_name_specifier): Likewise.
	(cp_parser_parse_tentatively): Likewise.
	(cp_parser_parse_definitely): Likewise.
	(yyparse): Likewise.
	(cp_parser_init_declarator): Remove access_checks parameter.
	Use new deferred access functions.
	(cp_parser_function_definition_from_specifiers_and_declarator):
	Likewise.
	(cp_parser_class_head): Remove deferring_access_checks_p and
	saved_access_checks parameters.  Use new deferred access functions.
	(cp_parser_member_specification_opt): Don't call
	reset_type_access_control.
	* search.c (type_access_control): Remove.
	* semantics.c: Include "gt-cp-semantics.h".
	(deferred_type_access_control): Remove.
	(deferred_access_stack): New variable.
	(deferred_access_free_list): Likewise.
	(push_deferring_access_checks): New function.
	(resume_deferring_access_checks): Likewise.
	(stop_deferring_access_checks): Likewise.
	(pop_deferring_access_checks): Likewise.
	(get_deferred_access_checks): Likewise.
	(pop_to_parent_deferring_access_checks): Likewise.
	(perform_deferred_access_checks): New function, adapted from
	cp_parser_perform_deferred_access_checks.
	(perform_or_defer_access_check): New function, adapted from
	cp_parser_defer_access_check.
	(current_type_lookups): Remove.
	(deferred_type_access_control): Likewise.
	(decl_type_access_control): Likewise.
	(save_type_access_control): Likewise.
	(reset_type_access_control): Likewise.
	(begin_function_definition): Adjust.
	(begin_class_definiton): Likewise.

2003-01-13  Jason Merrill  <jason@redhat.com>

	PR c++/8748
	* class.c (build_base_path): Take the address before calling save_expr.

	* call.c (build_user_type_conversion_1): Do set ICS_BAD_FLAG if
	all the ambiguous conversions are bad.

	* class.c (maybe_warn_about_overly_private_class): Don't stop
	searching when we find a nonprivate method.

	* typeck.c (build_class_member_access_expr): Use unary_complex_lvalue.

2003-01-12  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (get_arglist_len_in_bytes): Remove.

	PR c++/9264
	* parser.c (cp_parser_elaborated_type_specifier): Handle erroneous
	typeame types more robustly.

2003-01-11  Phil Edwards  <pme@gcc.gnu.org>

	* parser.c:  Fix comment typos.

2003-01-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9099
	* parser.c (cp_parser_scope_through_which_access_occurs): Handle
	an object_type which is not a class type.

2003-01-10  Geoffrey Keating  <geoffk@apple.com>

	* parser.c (cp_parser_late_parsing_for_member): Don't cast to void.
	(cp_parser_late_parsing_default_args): Likewise.

2003-01-10  Nathanael Nerode  <neroden@gcc.gnu.org>

	* cfns.gperf: ANSIfy function declarations.
	* cfns.h: Regenerate.
	* cp-tree.h: ANSIfy function declarations.

2003-01-10  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (reparse_absdcl_as_expr): Remove.
	(reparse_absdcl_as_casts): Likewise.
	(reparse_decl_as_expr): Likewise.
	(finish_decl_parsing): Likewise.
	* decl2.c (reparse_absdcl_as_expr): Remove.
	(reparse_absdcl_as_casts): Likewise.
	(repase_decl_as_expr): Likewise.
	(finish_decl_parsing): Likewise.

	PR c++/9128
	PR c++/9153
	PR c++/9171
	* parser.c (cp_parser_pre_parsed_nested_name_specifier): New
	function.
	(cp_parser_nested_name_specifier_opt): Correct the
	check_dependency_p false.
	(cp_parser_postfix_expression): Fix formatting.
	(cp_parser_decl_specifier_seq): Avoid looking for constructor
	declarators when possible.
	(cp_parser_template_id): Avoid performing name-lookup when
	possible.
	(cp_parser_class_head): Do not count specializations when counting
	levels of templates.
	(cp_parser_constructor_declarator_p): Return immediately if
	there's no chance that the tokens form a constructor declarator.
	* rtti.c (throw_bad_typeid): Add comment.  Do not return an
	expression with reference type.
	(get_tinfo_decl_dynamic): Do not return an expression with
	reference type.
	(build_typeid): Add comment.  Do not return an expression with
	reference type.
	* typeck.c (build_class_member_access_expr): Improve handling of
	conditionals and comma-expressions as objects.

2003-01-09  Nathanael Nerode  <neroden@gcc.gnu.org>

	* cfns.gperf: ANSIfy function declarations.
	* cfns.h: Regenerate.
	* cp-tree.h: ANSIfy function declarations.
	* parser.c: ANSIfy function declarations & definitions.

	* decl.c (bad_specifiers): Fix parameter order error I introduced.

2003-01-09  Geoffrey Keating  <geoffk@apple.com>

	Merge from pch-branch:

	2003-01-09  Geoffrey Keating  <geoffk@apple.com>

	Merge to tag pch-merge-20030102:

	* semantics.c (finish_translation_unit): Don't call finish_file.
	* parser.c: Don't include ggc.h.
	(cp_lexer_new_main): Rename from cp_lexer_new, only create main lexer,
	read first token here.  Don't allow PCH files after the first
	token is read.
	(cp_lexer_new_from_tokens): Duplicate functionality from cp_lexer_new.
	(cp_lexer_get_preprocessor_token): Allow LEXER to be NULL.
	(cp_parser_new): Call cp_lexer_new_main before allocating GCed memory.
	(cp_parser_late_parsing_for_member): Don't duplicate call to
	cp_lexer_set_source_position_from_token.
	(cp_parser_late_parsing_default_args): Likewise.
	(yyparse): Call finish_file after clearing the_parser.

	2002-12-11  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in: Remove $(GGC_H) from all dependencies.
	(CXX_TREE_H): Add $(GGC_H).
	* class.c: Don't include ggc.h.
	(field_decl_cmp): Make parameters be 'const void *' to match qsort.
	(method_name_cmp): Likewise.
	(resort_data): New variable.
	(resort_field_decl_cmp): New.
	(resort_method_name_cmp): New.
	(resort_sorted_fields): New.
	(resort_type_method_vec): New.
	(finish_struct_methods): Delete cast.
	(finish_struct_1): Delete cast.
	* cp-tree.h: Include ggc.h.
	(struct lang_type_class): Add reorder attribute to field `methods'.
	(union lang_decl_u3): Add reorder attribute to field `sorted_fields'.
	(resort_sorted_fields): New prototype.
	(resort_type_method_vec): New prototype.
	* call.c: Don't include ggc.h.
	* decl.c: Likewise.
	* decl2.c: Likewise.
	* init.c: Likewise.
	* lex.c: Likewise.
	* method.c: Likewise.
	* optimize.c: Likewise.
	* parse.y: Likewise.
	* pt.c: Likewise.
	* repo.c: Likewise.
	* search.c: Likewise.
	* semantics.c: Likewise.
	* spew.c: Likewise.
	* tree.c: Likewise.

	* lang-specs.h: Remove comment.

	2002-12-03  Geoffrey Keating  <geoffk@apple.com>

	* cp-tree.h (struct operator_name_info_t): Mark for GTY machinery.
	(operator_name_info): Mark to be saved for PCH, specify size.
	(assignment_operator_name_info): Likewise.

	2002-11-19  Geoffrey Keating  <geoffk@apple.com>

	* decl.c (anon_cnt): Mark to be saved for PCH.

	2002-10-25  Geoffrey Keating  <geoffk@apple.com>

	* lex.c  (init_reswords): Delete now-untrue comment.
	Allocate ridpointers using GGC.

	2002-10-04  Geoffrey Keating  <geoffk@apple.com>

	* cp-tree.h (union lang_decl_u2): Add tags to all fields.

	* g++spec.c (lang_specific_driver): Don't include standard
	libraries in `added'.

	2002-08-27  Geoffrey Keating  <geoffk@redhat.com>

	* decl2.c (finish_file): Call c_common_write_pch.
	* Make-lang.in (CXX_C_OBJS): Add c-pch.o.

	2002-08-17  Geoffrey Keating  <geoffk@redhat.com>

	* g++spec.c (lang_specific_driver): Treat .h files as C++ header
	files when using g++.
	* lang-specs.h: Handle compiling C++ header files.

2003-01-09  Jakub Jelinek  <jakub@redhat.com>

	* decl.c (start_decl): Only check DECL_THREAD_LOCAL for VAR_DECLs.

2003-01-09  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* pt.c (push_access_scope_real): Call push_to_top_level for
	function in namespace scope.
	(pop_access_scope): Call pop_from_top_level for function in
	namespace scope.

2003-01-09  Jakub Jelinek  <jakub@redhat.com>

	* decl.c (start_decl): Don't set DECL_COMMON for __thread variables.

2003-01-09  Christian Cornelssen  <ccorn@cs.tu-berlin.de>

	* Make-lang.in (c++.install-common, c++.install-man,
	c++.uninstall): Prepend $(DESTDIR) to destination paths in
	all (un)installation commands.
	(c++.install-common): Rewrite $(LN) commands to support
	DESTDIR with "ln" as well as with "ln -s".

2003-01-08  Jason Merrill  <jason@redhat.com>

	* parser.c (cp_parser_primary_expression): See through explicitly
	scoped ALIAS_DECLs, too.

2003-01-08  Nathanael Nerode  <neroden@gcc.gnu.org>

	* decl.c: Remove some #if 0 code.

	* decl.c: ANSIfy function declarations.

2003-01-07  Mark Mitchell  <mark@codesourcery.com>

	* parser.c (cp_parser_asm_definition): Correct handling of omitted
	operands.

2003-01-08  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/9030
	* decl.c (make_typename_type): Check access only when tf_error.
	(make_unbound_class_template): Likewise.
	* pt.c (saved_access_scope): New variable.
	(push_access_scope_real): New function.
	(push_access_scope): Likewise.
	(pop_access_scope): Likewise.
	(tsubst_default_argument): Use them.
	(instantiate_template): Likewise.
	(regenerate_decl_from_template): Likewise.
	(instantiate_decl): Likewise.
	(get_mostly_instantiated_function_type): Likewise.

2003-01-07  Nathanael Nerode <neroden@gcc.gnu.org>

	* tree.c: Delete bogus #if 0 code.

2003-01-07  Andreas Schwab  <schwab@suse.de>

	* class.c (layout_class_type): Don't use
	PCC_BITFIELD_TYPE_MATTERS if not defined.

2003-01-06  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9165
	* decl2.c (build_cleanup): Mark the object as used.

	* pt.c (retrieve_local_specialization): Revert 2003-01-05 change.
	(hash_local_specialization): New function.
	(register_local_specialization): Revert 2003-01-05 change.
	(instantiate_decl): Use hash_local_specialization when creating
	the local_specializations table.

	* decl2.c (mark_used): Do not synthesize thunks.

	* class.c (layout_class_type): Correct handling of unnamed
	bitfields wider than their types.

	PR c++/9189
	* parser.c (cp_parser): Remove default_arg_types.  Update
	documentation for unparsed_functions_queues.
	(cp_parser_late_parsing_default_args): Take a FUNCTION_DECL as the
	parameter.
	(cp_parser_new): Don't set parser->default_arg_types.
	(cp_parser_function_definition): Adjust usage of
	unparsed_funtions_queues.
	(cp_parser_class_specifier): Don't mess with
	parser->default_arg_types.  Handle default argument processing in
	a separate phase from function body processing.
	(cp_parser_template_declaration_after_export): Adjust usage of
	unparsed_functions_queues.
	(cp_parser_late_parsing_for_member): Do not handle default
	arguments.

2003-01-06  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/9109
	* parser.c (cp_parser_declarator_kind): New enum.
	(cp_parser_declarator): Adjust.
	(cp_parser_direct_declarator): Adjust. Allow for either named or
	abstract declarator. Prefer abstract, if possible. Allow
	parenthesized function name.
	(cp_parser_condition): Adjust cp_parser_declarator call.
	(cp_parser_explicit_instantiation): Likewise.
	(cp_parser_init_declarator): Likewise.
	(cp_parser_type_id): Likewise.
	(cp_parser_function_definition): Likewise.
	(cp_parser_member_declaration): Likewise.
	(cp_parser_parameter_declaration): Use cp_parser_declarator to do
	the tentative parsing.
	(cp_parser_exception_declaration): Likewise.

2003-01-05  Mark Mitchell  <mark@codesourcery.com>

	* parser.c (cp_parser_template_parameter): Adjust call to
	cp_parser_parameter_declaration.
	(cp_parser_parameter_declaration_list): Likewise.
	(cp_parser_parameter_declaration): Replace
	greater_than_is_operator_p with template_parm_p parameter.  Do not
	cache tokens for template default arguments.

	* pt.c (retrieve_local_specialization): Use htab_find, not
	htab_find_with_hash.
	(register_local_specialization): Use htab_find_slot, not
	htab_find_slot_with_hash.
	(instantiate_decl): Pass a hash function to htab_create.

2003-01-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* parser.c (cp_parser_binary_expression,
	cp_parser_multiplicative_expression,
	cp_parser_additive_expression, cp_parser_shift_expression,
	cp_parser_relational_expression, cp_parser_equality_expression,
	cp_parser_and_expression, cp_parser_exclusive_or_expression,
	cp_parser_inclusive_or_expression,
	cp_parser_logical_and_expression, cp_parser_logical_or_expression,
	cp_parser_binary_expression): Const-ify.

2003-01-04  Mark Mitchell  <mark@codesourcery.com>

	* method.c (use_thunk): Disable access control while building the
	body of the thunk.

2003-01-03  Nathanael Nerode  <neroden@gcc.gnu.org>

	* cvt.c, decl.c, decl2.c: This is the C++ front end, not the C
	front end.

2003-01-03  Matt Austern  <austern@apple.com>

	* cp-tree.h (struct lang_type_class): add field for key method
	(cp_global_trees): rename dynamic_classes to keyed_classes
	(key_method): add definition
	* class.c (finish_struct_1): compute class's key method, and add
	the class to keyed_classes list if there is no key method.
	* decl.c (finish_function): add class to keyed_classes list if we
	see a definition of the class's key method.
	* pt.c (instantiate_class_template): add template specialization
	of a dynamic class to keyed_classes list.
	* decl2.c (key_method): remove
	(finish_file): iterate only through keyed_classes list when
	deciding whether to emit vtables, remove class from its list after
	we do the emission.

2003-01-02  Jason Merrill  <jason@redhat.com>

	* call.c (build_conditional_expr): Stabilize lvalues properly.
	* cvt.c (ocp_convert): Don't build NOP_EXPRs of class type.
	* tree.c (lvalue_p_1): Don't allow sloppy NOP_EXPRs as lvalues.
	Don't allow CALL_EXPR or VA_ARG_EXPR, either.

	* call.c (convert_like_real): Call decl_constant_value for an
	IDENTITY_CONV even if there are no more conversions.

	* cvt.c (build_up_reference): Don't push unnamed temps.

	* decl2.c (do_namespace_alias): Namespace aliases are DECL_EXTERNAL.

	* dump.c (cp_dump_tree): Don't try to dump class-specific fields
	for a backend struct.

	* except.c (wrap_cleanups_r, build_throw): Make
	MUST_NOT_THROW_EXPRs void.
	* init.c (expand_default_init): Update to handle MUST_NOT_THROW_EXPR.

	* init.c (build_vec_delete_1): Pre-evaluate the base address.

	* init.c (get_temp_regvar): Simplify logic.

	* tree.c (cp_copy_res_decl_for_inlining): Only do debug tweaks if
	our replacement is a decl.

	* decl.c (cp_make_fname_decl): Push the decls inside the
	outermost scope.

2003-01-03  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/45, c++/3784
	* tree.c (cp_tree_equal, TEMPLATE_PARM_INDEX): The types must be
	the same too.

2003-01-03  Graham Stott  <graham.stott@btinternet.com>

	* parser.c (struct cp_parser): Add access_checks_lists field
	(cp_parser_simple_declaration): Use.
	(cp_parser_init_declarator): Likewise.

2003-01-02  Mark Mitchell  <mark@codesourcery.com>

	* parser.c (cp_parser_declaration): Accept the __extension__
	keyword before the declaration.

	PR c++/2843
	* parser.c (cp_parser_parameter_declaration): Allow attributes to
	appear after the declarator.

	* call.c (build_new_method_call): Fix typo in message format
	string.

2003-01-02  Mark Mitchell  <mark@codesourcery.com>

	* parser.c (cp_lexer_next_token_is): Declare it inline.
	(cp_lexer_set_source_position_from_token): Likewise.
	(cp_lexer_debugging_p): Likewise.
	(cp_parser_parsing_tentatively): Likewise.
	(cp_parser_nested_name_specifier_opt): Reduce the number of calls
	to the cp_lexer_peek_token.

	* parser.c (cp_parser_sizeof_operand): Do not evaluate the
	expression.

2003-01-02  Steven Bosscher <s.bosscher@student.tudelft.nl>

	* cp/except.c, cp/expr.c, cp/friend.c, cp/g++spec.c,
	cp/lang-options.h, cp/lang-specs.h, cp/lex.h, cp/ptree.c,
	cp/repo.c: Fix copyright years.

2003-01-01  Neil Booth  <neil@daikokuya.co.uk>

	* lex.c: Remove superfluous include of cpplib.h.
	(CONSTRAINT): Define without conditions.
	(init_cp_pragma): Use c_register_pragma.

2002-12-31  Neil Booth  <neil@daikokuya.co.uk>

	* .cvsignore: Remove.

2002-12-31  Steven Bosscher  <s.bosscher@student.tudelft.nl>

	* call.c, class.c, cp-lang.c, cp-tree.h, cvt.c, dump.c, error.c,
	  except.c, expr.c friend.c, g++spec.c, init.c, lang-options.h,
	  lang-specs.h, lex.c, mangle.c, method.c, optimize.c, parser.c,
	  pt.c, ptree.c, repo.c, rtti.c, search.c, semantics.c, tree.c,
	  typeck.c, typeck2.c: Replace "GNU CC" with "GCC" in the
	  copyright header.
	* lex.h: parse.y is dead, so don't mention it.  Also replace the
	  copyright header with the default GNU copyright header.

2002-12-31  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (LOOKUP_TEMPLATES_EXPECTED): Remove.
	(lookup_name_namespace_only): Likewise.
	(begin_only_namespace_names): Likewise.
	(end_only_namespace_names): Likewise.
	* decl.c (only_namespace_names): Remove.
	(qualify_lookup): Do not check LOOKUP_TEMPLATES_EXPECTED.
	(lookup_name_real): Do not check only_namespace_names.
	(lookup_name_namespace_only): Remove.
	(begin_only_namespace_names): Likewise.
	(end_only_namespace_names): Likewise.
	* parser.c (cp_parser_nested_name_specifier_opt): Handle erroneous
	nested-name-specifiers more gracefully.
	(cp_parser_class_or_namespace_name): Avoid looking up namespace
	names when they cannot possibly appear.
	(cp_parser_template_name): Adjust call to cp_parser_lookup_name.
	(cp_parser_elaborated_type_specifier): Likewise.
	(cp_parser_namespace_name): Only look for namespace names.
	(cp_parser_lookup_name): Add is_namespace parameter.
	(cp_parser_lookup_name_simple): Adjust call to
	cp_parser_lookup_name.

	* parser.c (cp_parser_dependent_type_p): Fix thinko.

2002-12-31  Neil Booth  <neil@daikokuya.co.uk>

	* .cvsignore: Update.

2002-12-31  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (modify_vtable_entry): Remove unused variable.
	(get_vcall_index): Always expect a non-thunk.
	(update_vtable_entry_for_fn): Combine covariant adjustments, when
	overriding a thunk. Pass get_vcall_index a non-thunk.

	* decl2.c (finish_file): Mark undefined inlines as extern.

2002-12-31  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.def (RETURN_INIT): Remove.
	* cp-tree.h (DECL_IN_MEMORY_P): Remove.
	(scope_kind): Add sk_block, sk_try, sk_catch, sk_for.
	(note_level_for_for): Remove.
	(note_level_for_try): Likewise.
	(note_level_for_catch): Likewise.
	(finish_named_return_value): Likewise.
	(do_pushlevel): Change prototype.
	(pending_lang_change): Remove.
	* decl.c (begin_scope): Handle sk_block, sk_try, sk_catch,
	sk_for.
	(note_level_for_for): Remove.
	(note_level_for_try): Likewise.
	(note_level_for_catch): Likewise.
	(maybe_inject_for_scope_var): Remove use of DECL_IN_MEMORY_P.
	* parser.c (cp_parser_context_free_list): Make it "deletable".
	(cp_parser_template_argument): Remove misleading comment.
	* pt.c (tsubst_expr): Remove RETURN_INIT code.
	* semantics.c (genrtl_named_return_value): Remove.
	(do_pushlevel): Take a scope kind as an argument.
	(begin_if_stmt): Adjust.
	(begin_while_stmt): Likewise.
	(begin_for_stmt): Likewise.
	(finish_for_init_stmt): Likewise.
	(begin_switch_stmt): Likewise.
	(begin_handler): Likewise.
	(begin_compound_stmt): Likewise.
	(finish_named_return_value): Remove.
	(cp_expand_stmt): Remove RETURN_INIT case.
	* tree.c (cp_statement_code_p): Remove RETURN_INIT case.

2002-12-31  Mark Mitchell  <mark@codesourcery.com>

	PR c++/9112
	* parser.c (cp_parser_direct_declarator): Handle erroneous
	parenthesized declarators correctly.

2002-12-31  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cp-tree.h (pending_lang_change): Declare.

2002-12-30  Mark Mitchell  <mark@codesourcery.com>

	* parser.c (cp_parser_context_free_list): New variable.
	(cp_parser_context_new): Use it.
	(cp_parser_error): Check return code from
	cp_parser_simulate_error.
	(cp_parser_simulate_error): Return a value.
	(cp_parser_id_expression): Optimize common case.
	(cp_parser_class_name): Likewise.
	(cp_parser_class_specifier): Adjust call to
	cp_parser_late_parsing_default_args.
	(cp_parser_lookup_name): Optimize common case.
	(cp_parser_late_parsing_for_member): Adjust call to
	cp_parser_late_parsing_default_args.
	(cp_parser_late_parsing_default_args): Add scope parameter.
	(cp_parser_require): Avoid creating the error message unless it's
	needed.
	(cp_parser_parse_definitely): Place free'd contexts on the free
	list.

	* parser.c (cp_parser_declaration_seq_opt): Handle pending_lang_change.

2002-12-30  David Edelsohn  <edelsohn@gnu.org>

	* parser.c (cp_parser_parameter_declaration_clause): Treat system
	header as extern "C" if NO_IMPLICIT_EXTERN_C undefined.

2002-12-30  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config-lang.in, Make-lang.in, operators.def, cp-tree.def:
	GCC, not GNU CC.

2002-12-30  Mark Mitchell  <mark@codesourcery.com>

	* parse.y: Remove.
	* spew.c: Likewise.
	* Make-lang.in (gt-cp-spew.h): Remove.
	* cp-tree.h (do_pending_lang_change): Remove.
	(do_identifier): Change prototype.
	(finish_id_expr): Remove.
	* decl.c (lookup_name_real): Remove yylex variable.
	* decl2.c (build_expr_from_tree): Adjust call to do_identifier.
	* lex.c (init_cpp_parse): Remove.
	(reduce_cmp): Likewise.
	(token_cmp): Likewise.
	(yychar): Likewise.
	(lastiddecl): Likewise.
	(token_count): Likewise.
	(reduce_count): Likewise.
	(yyhook): Likewise.
	(print_parse_statistics): Likewise.
	(do_pending_lang_change): Likewise.
	(do_identifier): Remove parsing parameter.
	* lex.h (lastiddecl): Remove.
	(looking_for_typename): Remove.
	(looking_for_template): Likewise.
	(pending_lang_change): Likewise.
	(yylex): Likewise.
	* semantics.c (finish_id_expr): Remove.

	* decl.c (grokdeclarator): Diagnost "extern thread" and "static
	thread" correctly.

2002-12-30  Nathanael Nerode  <neroden@gcc.gnu.org>

	* decl.c, decl2.c, decl.h:  GCC, not GNU CC.  This is the C++ front
	end, not the C front end.

2002-12-30  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (THUNK_TARGET): New macro.
	(THUNK_VIRTUAL_OFFSET): For result thunks it is always a binfo.
	(finish_thunk): Remove offset parms.
	* class.c (find_final_overrider): Look through thunks.
	(get_vcall_index): Use THUNK_TARGET.
	(update_vtable_entry_for_fn): Look through thunks. Set covariant
	fixed offset here. Adjust finish_thunk call.
	(build_vtbl_initializer): Adjust finish_thunk calls.
	* mangle.c (mangle_call_offset): Remove superfluous if.
	(mangle_thunk): Adjust.
	* method.c (make_thunk): Adjust.
	(finish_thunk): Adjust.
	(thunk_adjust): Remove assert.
	(use_thunk): Use THUNK_TARGET
	* dump1.c (cp_dump_tree): Adjust thunk dumping.

	PR c++/9054
	* class.c (layout_class_type): Set TYPE_CONTEXT of type for base.
	* dump.c (cp_dump_tree, RECORD_TYPE): Deal with type for base types.

2002-12-28  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Remove traditional C constructs 4/n.
	* decl2.c (grok_method_quals, warn_if_unknown_interface,
	grok_x_components, cp_build_parm_decl, build_artificial_parm,
	maybe_retrofit_in_chrg, grokclassfn, grok_array_decl,
	delete_sanity, check_member_template, check_java_method,
	check_classfn, finish_static_data_member_decl, grokfield,
	grokbitfield, grokoptypename, grok_function_init,
	cplus_decl_attributes, constructor_name, defer_fn,
	build_anon_union_vars, finish_anon_union, coerce_new_type,
	coerce_delete_type, comdat_linkage, maybe_make_one_only,
	key_method, import_export_vtable, import_export_class,
	output_vtable_inherit, import_export_decl, import_export_tinfo,
	build_cleanup, get_guard, get_guard_bits, get_guard_cond,
	set_guard, start_objects, finish_objects,
	start_static_storage_duration_function,
	finish_static_storage_duration_function, get_priority_info,
	start_static_initialization_or_destruction,
	finish_static_initialization_or_destruction,
	do_static_initialization, do_static_destruction,
	prune_vars_needing_no_initialization, write_out_vars,
	reparse_decl_as_expr, finish_decl_parsing, namespace_ancestor,
	add_using_namespace, merge_functions, ambiguous_decl,
	lookup_using_namespace, lookup_using_namespace,
	qualified_lookup_using_namespace, set_decl_namespace,
	decl_namespace, current_decl_namespace, push_decl_namespace,
	pop_decl_namespace, push_scope, pop_scope, add_function,
	arg_assoc_namespace, arg_assoc_template_arg, arg_assoc,
	lookup_arg_dependent, do_namespace_alias,
	validate_nonmember_using_decl, do_nonmember_using_decl,
	do_toplevel_using_decl, do_local_using_decl,
	do_class_using_decl, do_using_directive, check_default_args,
	mark_used, handle_class_head): Use C90 prototypings.  Use booleans.
	* parser.c (cp_parser_class_head): Use booleanss.
	* decl.c (walk_globals, walk_vtables): Likewise.
	* cp-tree.h (walk_globals_pred, walk_globals_fn, walk_vtables,
	walk_globals): Change return type from 'int' to 'bool'.
	* rtti.c (init_rtti_processing, build_headof, throw_bad_cast
	throw_bad_typeid, get_tinfo_decl_dynamic, typeid_ok_p,
	build_typeid, tinfo_name, get_tinfo_decl, get_tinfo_ptr,
	get_typeid, ifnonnull, build_dynamic_cast_1, build_dynamic_cast,
	qualifier_flags, tinfo_base_init, generic_initializer,
	ptr_initializer, dfs_class_hint_mark, ptm_initializer,
	dfs_class_hint_unmark, class_hint_flags, class_initializer,
	typeinfo_in_lib_p, get_pseudo_ti_init, create_pseudo_type_info,
	get_pseudo_ti_desc, create_tinfo_types, emit_support_tinfos,
	unemitted_tinfo_decl_p, emit_tinfo_decl): Likewise.
	* repo.c (repo_compile_flags, repo_template_declared,
	repo_template_defined, repo_class_defined, repo_get_id,
	repo_template_used, repo_vtable_used, repo_inline_used,
	repo_tinfo_used, repo_template_instantiated, extract_string,
	open_repo_file, afgets, init_repo, reopen_repo_file_for_write,
	finish_repo): Likewise.
	* ptree.c (cxx_print_decl, cxx_print_type, cxx_print_identifier,
	cxx_print_xnode): Likewise..
	* cp-lang.c (ok_to_generate_alias_set_for_type, cxx_get_alias_set,
	cxx_warn_unused_global_decl, cp_expr_size): Likewise.
	* cxxfilt.c (demangle_it, print_demangler_list, usage,
	standard_symbol_characters, hp_symbol_characters, main, fatal):
	Likewise.
	(strip_underscore):  Change type from 'int' to 'bool'.
	(main): Use boolean constants.

2002-12-28  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Remove traditional C constructs 3/n.
	* cvt.c (cp_convert_to_pointer, convert_to_pointer_force,
	build_up_reference, warn_ref_binding, convert_to_reference,
	convert_from_reference, convert_lvalue, cp_convert, ocp_convert,
	convert_to_void, convert, convert_force, build_type_conversion,
	build_expr_type_conversion, type_promotes_to,
	perform_qualification_conversions): Use C90 prototyping style.
	* decl2.c (grok_array_decl): Use boolean constant.
	(delete_sanity): Likewise.
	* typeck.c (build_unary_op): Likewise.
	* semantics.c (finish_switch_cond): Likewise.
	* parser.c (cp_parser_direct_new_declarator): Likewise.
	* init.c (build_new): Likewise.

2002-12-27  Mark Mitchell  <mark@codesourcery.com>

	* Make-lang.in (po-generated): Remove parse.c.
	(CXX_OBJS): Remove parse.o and spew.o.  Add parser.o.
	($(srcdir)/cp/parse.h): Remove target.
	($(srcdir)/cp/parse.c): Likewise.
	(gt-cp-parse.h): Likewise.
	(gt-cp-parser.h): New target.
	(c++.distclean): Do not remove parse.output.
	(c++.maintainer-clean): Do not remove parse.c or parse.h.
	(cp/spew.o): Remove target.
	(cp/lex.o): Adjust dependencies.
	(cp/pt.o): Likewise.
	(cp/parse.o): Likewise.
	(cp/TAGS): Do not mention parse.c.
	(cp/parser.o): New target.
	* NEWS: Mention the new parser.
	* call.c (build_scoped_method_call): Simplify.
	(build_method_call): Likewise.
	(build_new_function_call): Adjust calls to add_function_candidate
	and add_template_candidate.
	(build_new_op): Improve handling of erroroneous operands.
	(convert_default_arg): Remove circular argument processing.
	(name_as_c_string): New function.
	(build_new_method_call): Use it.
	(perform_implicit_conversion): Use error_operand_p.
	* class.c (finish_struct_anon): Use constructor_name_p.
	(check_field_decls): Likewise.
	(pop_nested_class): Use OVL_NEXT, not OVL_CHAIN.
	(resolve_address_of_overloaded_function): Likewise.
	(instantiate_type): Tweak pointer-to-member handling.
	(get_primary_binfo): Remove incorrect assertion.
	* config-lang.in (gtfiles): Add parser.c, remove parse.c.
	* cp-tree.h (DEFARG_TOKENS): New macro.
	(default_arg): New structure.
	(cp_tree_node_structure_enum): Add TS_CP_DEFAULT_ARG.
	(lang_tree_node): Add default_arg.
	(cp_tree_index): Add CPTI_TYPE_INFO_REF_TYPE.
	(type_info_ref_type): New macro.
	(saved_scope): Make processing_explicit_instantiation a boolean.
	(check_access): New field.
	(unparsed_text): Remove.
	(language_function): Remove unparsed_inlines.
	(error_operand_p): New macro.
	(lang_decl): Adjust pending_inline_info.
	(DEFARG_POINTER): Remove.
	(tag_types): Add typenames.
	(lookup_ualified_name): Declare.
	(lookup_name_real): Likewise.
	(shadow_tag): Adjust prototype.
	(get_scope_of_declarator): Declare it.
	(process_next_inline): Remove it.
	(check_for_missing_semicolon): Likewise.
	(maybe_get_template_decl_from_type_decl): Declare it.
	(finish_label_stmt): Adjust prototype.
	(finish_non_static_data_meber): Declare it.
	(finish_pseudo_destructor_call_expr): Rename to ...
	(finish_pseudo_destructor_expr): ... this.
	(finish_compound_literal): Declare it.
	(begin_inline_definitions): Remove it.
	(init_spew): Remove.
	(peekyylex): Likewise.
	(arbitrate_lookup): Likewise.
	(frob_opname): Likewise.
	(maybe_snarf_defarg): Likewise.
	(add_defarg_fn): Likewise.
	(do_pending_defargs): Likewise.
	(done_pending_defargs): Likewise.
	(unprocessed_defarg_fn): Likewise.
	(replace_defarg): Likewise.
	(end_input): Likewise.
	(get_overloaded_fn): Likewise.
	* cvt.c (convert_to_reference): Improve error handling.
	* decl.c (lookup_name_real): Do not declare it static.
	(maybe_push_to_top_level): Set check_access.
	(identifier_type_value): Adjust call to lookup_name_real.
	(lookup_qualified_name): New method.
	(lookup_name_real): Remove special-case parsing code.
	(lookup_name-nonclass): Adjust call to lookup_name_real.
	(lookup_name_namespace_only): Likewise.
	(lookup_name): Likewise.
	(check_tag_decl): Return the type declared.
	(shadow_tag): Likewise.
	(register_dtor_fn): Tweak check_access.
	(grokfndecl): Use constructor_name_p.
	(get_scope_of_declarator): New function.
	(grokdeclarator): Obscure tweaks for slightly different declarator
	representations.
	(start_method): Return error_mark_node to indicate failure.
	(cp_tree_node_structure_enum): Use TS_CP_DEFAULT_ARG for DEFAULT_ARGs.
	* decl2.c (constructor_name_full): Simplify.
	(constructor_name): Use it.
	(build_expr_from_tree): Adjust for changes to do new parser.
	(push_scope): Improve robustness.
	(validate_nonmember_using_decl): Process declarations, not names.
	(do_class_using_decl): Likewise.
	(handle_class_head): Do not mess with CLASSTYPE_DECLARED_CLASS
	here.
	* error.c (dump_expr): Handle IDENTIFIER_NODEs and BASELINKs.
	* expr.c (cxx_expand_expr): Handle BASELINKs.
	* init.c (member_init_ok_or_else): Issue more errors.
	(build_offset_ref): Tweak handling of FUNCTION_DECLs.
	* lex.c: Do not include parse.h.
	(yypring): Do not declare.
	(yylval): Likewise.
	(make_reference_declarator): Remove error-generating code.
	(rid_to_yy): Remove.
	(cxx_init): Do not call init_spew.
	(yypring): Remove.
	(check_for_missing_semicolon): Remove.
	* lex.h (got_scope): Remove.
	(got_object): Remove.
	* method.c (hack_identifier): Use finish_non_static_data_member.
	(implicitly_declare_fn): Adjust use of constructor_name.
	* parser.c: New file.
	* pt.c (parse.h): Do not include it.
	(maybe_get_template_decl_from_template): Do not declare it.
	(finish_member_template_decl): Tweak.
	(begin_explicit_instantiation): Adjust for
	processing_explicit_instantiation being boolean.
	(end_explicit_instantiation): Likewise.
	(maybe_process_partial_specialization): Tighten specialization
	test.
	(retrieve_local_specialization): Adjust ue of hash table.
	(eq_local_specializations): New function.
	(register_local_specialization): Likewise.
	(push_template_decl_real): Remove unnecessary test.
	(maybe_get_template_decl_from_type_decl): Don't make it static.
	(for_each_template_parm_r): Handle TYPEOF_TYPE.
	(tsubst_copy): Use retrieive_local_specialization to handle
	PARM_DECL.  Adjust handling of CONST_DECLs.  Handle BASELINKs.
	Handle COMPONENT_REFs with pseudo-destructor-expressions.
	Simplify handling of CALL_EXPR and METHOD_CALL_EXPR.
	(tsubst_expr): Pass decls, not names, to do_local_using_decl.
	(unify): Tweak handling of CONST_DECLs.
	(regenerate_decl_from_template): Use push_nested_class.
	(template_for_substitution): New funciton.
	(instantiate_decl): Use it.  Register parameters as local
	specializations.
	* rtti.c (init_rtti_processing): Set type_info_ref_type.
	(build_typeid): Use it.
	(get_typeid): Likeise.
	* search.c (accessible_p): Use check_access, not
	flag_access_control.
	(adjust_result_of_qualified_name_lookup): Pay attention to the
	context_class.
	* semantics.c (finish_asm_stmt): Adjust error handling.
	(finish_label_stmt): Return the statement.
	(finish_non_static_data_member): New function.
	(finish_class_expr): Handle BASELINKs.
	(finish_call_expr): Handle PSEUDO_DTOR_EXPR.
	(finish_object_call_expr): Simplify handling during templates.
	(finish_pseudo_destructor_call_expr): Rename to ...
	(finish_pseudo_dtor_expr): ... this.
	(finish_compound_literal): New function.
	(begin_inline_definitions): Remove.
	(finish_sizeof): Remove special template handling.
	* spew.c: Do not include parse.h.
	* tree.c (get_overloaded_fn): Remove.
	* typeck.c (build_class_member_access_expr): Handle
	PSEUDO_DTOR_EXPR.  Adjust handling of static member functions.
	(lookup_destructor): New function.
	(finish_class_member_access_expr): Use it.
	(convert_arguments): Simplify.
	(build_unary_op): Handle BASELINKs.

2002-12-26  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/4803
	* decl2.c (mark_used): Defer inline functions.
	(finish_file): Merge deferred_fns loops. Check all used
	inline functions have a definition.
	* method.c (make_thunk): Thunks are not inline.

	PR c++/5116, c++/764
	* call.c (build_new_op): Make sure template class operands are
	instantiated.

2002-12-24  Nathan Sidwell  <nathan@codesourcery.com>

	PR C++/7964
	* cp-tree.h (resolve_scoped_fn_name): Prototype.
	* call.c (resolve_scoped_fn_name): New function. Deal with
	more template expansion. Broken out of ...
	* parse.y (parse_finish_call_expr): ... here. Call it.
	* decl2.c (build_expr_from_tree, CALL_EXPR): Use
	resolve_scoped_fn_name and build_call_from_tree.

	PR c++/9053
	* decl.c (duplicate_decls): Templates may be disambiguated by
	return type.

	PR c++/8702
	* decl2.c (check_classfn): Use lookup_fnfield_1. List all
	conversion operators on failure.

2002-12-23  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Remove traditional C constructs 2/n.
	* call.c (tourney, build_field_call, equal_functions, joust,
	compare_ics, build_over_call, build_java_interface_fn_ref,
	convert_like_real, op_error, build_object_call, resolve_args,
	build_vfield_ref, check_dtor_name, build_scoped_method_call,
	build_addr_func, build_call, build_method_call, null_ptr_cst_p,
	sufficient_parms_p, build_conv, non_reference, strip_top_quals,
	standard_conversion, reference_related_p,
	reference_compatible_p, convert_class_to_reference,
	direct_reference_binding, reference_binding,
	,implicit_conversion, is_complete, promoted_arithmetic_type_p,
	add_template_conv_candidate, any_viable, any_strictly_viable,
	build_this, splice_viable, print_z_candidates,
	build_user_type_conversion, build_new_function_call,
	conditional_conversion, build_conditional_expr, build_new_op,
	build_op_delete_call, enforce_access, call_builtin_trap,
	convert_arg_to_ellipsis, build_x_va_arg, cxx_type_promotes_to,
	convert_default_arg, type_passed_as, convert_for_arg_passing,
	in_charge_arg_for_name, is_properly_derived_from,
	maybe_handle_implicit_object, maybe_handle_ref_bind,
	source_type, add_warning, can_convert, can_convert_arg,
	perform_implicit_conversion, can_convert_arg_bad,
	initialize_reference, add_conv_candidate,
	add_template_candidate_real, add_template_candidate): Ansify.

2002-12-22  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/8572
	* cp-tree.h (grokoptypename): Add SCOPE parameter.
	* decl2.c (grokoptypename): Add SCOPE parameter. tsubst the type
	if in a template scope.
	* parse.y (unoperator): Return the scope.
	(operator_name): Adjust grokoptypename call.

2002-12-22  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	* cp-tree.h (make_unbound_class_template): Use tsubst_flags_t.
	* decl.c (make_unbound_class_template): Adjust.  Check for tf_error.
	* pt.c (tsubst) [OFFSET_TYPE]: Check for tf_error.

2002-12-20  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Fix a typo.
	* class.c: Fix comment typos.
	* cp-tree.h: Likewise.

2002-12-18  Jason Merrill  <jason@redhat.com>

	Handle anonymous unions at the tree level.
	C++ ABI change: Mangle anonymous unions using the name of their
	first named field (by depth-first search).  Should not cause
	binary compatibility problems, though, as the compiler previously
	didn't emit anything for affected unions.
	* cp-tree.def (ALIAS_DECL): New tree code.
	* decl2.c (build_anon_union_vars): Build ALIAS_DECLs.  Return the
	first field, not the largest.
	(finish_anon_union): Don't mess with RTL.  Do set DECL_ASSEMBLER_NAME,
	push the decl, and write it out at namespace scope.
	* decl.c (lookup_name_real): See through an ALIAS_DECL.
	(pushdecl): Add namespace bindings for ALIAS_DECLs.
	* rtti.c (unemitted_tinfo_decl_p): Don't try to look at the name
	of a decl which doesn't have one.
	* typeck.c (build_class_member_access_expr): Don't recurse if
	we already have the type we want.

2002-12-18  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8099
	* friend.c (make_friend_class): Allow partial specialization
	when declaration is not a template friend.

2002-12-18  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/3663
	* pt.c (lookup_template_class): Copy TREE_PRIVATE and
	TREE_PROTECTED to created decl nodes.

2002-12-18  Mark Mitchell  <mark@codesourcery.com>

	* class.c (build_base_field): Do not set DECL_PACKED on the
	FIELD_DECL.

2002-12-18  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* cp-tree.h (struct tree_srcloc): Use location_t.
	(SOURCE_LOCUS): New.
	(SRCLOC_FILE, SRCLOC_LINE): Adjust.

2002-12-17  Jason Merrill  <jason@redhat.com>

	* decl.c (finish_function): Also complain about no return in
	templates.
	* semantics.c (finish_return_stmt): Also call check_return_expr in
	templates.
	* typeck.c (check_return_expr): In a template, just remember that we
	saw a return.

2002-12-16  Jason Merrill  <jason@redhat.com>

	* semantics.c (simplify_aggr_init_exprs_r): Don't change the type
	of the CALL_EXPR.

	* semantics.c (do_pushlevel): Call pushlevel after adding the
	SCOPE_STMT.
	(do_poplevel): Call poplevel before adding the SCOPE_STMT.
	* parse.y (function_body): Go back to using compstmt.
	* decl.c (pushdecl): Skip another level to get to the parms level.

	* call.c (build_new_method_call): Use is_dummy_object to determine
	whether or not to evaluate the object parameter to a static member
	function.

2002-12-14  Jason Merrill  <jason@redhat.com>

	* semantics.c (simplify_aggr_init_exprs_r): Also prepend the
	return slot for normal functions.  Set CALL_EXPR_HAS_RETURN_SLOT_ADDR.
	* tree.c (build_cplus_new): If the type isn't TREE_ADDRESSABLE,
	don't bother with an AGGR_INIT_EXPR.
	(cp_copy_res_decl_for_inlining): If the type isn't TREE_ADDRESSABLE,
	just generate a new decl normally.  Take return slot parm.
	* cp-tree.h: Adjust prototype.

2002-12-13  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR C++/8031
	* cvt.c (convert_to_pointer_force): Don't try comparing against
	erronous type.

2002-12-13  Geoffrey Keating  <geoffk@apple.com>

	* cp-tree.h: Have the multiple-include guards around
	the entire file.

2002-12-10  David Edelsohn  <edelsohn@gnu.org>

	* cp/spew.c (feed_input): Change limit to last_pos and pos to cur_pos
	for SPEW_DEBUG.
	(snarf_method): Same.
	(snarf_defarg): Same.

2002-12-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8372
	* pt.c (tsubst_copy): Handle destructor names more correctly.

2002-12-10  Matt Austern   <austern@apple.com>

	* cp-tree.h: get rid of needs_virtual_reinit bit.

2002-12-09  Mark Mitchell  <mark@codesourcery.com>

	* NEWS: Document removal of in-class initialization extension for
	static data members of non-arithmetic, non-enumeration type.
	* decl.c (check_static_variable_definition): Do not allow that
	extension.
	* decl2.c (grokfield): Do not call digest_init when processing
	templates.

2002-12-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* error.c (dump_expr): Fix format specifier warning.

2002-12-04  Geoffrey Keating  <geoffk@apple.com>

	* class.c (finish_struct_1): Correct comment.
	* cp-tree.c (DECL_SORTED_FIELDS): Likewise.

2002-12-04  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR C++/8799
	* error.c (dump_expr): Don't ever try to dump a non-existent
	expression.

2002-12-03  Nathan Sidwell  <nathan@codesourcery.com>

	Implement covariant returns.
	* cp-tree.h (IS_AGGR_TYPE_2): Remove.
	(struct lang_decl_flags): Add this_thunk_p flag.
	Rename vcall_offset to virtual_offset.
	(struct lang_decl): Rename delta to fixed_offset.
	(DECL_THIS_THUNK_P, DECL_RESULT_THUNK_P): New #defines.
	(SET_DECL_THUNK_P): Add THIS_ADJUSTING arg.
	(THUNK_DELTA, THUNK_VCALL_OFFSET): Rename to ...
	(THUNK_FIXED_OFFSET, THUNK_VIRTUAL_OFFSET): ... here.
	(make_thunk): Add this_adjusting arg.
	(finish_thunk): Declare.
	(mangle_thunk): Add this_adjusting arg.
	* class.c (get_vcall_index): Use base function for lookup.
	(update_vtable_entry_for_fn): Generate covariant thunk.
	(finish_struct_1): Set DECL_VINDEX to NULL for thunks.
	(build_vtbl_initializer): Use base function for lookup.
	Finish covariant thunk here. Adjust thunk generation.
	* dump.c (cp_dump_tree): Simplify DECL_GLOBAL_[CD]TOR_P handling.
	Adjust thunk dumping.
	* mangle.c (mangle_call_offset): New function.
	(mangle_thunk): Adjust for covariant thunks.
	* method.c (make_thunk): Adjust. Do not set name here.
	(finish_thunk): New function. Set name here.
	(use_thunk): Generate covariant thunks too.
	(thunk_adjust): New function.
	* search.c (covariant_return_p): Remove. Fold into ...
	(check_final_overrider): ... here. Simplify.
	* semantics.c (emit_associated_thunks): Walk covariant thunk lists.

2002-12-03  Jason Merrill  <jason@redhat.com>

	PR c++/8674
	* call.c (build_over_call): Check specifically for TARGET_EXPR
	when eliding.

	PR c++/8461, c++/8625
	* call.c (convert_for_arg_passing): Don't mess with error_mark_node.
	(cp_convert_parm_for_inlining): Remove.
	* cp-lang.c (LANG_HOOKS_TREE_INLINING_CONVERT_PARM_FOR_INLINING):
	Remove.
	* cp-tree.h (ADDR_IS_INVISIREF): Remove.
	* except.c (stabilize_throw_expr): Remove ADDR_IS_INVISIREF code.

	* call.c (build_user_type_conversion_1): Don't set ICS_BAD_FLAG on
	an ambiguous conversion.

2002-12-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8688
	* decl.c (reshape_init): Handle erroneous initializers.

2002-12-02  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8720
	* spew.c (remove_last_token): Make sure that last_chunk is set
	correctly.

	PR c++/8615
	* error.c (dump_expr): Handle character constants with
	TREE_OVERFLOW set.

2002-12-02  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	DR 180
	* decl.c (grokdeclarator): Require class-key for all friend class.
	Output the correct type and context in the error message.

2002-12-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/5919
	* pt.c (unify): Use variably_modified_type_p to test validity of
	template argument types.

	PR c++/8727
	* cp-tree.h (lang_type_class): Add typeinfo_var.
	(CLASSTYPE_TYPEINFO_VAR): New macro.
	* rtti.c (get_tinfo_decl): Use it.

	PR c++/8663
	* init.c (expand_member_init): Always get the main variant of a
	base class.

2002-12-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8332
	PR c++/8493
	* decl.c (cxx_init_decl_processing): Use size_type_node, not
	c_size_type_node.
	* decl2.c (coerce_new_type): Likewise.
	* except.c (do_allocate_exception): Likewise.

2002-11-30  Zack Weinberg  <zack@codesourcery.com>

	* call.c, class.c, cp-lang.c, cvt.c, cxxfilt.c, decl.c, decl2.c,
	dump.c, error.c, except.c, expr.c, friend.c, g++spec.c, init.c,
	lex.c, mangle.c, method.c, optimize.c, parse.y, pt.c, ptree.c,
	repo.c, rtti.c, search.c, semantics.c, spew.c, tree.c, typeck.c,
	typeck2.c: Include coretypes.h and tm.h.
	* Make-lang.in: Update dependencies.

2002-11-30  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8227
	* decl.c (layout_var_decl): Deal gracefully with erroneous types.
	(check_initializer): Validate the type of the initialized
	variable, even if the initializer is absent.
	* typeck.c (cp_type_quals): Deal gracefully with erroneous types.

	PR c++/8214
	* typeck.c (convert_for_assignment): Do not use
	decl_constant_value on the operand.

	PR c++/8511
	* pt.c (instantiate_decl): Handle template friends defined outside
	of the class correctly.

2002-11-29  Joe Buck <jbuck@synopsys.com>

	* parse.y (class_head_defn): Set CLASSTYPE_DECLARED_CLASS for
	anonymous structs.

2002-11-29  Mark Mitchell  <mark@codesourcery.com>

	* class.c (walk_subobject_offsets): Recur on binfos as well as on
	types.
	(layout_nonempty_base_or_field): Pass it a binfo when processing a
	base class.
	(layout_empty_base): Likewise.
	(build_base_field): Likewise.

2002-11-27  Mark Mitchell  <mark@codesourcery.com>

	* class.c (build_base_field): Make sure we get the canonical base
	when descending through primary bases.

2002-11-26  Geoffrey Keating  <geoffk@apple.com>

	* decl.c (check_initializer): Don't error on initialisation of
	a scalar with a brace-enclosed expression.

2002-11-26  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (DECL_LANG_FLAG_4): Document more uses.
	(template_parms_equal): Remove prototype.
	* typeck.c (buuld_indirect_ref): Reformat.

2002-11-25  Jason Merrill  <jason@redhat.com>

	* init.c (build_vec_init): Use a FOR_STMT instead of an IF_STMT
	and a DO_STMT.

2002-11-25  Mark Mitchell  <mark@codesourcery.com>

	* tree.c (cp_build_qualified_type_real): Correct handling of
	array types.
	* class.c (walk_subobject_offsets): Fix thinko.
	(build_base_field): Record offsets of empty bases in primary
	virtual bases.
	(layout_class_type): Record offsets of empty bases in fields.

	* search.c (is_subobject_of_p_1): Fix thinko.
	(lookup_field_queue_p): Likewise.

2002-11-24  Mark Mitchell  <mark@codesourcery.com>

	* class.c (layout_class_type): Reuse tail padding when laying out
	virtual bases.

2002-11-22  Mark Mitchell  <mark@codesourcery.com>

	* rtti.c (qualifier_flags): Fix thinko.

2002-11-21  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Remove traditional C constructs 1/n.
	* cp-tree.h (init_method, set_mangled_name_for_decl,
	build_opfncall, hack_identifier, make_thunk, use_thunk,
	synthesize_method, implicitly_declare_fn,
	skip_artificial_parms_for, optimize_function, calls_setjmp_p,
	maybe_clone_body): Remove use of PARAMS.

	* method.c (do_build_assign_ref, do_build_copy_constructor,
	synthesize_exception_spec, locate_dtor, locate_ctor, locate_copy):
	Likewise.
	(synthesize_method): Use 'bool' type and constants instead of
	'int'.
	(locate_copy): Likewise.
	(implicitly_declare_fn): Likewise.

	* optimize.c (calls_setjmp_r, update_cloned_parm, dump_function):
	Remove old-style declaration.
	(maybe_clone_body): Use 'bool' type and constants.

2002-11-21  Glen Nakamura  <glen@imodulo.com>

	PR c++/8342
	* typeck.c (get_member_function_from_ptrfunc): Make sure that a
	SAVE_EXPR for instance_ptr doesn't get evaluated first inside one
	of the branches of a COND_EXPR.

2002-11-19  Mark Mitchell  <mark@codesourcery.com>

	* pt.c (for_each_template_parm): Free allocated memory.
	* search.c (is_subobject_of_p_1): New function.
	(is_subobject_of_p): Avoid walking virtual bases multiple times.

2002-11-19  Jason Thorpe  <thorpej@wasabisystems.com>

	* g++spec.c (lang_specific_spec_functions): New.

2002-11-15  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* class.c: Likewise.
	* decl2.c: Likewise.

2002-11-14  Zack Weinberg  <zack@codesourcery.com>

	* search.c (dfs_push_decls): Do not try to reorder elements
	3..n of method_vec if method_vec has only two elements.
	Reverse order of two tests to avoid accessing unallocated
	memory.

2002-11-14  Mark Mitchell  <mark@codesourcery.com>

	* class.c (dfs_find_final_overrider): Adjust so that the most
	derived object is a binfo, rather than a class type.
	(find_final_overrider): Likewise.
	(add_vcall_offset_vtbl_entries_1): Simplify accordingly.
	(add_vcall_offset): Likewise.

2002-11-09  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/8389
	* pt.c (instantiate_template): Push class scope for member
	functions.
	(get_mostly_instantiated_function_type): Likewise.  Don't call
	tsubst on context.  Remove CONTEXTP and TPARMSP parameters.
	* cp-tree.h (get_mostly_instantiated_function_type): Adjust.
	* mangle.c (write_encoding, write_unqualified_name): Adjust.

2002-11-07  Mark Mitchell  <mark@codesourcery.com>

	* class.c (add_vcall_offset_vtbl_entries_1): Correct ordering of
	vcall offfsets.  Split out ...
	(add_vcall_offset): ... new function.

	PR c++/8338
	* pt.c (for_each_template_parm): Add htab parameter.
	(process_partial_specialization): Adjust call.
	(push_template_decl_real): Likewise.
	(pair_fn_data): Add visited.
	(for_each_template_parm_r): Avoid walking duplicates more than
	once.
	(uses_template_parms): Adjust call to for_each_template_parm.

2002-11-07  Mark Mitchell  <mark@codesourcery.com>

	* class.c (add_implicitly_declared_members): Put implicitly
	declared functions at the end of TYPE_METHODs when -fabi-version
	is at least 2.

2002-11-05  Geoffrey Keating  <geoffk@apple.com>

	* decl2.c (finish_file): Correct spelling.

2002-11-03  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_special_member_call): Do not try to lookup VTTs by
	name.
	* class.c (vtbl_init_data): Add generate_vcall_entries.
	(get_vtable_decl): Do not look up virtual tables by name.
	(copy_virtuals): Do not use BV_USE_VCALL_INDEX_P.
	(set_primary_base): Do not set CLASSTYPE_RTTI.
	(determine_primary_base): Likewise.
	(get_matching_virtual): Remove.
	(get_vcall_index): New function.
	(update_vtable_entry_for_fn): Do not try to use virtual thunks
	when they are not required.  Assign vcall indices at this point.
	(finish_struct_1): Do not set CLASSTYPE_NEEDS_VIRTUAL_REINIT.
	Do update dynamic_classes.
	(build_vtt): Do not add VTTs to the symbol table.
	(build_ctor_vtbl_group): Likewise.
	(build_vtbl_initializer): Simplify handling of vcall indices.
	(build_vcall_offset_vtbl_entries): Pretend to build vcall offsets
	for the most derived class.
	(add_vcall_offset_vtbl_entries_1): But do not actually add them to
	the vtable.
	* cp-tree.h (dynamic_classes): New macro.
	(lang_type_class): Remove rtti.  Add vtables.  Add vcall_indices.
	(CLASSTYPE_RTTI): Remove.
	(CLASSTYPE_NEEDS_VIRTUAL_REINIT): Remove.
	(CLASSTYPE_VCALL_INDICES): New macro.
	(CLASSTYPE_VTABLES): Likewise.
	(BV_USE_VCALL_INDEX_P): Remove.
	(build_vtable_path): Remove.
	* decl2.c (finish_vtable_vardecl): Remove.
	(key_method): Remove #if 0'd code.
	(finish_vtable_vardecl): Rename to ...
	(maybe_emit_vtables): ... this.
	(finish_file): Use it.
	* search.c (look_for_overrides_here): Update comment.

2002-11-01  Zack Weinberg  <zack@codesourcery.com>

	PR c/7353 redux
	* decl2.c (grokfield): Reject TYPE_DECLs with initializers.

2002-10-30  Jason Merrill  <jason@redhat.com>

	PR c++/8186
	* cp-tree.h (ADDR_IS_INVISIREF): New macro.
	* call.c (convert_for_arg_passing): Set it.
	* except.c (stabilize_throw_expr): Recurse for such an arg.

2002-10-31  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (lang_decl_flags): Remove init_priority.
	(lang_decl): Add delta.
	(GLOBAL_INIT_PRIORITY): Remove.
	(THUNK_DELTA): Revise definition.
	* decl2.c (start_objects): Don't set GLOBAL_INIT_PRIORITY.
	* dump.c (cp_dump_tree): Don't dump it.

2002-10-30  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8160
	* typeck2.c (process_init_constructor): Call complete_array_type.

	PR c++/8149
	* decl.c (make_typename_type): Issue errors about invalid results.

2002-10-30  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	Core issue 287, PR c++/7639
	* cp-tree.h (lang_type_class): Add decl_list field.
	(CLASSTYPE_DECL_LIST): New macro.
	(maybe_add_class_template_decl_list): Add declaration.
	* class.c (duplicate_tag_error): Initialize CLASSTYPE_DECL_LIST.
	(unreverse_member_declarations): Reverse CLASSTYPE_DECL_LIST.
	(maybe_add_class_template_decl_list): New function.
	(add_implicitly_declared_members): Use it.
	* decl.c (maybe_process_template_type_declaration): Likewise.
	(pushtag): Likewise.
	* friend.c (add_friend): Likewise.
	(make_friend_class): Likewise.
	* semantics.c (finish_member_declaration): Likewise.
	(begin_class_definition): Initialize CLASSTYPE_DECL_LIST.
	* pt.c (instantiate_class_template): Use CLASSTYPE_DECL_LIST
	to process members and friends in the order of declaration.

2002-10-29  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8287
	* decl.c (finish_destructor_body): Create the label to jump to
	when returning from a destructor here.
	(finish_function_body): Rather than here.

2002-10-25  Zack Weinberg  <zack@codesourcery.com>

	PR c++/7266
	* decl.c (grokdeclarator): Check that TREE_OPERAND 0 of a
	SCOPE_REF is not null before dereferencing it.

2002-10-25  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_over_call): Use DECL_CONTEXT, not
	DECL_VIRTUAL_CONTEXT.
	* class.c (modify_vtable_entry): Don't mess with
	DECL_VIRTUAL_CONTEXT.
	(set_vindex): Remove.
	(set_primary_base): Remove vfuns_p parameter.
	(determine_primary_base): Likewise.
	(modify_all_vtables): Likewise.
	(layout_class_type): Likewise.  Adjust calls to other functions
	accordingly.
	(finish_struct_1): Adjust calls to modified functions.  Set
	DECL_VINDEX here.
	* cp-tree.h (lang_type_class): Remove vsize.
	(CLASSTYPE_VSIZE): Remove.
	(lang_decl): Remove thunks.
	(DECL_THUNKS): Adjust.
	(DECL_VIRTUAL_CONTEXT): Remove.
	(duplicate_decls): Don't copy it.
	* pt.c (build_template_decl): Don't set it.
	(tsubst_decl): Likewise.
	* typeck.c (expand_ptrmemfunc_cst): Don't use it.

	* class.c (build_vtbl_initializer): Don't use build_vtable_entry.
	(build_vtable_entry): Remove.
	* cp-tree.h (BINFO_VIRTUALS): Expand documentation.
	(lang_decl): Add thunks.
	(DECL_THUNKS): New macro.
	* decl.c (duplicate_decls): Copy it.
	* method.c (make_thunk): Simplify, and add thunks to DECL_THUNKS.
	* semantics.c (emit_associated_thunks): Simplify.

2002-10-24  David Edelsohn  <edelsohn@gnu.org>

	PR c++/7228
	* cp-tree.h (CLASSTYPE_READONLY_FIELDS_NEED_INIT): Check that
	lang_type structure exists before accessing field.
	(SET_CLASSTYPE_READONLY_FIELDS_NEED_INIT): New macro.
	(CLASSTYPE_REF_FIELDS_NEED_INIT): Similar.
	(SET_CLASSTYPE_REF_FIELDS_NEED_INIT): New macro.
	* class.c (check_field_decls): Use new macros.
	* typeck2.c (process_init_constructor): Remove redundant check for
	existence of lang_type structure.

2002-10-24  Mark Mitchell  <mark@codesourcery.com>

	* class.c (end_of_base): New method.
	(end_of_class): Use it.  Check indirect virtual bases.

	* class.c (check_field_decls): Fix typo.

2002-10-23  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8067
	* decl.c (maybe_inject_for_scope_var): Ignore __FUNCTION__ and
	related variables.

	PR c++/7679
	* spew.c (next_token): Do not return an endless stream of
	END_OF_SAVED_INPUT tokens.
	(snarf_method): Add three END_OF_SAVED_INPUT tokens to the end of
	the cached token stream.
	(snarf_defarg): Likewise.

2002-10-23  Zack Weinberg  <zack@codesourcery.com>

	* cp-lang.c (cp_var_mod_type_p): New: C++ hook for
	variably_modified_type_p.
	* cp-tree.h: Remove prototype of variably_modified_type_p.
	* tree.c (variably_modified_type_p): Remove; now implemented
	in language-independent code.

2002-10-22  Mark Mitchell  <mark@codesourcery.com>

	PR c++/6579
	* spew.c (snarf_parenthesized_expression): New function.
	(snarf_block): Use it.

2002-10-22  Richard Henderson  <rth@redhat.com>

	* method.c (use_thunk): Always compute vcall_value; assert that
	it is not zero.  Use can_output_mi_thunk; use output_mi_thunk
	for vcall thunks as well.

2002-10-21  Mark Mitchell  <mark@codesourcery.com>

	* class.c (empty_base_at_nonzero_offset_p): New function.
	(layout_nonempty_base_or_field): Do not check for conflicts when
	laying out a virtual base using the GCC 3.2 ABI.
	(build_base_field): Correct checking for presence of empty classes
	at nonzero offsets when clearing CLASSTYPE_NEARLY_EMPTY_P.

	* class.c (include_empty_classes): Use normalize_rli.
	(layout_class_type): Likewise.

	* decl.c (reshape_init): Tweak handling of character arrays.

	PR c++/8218
	* cp-tree.h (lang_type_class): Add contains_empty_class_p.
	(CLASSTYPE_CONTAINS_EMPTY_CLASS_P): New macro.
	* class.c (check_bases): Update CLASSTYPE_CONTAINS_EMPTY_CLASS_P.
	(check_field_decls): Likewise.
	(layout_class_type): Likewise.
	(finish_struct_1): Initialize it.
	(walk_subobject_offsets): Use it to prune searches.

2002-10-20  Mark Mitchell  <mark@codesourcery.com>

	* method.c (use_thunk): Compute the vcall index as a HOST_WIDE_INT.
	* optimize.c (optimize_function): Replace ASM_OUTPUT_MI_THUNK with
	TARGET_ASM_OUTPUT_MI_THUNK in comments.

2002-10-18  Zack Weinberg  <zack@codesourcery.com>

	* decl.c (start_decl): Point users of the old initialized-
	typedef extension at __typeof__.

2002-10-18  Mark Mitchell  <mark@codesourcery.com>

	* Make-lang.in (method.o): Depend on TARGET_H.
	* method.c (target.h): Include it.
	(use_thunk): Use target hooks.  Use vcall thunks, if available.

2002-10-18  Mark Mitchell  <mark@codesourcery.com>

	* class.c (base_derived_from): Make sure return value is a bool.

2002-10-18  Mark Mitchell  <mark@codesourcery.com>

	* class.c (find_final_overrider_data_s): Remove overriding_fn and
	overriding_base.
	(dfs_base_derived_from): New function.
	(base_derived_from): Likewise.
	(dfs_find_final_overrider): Use base_derived_from.
	(find_final_overrider): Adjust.

2002-10-18  Jason Merrill  <jason@redhat.com>

	PR c++/8080
	* semantics.c (finish_for_cond, finish_while_cond): Don't mess
	with condition decls in a template.

2002-10-17  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (add_method): Compare template parms too.

2002-10-17  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7584
	* class.c (handle_using_decl): Allow the declaration used to be
	from an ambiguous base.

	* pt.c (convert_template_argument): Revert this change:
		2002-10-16  Mark Mitchell  <mark@codesourcery.com>
		* pt.c (convert_template_argument): Do not fold non-type
		template rguments when inside a template.

	* init.c (expand_default_init): Handle brace-enclosed initializers
	correctly.

2002-10-16  Mark Mitchell  <mark@codesourcery.com>

	* mangle.c (write_expression): Correct handling of enumeration
	constants.
	(write_template_arg): Likewise.
	* pt.c (convert_template_argument): Do not fold non-type template
	arguments when inside a template.

	PR c++/7478
	* cvt.c (convert_to_reference): Allow references as the incoming
	type.

2002-10-16  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7524
	* method.c (do_build_assign_ref): Use cp_build_qualified_type, not
	build_qualified_type.

2002-10-15  Richard Henderson  <rth@redhat.com>

	* error.c (dump_expr): Use real_to_decimal directly, and with
	the new arguments.

2002-10-15  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (reshape_init): Fix typo.

	* cp-tree.h (operator_name_info_t): Add arity.
	* lex.c (init_operators): Initialize it.
	* mangle.c (write_conversion_operator_name): New function.
	(write_unqualified_name): Use it.
	(write_template_args): Accept template arguments as a TREE_LIST.
	(write_expression): Adjust handling of qualified names to match
	specification.

2002-10-15  Jason Merrill  <jason@redhat.com>

	* call.c (call_builtin_trap): New fn.
	(convert_arg_to_ellipsis): Use it.  Downgrade error to warning.
	(build_call): Don't set current_function_returns_abnormally outside
	a function.

2002-10-14  Mark Mitchell  <mark@codesourcery.com>

	* class.c (check_field_decls): Remove empty_p parameter.  Instead,
	clear CLASSTYPE_EMPTY_P.
	(build_base_field): Likewise.
	(build_base_fields): Likewise.
	(check_bases_and_members): Likewise.
	(create_vtbl_ptr): Likewise.
	(layout_class_type): Likewise.  Ensure that empty classes have
	size zero when used as base classes in the 3.2 ABI.
	(finish_struct_1): Initialize CLASSTYPE_EMPTY_P and
	CLASSTYPE_NEARLY_EMPTY_P.  Adjust calls to avoid passing empty_p
	parameter.
	(is_empty_class): Correct definition when using post-3.2 ABI.
	* cp-tree.h (lang_type_class): Add empty_p.
	(CLASSTYPE_EMPTY_P): New macro.

2002-10-12  Nathan Sidwell  <nathan@codesourcery.com>

	* init.c (build_delete): Do not apply save_expr for arrays.
	(build_vec_delete): Likewise.

2002-10-14  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (layout_var_decl): Call layout_decl even for variables
	whose type is an array with unspecified bounds.

	PR c++/7176
	* lex.c (do_identifier): Add another option for the parsing
	parameter.
	* parse.y (do_id): Use it.

2002-10-11  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PRs C++/6803, C++/7721 and C++/7803
	* decl.c (grokdeclarator): Gracefully handle template-name as
	decl-specifier.

2002-10-11  Jason Molenda  <jmolenda@apple.com>

	* init.c (build_field_list): Provide uses_unions_p with a default
	value.

2002-10-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/5661
	* cp-tree.h (variably_modified_type_p): New function.
	(grokdeclarator) Tighten check for variably modified types as
	fields.
	* pt.c (convert_template_argument): Do not allow variably modified
	types as template arguments.
	* tree.c (variably_modified_type_p): New function.

	* NEWS: Document removal of "new X = ..." extension.
	* class.c (initialize_array): Set TREE_HAS_CONSTRUCTOR on
	brace-enclosed initializers.
	* cp-tree.h (CP_AGGREGATE_TYPE_P): New macro.
	(initialize_local_var): Remove declaration.
	(expand_static_init): Likewise.
	* decl.c (next_initializable_field): New function.
	(reshape_init): Likewise.
	(check_initializer): Use them.  Build dynamic initializer for
	aggregates here too.
	(initialize_local_var): Simplify, and incorporate cleanup
	insertion code as well.
	(destroy_local_var): Remove.
	(cp_finish_decl): Tidy.
	(expand_static_init): Fold checks for whether or not a variable
	needs initialization into this function.  Simplify.
	* decl2.c (do_static_initialization): Simplify.
	* init.c (build_init): Do not set TREE_SIDE_EFFECTS when it will
	be done for us automatically.
	(expand_default_init): Handle brace-enclosed initializers
	correctly.
	(expand_aggr_init_1): Remove RTL-generation code.
	(build_vec_init): Remove "new X = ..." support.
	* parse.y (new_initializer): Likewise.
	* rtti.c (get_pseudo_ti_init): Set TREE_HAS_CONSTRUCTOR on
	brace-enclosed initializer.
	(create_pseudo_type_info): Likewise.
	* typeck2.c (store_init_value): Don't try to handle digest_init
	being called more than once.
	(digest_init): Tidy handling of brace-enclosed initializers.

2002-10-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (typename_hash): Use htab_hash_pointer.

2002-10-10  Jim Wilson  <wilson@redhat.com>

	* decl.c (duplicate_decls): Don't call decl_attributes.

2002-10-09  Zack Weinberg  <zack@codesourcery.com>

	PR c/7353
	* decl.c (start_decl): Unconditionally issue error for
	'typedef foo = bar'.
	(cp_finish_decl): Remove special case for TYPE_DECL with initializer.
	(grokdeclarator): Remove redundant error for 'typedef foo = bar'.

2002-10-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl2.c (prune_vtable_vardecl): Delete unused function.

2002-10-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7754
	* decl2.c (finish_anon_union): Do not expand anonymous unions when
	procesing template functions.
	* pt.c (tsubst_decl, case VAR_DECL): Try to complete the variable
	type. Call layout_decl.
	(tsubst_expr, case DECL_STMT): Handle anonymous unions.

2002-10-07  Richard Henderson  <rth@redhat.com>

	* decl2.c, pt.c: Revert c++/7754 fix.

2002-10-05  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/7804
	* error.c (dump_expr) [REAL_CST]: Output in decimal format.

2002-10-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7931
	* pt.c (for_each_template_parm_r): Handle BASELINKs.

	PR c++/7754
	* decl2.c (finish_anon_union): Do not expand anonymous unions when
	procesing template functions.
	* pt.c (tsubst_decl, case VAR_DECL): Try to complete the variable
	type. Call layout_decl.
	(tsubst_expr, case DECL_STMT): Handle anonymous unions.

2002-10-03  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8006
	* mangle.c (CLASSTYPE_TEMPLATE_ID_P): Handle instances of template
	template parameters.
	(globals): Add entity and need_abi_warning.
	(decl_is_template_id): Use TYPE_TEMPLATE_INFO, not
	CLASSTYPE_TEMPLATE_INFO.
	(is_std_substitution): Use CLASSTYPE_TI_TEMPLATE, not
	TYPE_TI_TEMPLATE.
	(write_prefix): Handle typename types correctly.
	(write_template_prefix): Handle template template parameters
	correctly.
	(start_mangling): Add entity parameter.
	(finish_mangling): Warn about names whose mangling will change.
	(mangle_decl_string): Adjust.
	(mangle_type_string): Likewise.
	(mangle_special_for_type): Likewise.
	(mangle_ctor_vtbl_for_type): Likewise.
	(mangle_thunk): Likewise.
	(mangle_guard_variable): Likewise.
	(mangle_ref_init_variable): Likewise.

2002-10-02  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7188.
	* cp-tree.def (CTOR_INITIALIZER): Use one slot, not two.
	* cp-tree.h (emit_base_init): Rename to ....
	(emit_mem_initializers): ... this.
	(expand_member_init): Change prototype.
	* init.c (perform_member_init): Compute explicit, rather than
	requiring it as a parameter.
	(sort_member_init): Rename to ...
	(sort_mem_initializers): ... this.  Process bases and data members
	together.
	(sort_base_init): Remove.
	(emit_base_init): Rename to ...
	(emit_mem_initializers): ... this.
	(expand_aggr_vbase_init_1): Remove.
	(construct_virtual_bases): Rename to ...
	(construct_virtual_base): ... this.
	(expand_member_init): Rework handling of base initializers.
	* method.c (do_build_copy_constructor): Use
	finish_mem_initializers.
	* parse.y (member_init): Adjust calls to expand_member_init.
	* pt.c (tsubst_expr): Simplify CTOR_INITIALIZER case.
	(tsubst_initializer_list): Use expand_member_init.
	* semantics.c (finish_mem_intiailizers): Simplify.

2002-10-02  Matt Austern  <austern@apple.com>
	* decl.c (walk_vtables_r): Fixed typo that caused result to
	never get a nonzero value.

2002-10-02  Roger Sayle  <roger@eyesopen.com>

	PR optimization/6627
	* cp-tree.h (enum ptrmemfunc_vbit_where_t): Delete definition
	from here, and move it to tree.h.
	* decl.c (cxx_init_decl_processing): If storing the vbit
	in function pointers, ensure that force_align_functions_log
	is atleast one.

2002-10-02  Matt Austern  <austern@apple.com>

	* class.c (check_field_decls): Changed warning about const member
	variables so that it doesn't get issued for a class aggregate.

2002-10-01  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (cp_finish_decl): Make sure array types are laid out,
	even if the array bounds are unknown.

2002-10-01  Steve Ellcey  <sje@cup.hp.com>

	* class.c (build_vtbl_initializer): Change build_c_cast
	to build1.

2002-10-01  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (cp_finish_decl): Make sure array types are laid out,
	even if the array bounds are unknown.

	* decl.c (cp_finish_decl): Correct check for dynamic
	initialization of thread-local storage.

2002-09-30  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.c (really_overloaded_fn): TEMPLATE_ID_EXPRs are also
	overloaded.

2002-09-30  Steve Ellcey  <sje@cup.hp.com>

	* class.c (build_vtbl_initializer): Add cast.
	(add_vcall_offset_vtbl_entries_1):
	Use TARGET_VTABLE_DATA_ENTRY_DISTANCE for offset.

2002-09-30  Mark Mitchell  <mark@codesourcery.com>

	* class.c (walk_subobject_offsets): Correct the calculation of
	offsets for virtual bases.  Correct the counting of array
	elements.
	(layout_nonempty_base_or_field): Simplify.  Correct the
	calculation of offsets to be propagated through the binfo
	hierarchy.
	(build_base_field): Avoid creating a FIELD_DECL for empty bases.
	Add the FIELD_DECL to TYPE_FIELDS.
	(build_base_fields): Adjust accordingly.
	(layout_virtual_bases): Use build_base_field.
	(end_of_class): Return a tree, not an integer.
	(warn_about_ambiguous_direct_bases): Rename to ...
	(warn_about_ambiguous_bases): ... this.
	(include_empty_classes): New function.
	(layout_class_type): Create an alternative version of the type to
	be used when as a base class type.  Do not call
	finish_record_layout until we are done laying out the class.
	* cp-tree.h (lang_type_class): Remove size, size_unit.  Add
	as_base.
	(CLASSTYPE_SIZE): Reimplement.
	(CLASSTYPE_SIZE_UNIT): Likewise.
	(CLASSTYPE_ALIGN): Likweise.
	(CLASSTYPE_USER_ALIGN): Likewise.
	(CLASSTYPE_AS_BASE): New macro.
	(DECL_INITIALIZED_P): Likewise.
	(extract_init): Remove prototype.
	(build_forced_zero_init): Rename to ...
	(build_zero_init): ... this.
	(force_store_init_value): Remove.
	* decl.c (obscure_complex_init): Remove.
	(duplicate_decls): Copy DECL_INITIALIZED_P.
	(check_initializer): Do not leave junk in DECL_INITIAL.
	(cp_finish_decl): Handle zero-initialization of entities with
	static storage duration.
	* expr.c (extract_init): Remove.
	* init.c (build_forced_zero_init): Remove.
	(build_zero_init): New function.
	(build_default_init): Use it.
	(build_field_list): Skip FIELD_DECLs for base subobjects.
	(push_base_cleanups): Likewise.
	* method.c (do_build_assign_ref): Likewise.
	(synthesize_exception_spec): Likewise.
	* pt.c (tsubst_decl): Clear DECL_INITIALIZED_P.
	(regenerate_decl_from_template): To not set DECL_INITIAL for a
	static data member whose initialization took place in its class.
	(instantiate_decl): Do not pass an initializer to cp_finish_decl
	in that situation.
	* search.c (dfs_push_decls): Skip FIELD_DECLs for base subobjects.
	(dfs_unuse_fields): Likewise.
	* tree.c (pod_type_p): Handle error_mark_node.
	(zero_init_p): Likewise.
	* typeck.c (lookup_anon_field): Skip FIELD_DECLs for base
	subobjects.
	* typeck2.c (store_init_value): Remove #if 0'd code.
	(force_store_init_value): Remove.
	(process_init_constructor): Use build_zero_init.

2002-09-29  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7788
	* rtti.c (unemitted_tinfo_decl_p): Check it has a field.

2002-09-29  Kazu Hirata  <kazu@cs.umass.edu>

	* cp-tree.h: Fix comment typos.
	* decl.c: Likewise.
	* pt.c: Likewise.

2002-09-25  Mark Mitchell  <mark@codesourcery.com>

	* cp/class.c (contains_empty_class_p): New method.
	(walk_subobject_offsets): Correct computation of field offset.
	(layout_empty_base): Correct placement of emtpy base classes.
	(layout_class_type): Warn about ABI changes.

2002-09-23  Mark Mitchell  <mark@codesourcery.com>

	* cp/class.c (layout_virtual_bases): Do not round the size of the
	type to a multiple of the alignment before laying out virtual bases.
	(layout_class_type): Correct handling of bit-fields that are wider
	than their type inside unions.  Round the size of the type to a
	even number of bytes when computing the size without virtual
	bases.
	* cp/cp-tree.h (abi_version_at_least): New macro.

2002-09-21  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* ChangeLog.2: Likewise.
	* call.c: Likewise.
	* class.c: Likewise.
	* cp-tree.h: Likewise.
	* cvt.c: Likewise.
	* decl.c: Likewise.
	* decl2.c: Likewise.
	* except.c: Likewise.
	* friend.c: Likewise.
	* g++spec.c: Likewise.
	* init.c: Likewise.
	* lex.c: Likewise.
	* mangle.c: Likewise.
	* method.c: Likewise.
	* operators.def: Likewise.
	* optimize.c: Likewise.
	* pt.c: Likewise.
	* rtti.c: Likewise.
	* search.c: Likewise.
	* semantics.c: Likewise.
	* spew.c: Likewise.
	* tree.c: Likewise.
	* typeck.c: Likewise.

2002-09-18  Devang Patel  <dpatel@apple.com>

	* cp/cp-tree.h: New prototype for walk_vtabls().
	* cp/decl.c (walk_vtables_r): New function.
	(struct cp_binding_level): Add new members, namespaces,
	names_size and vtables.
	(add_decl_to_level): Add decl in namespaces or vtables
	chain, if conditions match.
	(walk_vtables): New function.
	(walk_namespaces_r): Travers separate namespace chain
	for namespace decls.
	(wrapup_globals_for_namespace): Use names_size instead
	of list_length().
	* cp/decl2.c (finish_file): Use walk_vtables() instead of
	walk_globals() to walk vtable decls.

2002-09-18  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (grokdeclarator): Use assert, not internal_error. Don't
	ICE with invalid pointers & references.

2002-09-17  Zack Weinberg  <zack@codesourcery.com>

	* Make-lang.in: Remove all references to the demangler.
	* cxxfilt.c: Moved to binutils.

2002-09-16  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7718
	* pt.c (tsubst_decl): Remove assert.

	Remove DR 295 implementation.
	* pt.c (check_cv_quals_for_unify): Disable function & method cases.
	* tree.c (cp_build_qualified_type_real): Likewise. Don't warn
	about ignoring volatile qualifiers.

	* search.c (lookup_member): Correct documentation.

2002-09-16  Geoffrey Keating  <geoffk@apple.com>

	* cp-tree.h (union lang_tree_node): Add chain_next option.

2002-09-16  Nathan Sidwell  <nathan@codesourcery.com>

	* parse.y (parse_finish_call_expr): Check lookup_member result.

	PR c++/7015
	* semantic.c (finish_asm_stmt): Fix operand/output_operands
	thinko.
	* typeck.c (c_expand_asm_operands): Protect from error_mark_node.

2002-09-15  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7919
	* call.c (build_over_call): Convert this pointer for fns found by
	using decls.

2002-09-15  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* ChangeLog.1: Likewise.

2002-09-14  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7768
	* pt.c (build_template_decl): Copy DECL_DESTRUCTOR_P.

2002-09-14  Kazu Hirata  <kazu@cs.umass.edu>

	* error.c: Fix comment formatting.
	* except.c: Likewise.
	* expr.c: Likewise.
	* friend.c: Likewise.
	* g++spec.c: Likewise.
	* init.c: Likewise.
	* lex.c: Likewise.
	* mangle.c: Likewise.
	* method.c: Likewise.
	* optimize.c: Likewise.
	* pt.c: Likewise.
	* rtti.c: Likewise.
	* search.c: Likewise.
	* semantics.c: Likewise.
	* spew.c: Likewise.
	* tree.c: Likewise.
	* typeck.c: Likewise.
	* typeck2.c: Likewise.

2002-09-13  Matt Austern  <austern@apple.com>

	PR C++/7828
	* cp/cp-tree.h, cp/tree.c: New function non_cast_lvalue_p.
	* cp/call.c: Change call-by-const-reference mechanism to use
	non_cast_lvalue_p when deciding whether the create a temporary.
	We need a temporary when passing, e.g. (long) x by const ref.

2002-09-13  Nathan Sidwell  <nathan@codesourcery.com>

	* pt.c (unify, ARRAY_TYPE): Element type can be more qualified.

2002-09-13  Kazu Hirata  <kazu@cs.umass.edu>

	* decl.c: Fix comment formatting.
	* decl2.c: Likewise.

2002-09-12  Kazu Hirata  <kazu@cs.umass.edu>

	* call.c: Fix comment formatting.
	* class.c: Likewise.
	* cp-lang.c: Likewise.
	* cp-tree.h: Likewise.
	* cvt.c: Likewise.

2002-09-11  Zack Weinberg  <zack@codesourcery.com>

	* Make-lang.in: Build cp/cxxfilt.o from $(srcdir)/cp/cxxfilt.c,
	and c++filt from cxxfilt.o + version.o + $(LIBDEPS).
	* cxxfilt.c: New file: split from libiberty/cplus-dem.c, with
	minor adjustments (use version_string, eliminate yet another
	duplicate of xmalloc)

2002-09-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cp-tree.h (require_complete_eh_spec_types): Add prototype.

2002-09-05  Jason Merrill  <jason@redhat.com>

	* typeck2.c (add_exception_specifier): Only pedwarn for an
	incomplete type.
	(require_complete_eh_spec_types): New fn.
	(cxx_incomplete_type_diagnostic): Also support pedwarning.
	* typeck.c (complete_type_or_diagnostic): Likewise.
	* call.c (build_call): Call require_complete_eh_spec_types.
	* rtti.c (get_pseudo_ti_desc): Give an error rather than aborting
	on an incomplete type.

2002-09-04  Jakub Jelinek  <jakub@redhat.com>

	* decl.c (start_cleanup_fn): Clear interface_only before
	start_function, restore it afterwards.

2002-09-02  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (finish_builtin_type): Remove.
	* decl2.c (finish_builtin_type): Move to common code.
	* decl.c (build_ptrmemfunc_type): Adjust.
	* rtti.c (create_pseudo_type_info): Adjust.
	(create_tinfo_types): Adjust.

2002-08-31  Jason Merrill  <jason@redhat.com>

	* cp-lang.c (cp_expr_size): Allow initialization from a
	CONSTRUCTOR.

2002-08-30  Richard Henderson  <rth@redhat.com>

	PR opt/7515
	* tree.c: Include target.h.
	(cp_cannot_inline_tree_fn): Don't auto-inline functions that
	don't bind locally.
	* Makefile.in (tree.o): Update.

2002-08-27  Mark Mitchell  <mark@codesourcery.com>

	* class.c (layout_virtual_bases): Warn about bugs in G++ that
	result in incorrect object layouts.
	(layout_class_type): Likewise.

2002-08-24  Matt Austern  <austern@apple.com>

	* tree.c (lvalue_p_1): Add argument for whether casts of lvalues
	are allowable.
	(real_lvalue_p): Update caller.
	(lvalue_p): Ditto.
	(non_cast_lvalue_or_else): New.
	* tree.h: Declare it.
	* typeck.c (build_unary_op): Use non_cast_lvalue_or_else.

2002-08-22  Mark Mitchell  <mark@codesourcery.com>

	* typeck.c (build_class_member_access_expr): Handle COMPOUND_EXPR
	and COND_EXPR specially; fix error message output.

2002-08-22  Jason Merrill  <jason@redhat.com>

	* pt.c (tsubst_expr): RETURN_EXPR is now RETURN_STMT_EXPR.
	* semantics.c (nullify_returns_r): Likewise.

2002-08-17  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	Fix PR/7621
	* typeck.c (finish_class_member_access_expr): Diagnose cases where
	name lookup finds nothing.

2002-08-15  Jason Merrill  <jason@redhat.com>

	* semantics.c (finish_then_clause): Remove redundant assignment.
	(finish_if_stmt, begin_switch_stmt, finish_switch_stmt): Move the
	extra binding level outside the if/switch statement.
	(finish_while_cond, finish_for_cond): Rewrite complex condition
	into the loop body.

2002-08-15  Alexandre Oliva  <aoliva@redhat.com>

	* parse.y (sizeof, alignof, typeof): New non-terminals to
	increment skip_evaluation.  Replace terminals with them and
	decrement skip_evaluation at the end of rules using them.
	* decl2.c (mark_used): Don't assemble_external if
	skipping evaluation.

2002-08-15  Gabriel Dos Reis  <gdr@nerim.net>

	Fix PR/7504
	* parse.y (parse_finish_call_expr): Handle incomplete
	type used to name a scope.

2002-08-15  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7598
	* typeck.c (build_unary_op): Fold offsetof idiom. Fixes
	regression caused by my 2002-08-08 patch.

2002-08-13  Mark Mitchell  <mark@codesourcery.com>

	* decl.c (pushdecl_class_level): Honor requests to bind names to
	OVERLOADs.

2002-08-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl2.c (build_call_from_tree): Fix uninitialized variable.
	* parse.y (parse_finish_call_expr): Likewise.
	* repo.c (old_args, old_dir, old_main): Const-ify.

2002-08-11  Gabriel Dos Reis  <gdr@nerim.net>

	* decl.c (duplicate_decls): Replace DECL_SOURCE_FILE
	DECL_SOURCE_LINE with DECL_SOURCE_LOCATION.
	* optimize.c (maybe_clone_body): Likewise.
	* pt.c (tsubst_enum): Likewise.
	(lookup_template_class): Likewise.
	* tree.c (cp_copy_res_decl_for_inlining): Likewise.

2002-08-10  Neil Booth  <neil@daikokuya.co.uk>

	* lang-specs.h: Remove -ansi.

2002-08-10  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.c (maybe_dummy_object): Replace // with /* */

2002-08-09  Mark Mitchell  <mark@codesourcery.com>

	* call.c (standard_conversion): Use build_ptrmem_type.
	* cp-tree.h (build_ptrmem_type): New function.
	(adjust_result_of_qualified_name_lookup): Likewise.
	* decl.c (grokvardecl): Do not look for OFFSET_TYPEs to indicate
	static data members.
	(build_ptrmem_type): New function.
	(grokdeclarator): Do not use build_offset_type when encountering a
	qualified name.
	* parse.y (parse_finish_call_expr): Use
	adjust_result_of_qualified_name_lookup.
	* search.c (adjust_result_of_qualified_name_lookup): New function.
	* typeck.c (qualify_type_recursive): Use TYPE_PTRMEM_* rather than
	accessing OFFSET_TYPEs directly.

2002-08-08  Mike Stump  <mrs@apple.com>

	* call.c (add_builtin_candidate): legal -> valid, illegal -> invalid.
	(type_decays_to): Likewise.
	* class.c (find_final_overrider): Likewise.
	(maybe_note_name_used_in_class): Likewise.
	* decl.c (current_tmpl_spec_kind): Likewise.
	(add_binding): Likewise.
	(push_class_binding): Likewise.
	(duplicate_decls): Likewise.
	(layout_var_decl): Likewise.
	(grokfndecl): Likewise.
	(grokdeclarator): Likewise.
	(check_default_argument): Likewise.
	* decl2.c (handle_class_head): Likewise.
	* error.c (dump_template_decl): Likewise.
	* init.c (build_offset_ref): Likewise.
	* pt.c (check_specialization_scope): Likewise.
	(determine_specialization): Likewise.
	(check_explicit_specialization): Likewise.
	(maybe_check_template_type): Likewise.
	(process_partial_specialization): Likewise.
	(check_default_tmpl_args): Likewise.
	(push_template_decl_real): Likewise.
	(convert_template_argument): Likewise.
	(try_class_unification): Likewise.
	(get_bindings_real): Likewise.
	(do_decl_instantiation): Likewise.
	* semantics.c (begin_function_definition): Likewise.
	(finish_member_declaration): Likewise.
	(check_multiple_declarators): Likewise.
	* typeck.c (comp_array_types): Likewise.
	(comptypes): Likewise.
	(expr_sizeof): Likewise.
	(build_binary_op): Likewise.
	(dubious_conversion_warnings): Likewise.
	(check_return_expr): Likewise.

2002-08-08  Mark Mitchell  <mark@codesourcery.com>

	* typeck.c (build_class_member_access_expr): Do not return
	error_mark_node when no error has occurred.

2002-08-08  Nathan Sidwell  <nathan@codesourcery.com>

	* typeck.c (build_component_addr): Remove.
	(build_unary_op): Just check it's not a bitfield, and then build
	an ADDR_EXPR.

2002-08-08  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (convert_to_base): Correct check for error_mark_node.
	(create_vtable_ptr): Remove unused VFUNS_P parm.

2002-08-08  Nathan Sidwell  <nathan@codesourcery.com>

	* cp/Make-lang.in (c++.mostlyclean): Remove coverage files.

2002-08-07  Mark Mitchell  <mark@codesourcery.com>

	Rework build_component_ref.
	* call.c (build_vfield_ref): Do not go through build_component_ref.
	(build_field_call): Use build_class_member_access_expr.
	(build_user_type_conversion_1): Use BASELINK_FUNCTIONS.
	(build_object_call): Likewise.
	* class.c (convert_to_base): New function.
	(type_requires_array_cookie): Use BASELINK_FUNCTIONS.
	(instantiate_type): Handle BASELINKs.
	* cp-tree.def (BASELINK): New tree code.
	* cp-tree.h (BASELINK_P): Reimplement.
	(SET_BASELINK_P): Remove.
	(BASELINK_BINFO): Reimplement.
	(BASELINK_FUNCTIONS): Likewise.
	(BASELINK_ACCESS_BINFO): Likewise.
	(BASELINK_OPTYPE): Likewise.
	(convert_to_base): New function.
	(name_p): Likewise.
	(build_object_ref): Remove.
	(build_component_ref_1): Likewise.
	(build_component_ref): Likewise.
	(build_x_component_ref): Likewise.
	(build_class_member_access_expr): New function.
	(finish_class_member_access_expr): Likewise.
	(build_ptrmemfunc_access_expr): Likewise.
	* decl.c (grokdeclarator): Handle BASELINKs.
	* decl2. (build_expr_from_tree): Handle COMPONENT_REFs by using
	finish_class_member_access_expr.
	(arg_assoc): Handle BASELINKs.
	(do_class_using_decl): Likewise.
	* error.c (dump_decl): Likewise.
	(dump_expr): Use build_ptrmemfunc_access_expr.
	* except.c (dtor_nothrow): Use CLASSTYPE_DESTRUCTORS to find
	destructors.
	(build_throw): Use BASELINK_FUNCTIONS.
	* init.c (perform_member_init): Use
	build_class_member_access_expr.
	(build_offset_ref): Handle BASELINKs.  Use
	build_class_member_access_expr.
	* method.c (hack_identifier): Likewise.
	* parse.y (do_id): Use BASELINK, not TREE_LIST.
	(primary): Remove uses of build_object_ref.
	* pt.c (lookup_template_function): Handle BASELINKs.
	(resolve_overloaded_unification): Likewise.
	* search.c (build_baselink): Build a BASELINK, not a TREE_LIST.
	(lookup_field): Use BASELINK, not TREE_LIST.
	(lookup_fnfiels): Likewise.
	(setup_class_bindings): Likewise.
	* semantics.c (finish_object_call_expr): Do not use
	build_method_call when we already know what function is being
	called.
	* spew.c (identifier_type): Use BASELINK, not TREE_LIST.
	* tree.c (really_overloaded_fn): Use OVL_CHAIN for OVERLOADs, not
	TREE_CHAIN.
	(name_p): New function.
	* typeck.c (build_object_ref): Remove.
	(build_component_ref_1): Likewise.
	(build_x_component_ref): Likewise.
	(build_class_member_access_expr): New function.
	(finish_class_member_access_expr): Likewise.
	(build_ptrmemfunc_access_expr): Likewise.
	(get_member_function_from_ptrfunc): Use
	build_ptrmemfunc_access_expr.
	(build_binary_op): Likewise.
	(build_unary_op): Likewise.
	(build_ptrmemfunc): Likewise.
	(pfn_from_ptrmemfunc): Likewise.
	* typeck2.c (build_m_component_ref): Adjust comment.

2002-08-07  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in (CXX_C_OBJS): Update.
	* cp-lang.c (LANG_HOOKS_DECODE_OPTION): Use c_common_decode_option.
	* cp-tree.h (cxx_decode_option): Remove.
	* decl2.c (compare_options, lang_f_options, unsupported_options,
	cxx_decode_option): Remove.

2002-08-06  Gabriel Dos Reis  <gdr@nerim.net>

	* typeck.c (build_x_unary_op): Handle pointer-to-member.

2002-08-05  Geoffrey Keating  <geoffk@redhat.com>

	* class.c: Don't include obstack.h.
	(popclass):
	* decl2.c: Delete bogus comment.
	* error.c: Don't include obstack.h.
	* except.c: Likewise.
	(dump_type): Correct comment.
	* method.c: Don't include obstack.h.
	* tree.c: Likewise.

2002-08-04  Gabriel Dos Reis  <gdr@nerim.net>

	Fix PR/2213
	* cvt.c (cp_convert_to_pointer): Reject conversions from integral
	expressions to pointer-to-data-member of pointer-to-member-functions.

2002-08-04  Geoffrey Keating  <geoffk@redhat.com>

	* cvt.c (ocp_convert): Delete obsolete code.
	* parse.y (permanent_obstack): Delete declaration.
	* pt.c (permanent_obstack): Delete declaration.
	* repo.c (permanent_obstack): Delete declaration.
	(open_repo_file): Use xmalloc instead of permanent_obstack.
	(init_repo): Use xstrdup instead of permanent_obstack.

2002-08-04  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (VF_DERIVED_VALUE): Remove.
	* class.c (finish_struct_1): Use VF_BINFO_VALUE not VF_DERIVED_VALUE.

2002-08-03  Nathan Sidwell  <nathan@codesourcery.com>

	PR 7470.
	C++ ABI change - vfunc ordering.
	* class.c (add_virtual_function): Remove.
	(dfs_modify_all_vtables): Take list of all declared
	virtuals. Assign all that are not in primary base.
	(check_for_override): Adjust comments.
	(create_vtable_ptr): Take single list of virtuals. Build chain
	of declared virtuals here.
	(layout_class_type): Take single list of virtuals. Adjust.
	(finish_struct_1): Keep virtuals on single list. Adjust.

2002-08-02  Mark Mitchell  <mark@codesourcery.com>

	* init.c (build_member_call): Use build_new_method_call, not
	build_method_call.

2002-08-02  Krister Walfridsson  <cato@df.lth.se>

	* Make-lang.in (spew.o, lex.o, pt.o): Add path to parse.h dependencies.

2002-08-02  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_method_call): Issue a more helpful error message
	about ambiguous method names.

2002-08-02  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.c (build_shared_int_cst): Make cache file scope, and
	GTY it.

2002-08-02  Jason Merrill  <jason@redhat.com>

	* cp-lang.c (LANG_HOOKS_EXPR_SIZE): Define.
	(cp_expr_size): New fn.
	* call.c (build_over_call): Lose empty class hackery.
	(convert_arg_to_ellipsis): Promote non-POD warning to error.
	* typeck.c (build_modify_expr): Don't use save_expr on an lvalue.

	* semantics.c (expand_body): Do tree optimization in the function
	context, too.

2002-08-01  Neil Booth  <neil@daikokuya.co.uk>

	* cp-tree.h: Move all warning and flag declarations to c-common.h.
	* decl.c: Move all warning and flag variables to c-common.c.
	* decl2.c: Move all warning and flag variables to c-common.c.
	* lex.c (flag_digraphs): Remove.
	(warn_traditional): Now in c-common.c.

2002-07-31  Mark Mitchell  <mark@codesourcery.com>

	* call.c (build_field_call): Do not look up the field by name.
	(build_method_call): Simplify.
	(struct z_candidate): Add access_path and conversion_path.  Remove
	basetype_path.
	(convert_class_to_reference): Adjust use of
	add_function_candidate.
	(add_candidate): Add conversion_path argument.
	(add_function_candidate): Use it.
	(add_conv_dndidate): Likewise.
	(build_builtin_candidate): Likewise.
	(add_template_candidate_real): Add conversion_path argument.
	(add_template_conv_candidate): Likewise.
	(add_template_candidate): Likewise.
	(build_user_type_conversion_1): Use it.
	(build_new_function_call): Remove name lookup code.  Adjust use of
	add_template_candidate and add_function_candidate.
	(build_new_op): Likewise.
	(convert_like_real): Use build_special_member_call.
	(build_over_call): Use cand->conversion_path.
	(build_special_member_call): New method.
	(build_new_method_call): Remove name lookup code.
	* cp-tree.def (OFFSET_REF): Update documentation.
	(TEMPLATE_ID_EXPR): Likewise.
	* cp-tree.h (BASELINK_ACCESS_BINFO): New macro.
	(BASELINK_OPTYPE): Likewise.
	(build_new_method_call): Adjust prototype.
	(build_special_member_call): New method.
	(build_baselink): New method.
	(build_offset_ref_call_from_tree): Likewise.
	(build_call_from_tree): Likewise.
	(finish_qualified_call_expr): Remove.
	(finish_call_expr): Adjust prototype.
	(build_x_function_call): Remove.
	* cvt.c (ocp_convert): Use build_special_member_call.
	* decl2.c (reparse_absdcl_as_expr): Use finish_call_expr.
	(build_expr_from_tree): Adjust handling for TEMPLATE_ID_EXPR and
	CALL_EXPR.
	(build_offset_ref_call_from_tree): New function.
	(build_call_from_tree): Likewise.
	* init.c (expand_cleanup): Use build_special_member_call.
	(expand_default_init): Likewise.
	(build_member_call): Use finish_call_expr.
	(build_new_1): Use build_special_member_call.
	(push_base_cleanups): Likewise.
	* method.c (do_build_assign_ref): Likewise.
	* parse.y (template_id): Do not pass a COMPONENT_REF to
	lookup_template_function.
	(primary): Use parse_finish_call_epxr, not finish_call_expr.
	(parse_finish_call_expr): New function.
	* pt.c (lookup_template_function): Add assertions.
	* search.c (lookup_base): Allow T to be a binfo.
	(build_baselink): New function.
	(lookup_member): Use it.
	* semantics.c (finish_call_expr): Do not do name lookup.
	(finish_object_call_expr): Remove #if 0'd code.
	(finish_qualified_call_expr): Remove.
	* typeck.c (build_x_function_call): Remove.
	(build_static_case): Use build_special_member_call.
	* typeck2.c (build_functional_cast): Likewise.

2002-07-30  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* lang-specs.h: Remove __GXX_ABI_VERSION, moved to gcc.c.

2002-07-30  Gabriel Dos Reis  <gdr@nerim.net>

	* cp-tree.h (VF_DERIVED_VALUE): Restore from previous deletion.

2002-07-30  Nathan Sidwell  <nathan@codesourcery.com>

	* cp-tree.h (CLASSTYPE_VFIELDS, VF_*, BV_*): Add more
	documentation.

2002-07-29  Alan Modra  <amodra@bigpond.net.au>

	* cp-tree.h: Comment typo fix.

2002-07-29  Richard Earnshaw  <rearnsha@arm.com>

	* spew.c (space_for_token): Allocate zeroed memory for a new token
	chunk.

2002-07-27  Roger Sayle  <roger@eyesopen.com>

	* decl.c (builtin_function_1): No need to explicitly mark
	BUILT_IN_RETURN and BUILT_IN_EH_RETURN as noreturn.

2002-07-27  Roger Sayle  <roger@eyesopen.com>

	* decl2.c (cxx_decode_option): Support -fno-builtin-foo.

2002-07-26  Jason Merrill  <jason@redhat.com>

	* call.c (build_over_call): Likewise.
	(cp_convert_parm_for_inlining): New fn.
	(convert_for_arg_passing): New fn.
	(convert_default_arg, build_over_call): Use it.
	(type_passed_as): New fn.
	* pt.c (tsubst_decl): Use it.
	* decl2.c (cp_build_parm_decl): New fn.
	(build_artificial_parm): Use it.
	(start_static_storage_duration_function): Likewise.
	* decl.c (start_cleanup_fn, grokdeclarater): Likewise.
	(grokparms): Don't mess with DECL_ARG_TYPE.
	* typeck.c (convert_arguments): Use convert_for_arg_passing.
	* cp-lang.c (LANG_HOOKS_TREE_INLINING_CONVERT_PARM_FOR_INLINING):
	Define.
	* cp-tree.h: Declare new fns.

2002-07-26  Neil Booth  <neil@daikokuya.co.uk>

	* cp-tree.h (flag_operator_names): Remove.
	* decl2.c (flag_operator_names): Remove.
	(lang_f_options): Remove operator-names.
	* lex.c (D_OPNAME): Remove.
	(reswords): Remove operator names.
	(rid_to_yy): Remove operator names.
	(init_reswords): No need to handle D_OPNAME.
	* spew.c (read_process_identifier): There are no operator
	names.

2002-07-26  Jason Merrill  <jason@redhat.com>

	* dump.c (cp_dump_tree): Call c_dump_tree.
	* Make-lang.in (CXX_C_OBJS): Add c-dump.o.

2002-07-25  Neil Booth  <neil@daikokuya.co.uk>

	* error.c (print_whitespace): Remove.
	* g++spec.c (LIBUNWIND): Move.
	* mangle.c (mangled_position, write_signed_number): Remove.

2002-07-25  Neil Booth  <neil@daikokuya.co.uk>

	* decl2.c (cxx_decode_option): Similarly.

2002-07-25  Gabriel Dos Reis  <gdr@nerim.net>

	* cp-tree.h (cxx_sizeof_nowarn): Now a macro.
	(cxx_sizeof_or_alignof_type): Take a third argument.
	(cxx_sizeof): Adjust definition.
	(cxx_alignof): Likewise.
	* init.c (build_delete): Use cxx_sizeof_nowarn to reflect reality.
	* typeck.c (cxx_sizeof_or_alignof_type): Take a third argument for
	complaining.
	(c_sizeof_nowarn): Remove definition.
	(build_unary_op): Use cxx_sizeof_nowarn.

2002-07-24  Geoffrey Keating  <geoffk@redhat.com>

	* tree.c (cp_build_qualified_type_real): When copying
	pointer-to-method types, unshare the record that holds
	the cached pointer-to-member-function type.

2002-07-23  Neil Booth  <neil@daikokuya.co.uk>

	* cp-tree.h (FILE_FUNCTION_PREFIX_LEN): Remove.

2002-07-23  Gabriel Dos Reis  <gdr@nerim.net>

	Fix PR/7363:
	* typeck.c (cxx_sizeof_or_alignof_type): New function.
	(c_sizeof): Remove definition.
	(expr_sizeof): Use cxx_sizeof.
	* decl2.c (build_expr_from_tree): Use cxx_sizeof_or_alignof_type.
	* decl.c (finish_destructor_body): Use cxx_sizeof.
	* semantics.c (finish_alignof): Likewise.
	(finish_alignof): Use cxx_alignof.
	* cp-tree.h (cxx_sizeof, cxx_alignof): New macros.
	(cxx_sizeof_or_alignof_type): Declare.
	(my_friendly_assert): Move to ../c-common.h.

2002-07-23  Neil Booth  <neil@daikokuya.co.uk>

	* class.c, method.c, pt.c, search.c: Don't define obstack macros.

2002-07-22  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/7347, c++/7348
	* cp-tree.h (tsubst_flags_t): Add tf_parsing.
	* decl.c (make_typename_type): Use it.
	(make_unbound_class_template): Likewise.
	(lookup_name_real): Don't call type_access_control if scope is
	template parameter dependent.
	* parse.y (template_arg): Call make_unbound_class_template with
	tf_parsing set.
	(nest_name_specifier): Call make_typename_type with tf_parsing set.
	(typename_sub0): Likewise.
	(typename_sub1): Likewise.
	(instantiate_decl): Push class scope.
	* pt.c (regenerate_decl_from_template): Call pushclass and popclass
	for both static variable and member function template.
	(instantiate_decl) Call pushclass and popclass when tsubst'ing type
	and arguments.
	* search.c (type_access_control): Do type access for TEMPLATE_DECL
	too.

2002-07-20  Roger Sayle  <roger@eyesopen.com>

	* decl2.c (cxx_decode_option): Simplify -fhandle-exceptions
	test by using positive_option.  Make whitespace consistent.

2002-07-20  Gabriel Dos Reis  <gdr@nerim.net>

	* spew.c (struct unparsed_test): Replace 'filename' and 'lineno'
	members with 'locus'.  Adjust use throughout.
	(struct feed):  Likewise.
	(alloc_unparsed_test): Change prototype, take a 'const location_t *'.
	Adjust use.
	(snarf_defarg): Use error(), not error_with_file_and_line().

2002-07-19  Chris Demetriou  <cgd@broadcom.com>

	* lang-specs.h (@c++): Include "%2" (cc1plus_spec) wherever
	cpp_options is included.

2002-07-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/2862, c++/2863
	* pt.c (determine_specialization): Compare the length of
	TYPE_ARG_TYPES.  Tidy.

2002-07-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/3797
	* decl.c (duplicate_decls): Don't propagate inlining parameters from
	olddecl to newdecl when newdecl is a specialization of the
	instantiation olddecl.

2002-07-17  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>

	PR c++/4802, c++/5387
	* decl.c (make_typename_type): Use enforce_access.

2002-07-17  Scott Snyder <snyder@fnal.gov>

	PR c++/7320
	* rtti.c (get_tinfo_decl): Set DECL_COMDAT.

2002-07-12  Mark Mitchell  <mark@codesourcery.com>

	* class.c (add_method): Correct handling of conversion operators.

2002-07-11  Mark Mitchell  <mark@codesourcery.com>

	PR c++/7224
	* class.c (add_method): Simplify.

2002-07-11  Jason Merrill  <jason@redhat.com>

	PR c++/7279
	* tree.c (cp_copy_res_decl_for_inlining): Also copy
	TREE_ADDRESSABLE.

2002-07-10  Graham Stott  <graham.stott@btinternet.com>

	* pt.c (template_parm_this_level_p, push_template_decl_real):
	Pass depth as int pointer.

2002-07-11  Tim Josling  <tej@melbpc.org.au>

	Remove front end hard coding from gengtype.c.

	* config-lang.in (gtfiles): Add files needed for this front end.

2002-07-10  Mark Mitchell  <mark@codesourcery.com>

	* cp-tree.h (unqualified_name_lookup_error): Declare it.
	(begin_function_definition): Adjust prototype.
	* lex.c (unqualified_name_lookup_error): New function, split out
	from ...
	(do_identifier): ... here.
	* parse.y (parse_begin_function_definition): New function.
	(fn.def1): Use it.
	* semantics.c (begin_function_definition): Accept decl-specifiers
	and attributes as separate parameters.

2002-07-10  Jason Merrill  <jason@redhat.com>

	PR c++/6255
